var ccc=0;
var PointTip=cc.Class.extend({
    shape:0,
    angle:0,
    position:null,
    ctor:function (s,a,p) {
        this.shape=s;
        this.angle=a;
        this.position=p;
    },

    clone:function () {
        var newpt=new PointTip();
        newpt.shape=this.shape;
        newpt.angle=this.angle;
        newpt.position=cc.p(0,0);
        newpt.position.x=this.position.x;
        newpt.position.y=this.position.y;
        return newpt;
    },

    isEqual:function (ptip) {
        if(this.shape==ptip.shape&&this.angle==ptip.angle&&this.position.x==ptip.position.x&&this.position.y==ptip.position.y)
            return true;
        return false;
    },
});

var BoxMovePath=cc.Class.extend({
    FrontTip:null,
    NowTip:null,
    step:0,
    ctor:function (a,b,c) {
        this.FrontTip=a;
        this.NowTip=b;
        this.step=c;
    },


    isEqual:function (bmp) {
        if(this.FrontTip.isEqual(bmp.FrontTip)&&this.NowTip.isEqual(bmp.NowTip)&&this.step==bmp.step)
            return true;
        return false;
    },
});

var BoxMoveResult=cc.Class.extend({
    result:false,
    newTip:null,
    ctor:function (re,nt) {
        this.result=re;
        this.newTip=nt.clone();
    },
});

var PointManage=cc.Class.extend({
    _canGet:false,
    _BoxMoveVec:[],
    _BoxPathVec:[],
    _beginTip:null,
    _endTip:null,
    _chessfillinfo:[],
    _theTopTipVec:[],
    _theTopStep:0,
    _theTopTip:0,
    _toph:[],
    ctor:function () {
    },

    pathAToB:function (begintip,endtip,chessinfo) {
        ccc=0;
        this.dataInit(begintip,endtip,chessinfo);
        this.dataProcess();
        return this;
    },

    dataInit:function (begintip,endtip,chessinfo) {
        this._canGet=false;
        this._BoxMoveVec=[];
        this._beginTip=begintip;
        this._endTip=endtip;
        for(var i=0;i<FANGK_WIDTH;i++){
            for(var j=0;j<FANGK_HEIGHT;j++){
                this._chessfillinfo[i*FANGK_HEIGHT+j]=chessinfo[i*FANGK_HEIGHT+j];
            }
        }
        this._theTopTipVec=[];
        this._theTopStep=9999;
        for(var i=0;i<FANGK_WIDTH;i++){
            this._toph[i]=-1;
            for(var j=(FANGK_HEIGHT-1);j>0;j--){
                if(this._chessfillinfo[i*FANGK_HEIGHT+j]){
                    this._toph[i]=j;
                    break;
                }
            }
        }

    },

    dataProcess:function () {
        this._BoxPathVec=[];
        this._BoxPathVec.push(new BoxMovePath(this._endTip,this._endTip,0));
        this.boxMoveProcessOne(this._endTip,1);
        if(this.topData()){
            this.getPathByVecOne();
            this._canGet=true;
        }
    },

    getPathByVecOne:function () {
        var tempvec=[];
        tempvec.push(this._theTopTip);
        var lasttip=new PointTip(this._theTopTip.shape,this._theTopTip.angle,this._theTopTip.position);
        var laststep=this._theTopStep;
        var loop=true;
        do{
            loop=true;
            for(var i in this._BoxPathVec){
                var key=this._BoxPathVec[i];
                if(key.NowTip.isEqual(lasttip)&&key.step==laststep){
                    lasttip=key.FrontTip.clone();
                    laststep--;
                    tempvec.push(key.FrontTip);
                    if(lasttip.isEqual(this._endTip)){
                        loop=false;
                    }
                    break;
                }
                if(key.isEqual(this._BoxPathVec[this._BoxPathVec.length-1])){
                    tempvec=[];
                    loop=false;
                    break;
                }
            }
        }while(loop);

        if(tempvec.length>0){
            for(var i=tempvec.length-1;i>=0;i--){
                this._BoxMoveVec.push(tempvec[i]);
            }
        }
    },

    topData:function () {
        if(this._theTopTipVec.length==0)
            return false;
        else{
            for(var i in this._theTopTipVec){
                if(this._theTopTipVec[i].first<this._theTopStep){
                    this._theTopStep=this._theTopTipVec[i].first;
                    this._theTopTip=this._theTopTipVec[i].second;
                }
            }
            return true;
        }
    },

    boxMoveProcessOne:function (recenttip,step) {
        ccc++;
        if(ccc>20){
            cc.log("ccc>20");
            return true;
        }else{
            cc.log("ccc="+ccc);
        }
        var newstep=step+1;
        //向左
        var res=this.BoxMove(recenttip,cc.p(-1,0));
        if(res.result&&!this.BoxPathVecJudge(recenttip,res.newTip,step)){
            this._BoxPathVec.push(new BoxMovePath(recenttip,res.newTip,step));
            if(this.isTheTop(res.newTip)){
                this._theTopTipVec.push({first:step,second:res.newTip});
                return true;
            }else{
                if(this.boxMoveProcessOne(res.newTip,newstep))
                    return true;
            }
        }

        //向右
        res=this.BoxMove(recenttip,cc.p(1,0));
        if(res.result&&!this.BoxPathVecJudge(recenttip,res.newTip,step)){
            this._BoxPathVec.push(new BoxMovePath(recenttip,res.newTip,step));
            if(this.isTheTop(res.newTip)){
                this._theTopTipVec.push({first:step,second:res.newTip});
                return true;
            }else{
                if(this.boxMoveProcessOne(res.newTip,newstep))
                    return true;
            }
        }

        //向上
        res=this.BoxMove(recenttip,cc.p(0,1));
        if(res.result&&!this.BoxPathVecJudge(recenttip,res.newTip,step)){
            this._BoxPathVec.push(new BoxMovePath(recenttip,res.newTip,step));
            if(this.boxMoveProcessOne(res.newTip,newstep))
                return true;
        }

        if(this._beginTip.shape!=ShapeIndex.SQUARE_SHAPE&&this._beginTip.shape!=ShapeIndex.POINT_SHAPE)
        {
            //逆时针旋转
            res=this.ReBoxRotate(recenttip,3);
            if(res.result&&!this.BoxPathVecJudge(recenttip,res.newTip,step)&&res.newTip.shape!=ShapeIndex.SQUARE_SHAPE)
            {
                this._BoxPathVec.push(new BoxMovePath(recenttip,res.newTip,step));
                if(this.isTheTop(res.newTip))
                {
                    this._theTopTipVec.push({first:step,second:res.newTip});
                    return true;
                }
                else
                {
                    if(this.boxMoveProcessOne(res.newTip,newstep))
                        return true;
                }
            }
        }

        return false;

    },

    ReBoxRotate:function (recenttip,key) {
        var newangle=(recenttip.angle+key)%4;
        var tempbox=new BoxNode(recenttip.shape,newangle);
        var boxfill=tempbox.getBoxFill();
        for(var i in boxfill){
            boxfill[i].x+=recenttip.position.x;
            boxfill[i].y+=recenttip.position.y;
        }

        var result=new BoxMoveResult(false,recenttip);
        result.newTip.angle=newangle;
        var tempbool=true;
        for(var i in boxfill){
            var key=boxfill[i];
            if(key.y<FANGK_HEIGHT&&(key.y<0||key.x<0||key.x>=FANGK_WIDTH||this._chessfillinfo[key.x*FANGK_HEIGHT+key.y])){
                tempbool=false;
                break;
            }
        }

        if(tempbool){
            result.result=true;
            return result;
        }else{
            tempbool=true;
            if(this._beginTip.shape==ShapeIndex.U_SHAPE)
                tempbool=false;
            else{
                var newboxFill=this.BoxFillOffest(boxfill,cc.p(-1,0));
                for(var i in newboxFill){
                    var key=newboxFill[i];
                    if(key.y<FANGK_HEIGHT&&(key.y<0||key.x<0||key.x>=FANGK_WIDTH||this._chessfillinfo[key.x*FANGK_HEIGHT+key.y])){
                        tempbool=false;
                        break;
                    }
                }
            }
        }

        //向左移动一个单位
        if(tempbool){
            result.result=true;
            result.newTip.position.x-=1;
            return result;
        }else{
            tempbool=true;
            if(this._beginTip.shape==ShapeIndex.U_SHAPE)
                tempbool=false;
            else{
                var newboxFill=this.BoxFillOffest(boxfill,cc.p(1,0));
                for(var i in newboxFill){
                    var key=newboxFill[i];
                    if(key.y<FANGK_HEIGHT&&(key.y<0||key.x<0||key.x>=FANGK_WIDTH||this._chessfillinfo[key.x*FANGK_HEIGHT+key.y])){
                        tempbool=false;
                        break;
                    }
                }
            }
        }

        //向右移动一个单位
        if(tempbool){
            result.result=true;
            result.newTip.position.x+=1;
            return result;
        }else{
            tempbool=false;
        }

        //向左上移动
        if(tempbool){
            result.result=true;
            result.newTip.position.x-=1;
            result.newTip.position.y+=1;
            return result;
        }else{
            tempbool=true;
            if(this._beginTip.shape==ShapeIndex.T_SHAPE||this._beginTip.shape==ShapeIndex.SWAGER_RESHAPE){
                var newboxFill=this.BoxFillOffest(boxfill,cc.p(1,1));
                for(var i in newboxFill){
                    var key=newboxFill[i];
                    if(key.y<FANGK_HEIGHT&&(key.y<0||key.x<0||key.x>=FANGK_WIDTH||this._chessfillinfo[key.x*FANGK_HEIGHT+key.y])){
                        tempbool=false;
                        break;
                    }
                }
            }else{
                tempbool=false;
            }
        }

        //向右上移动
        if(tempbool){
            result.result=true;
            result.newTip.position.x+=1;
            result.newTip.position.y+=1;
            return result;
        }else{
            tempbool=true;
            if(this._beginTip.shape==ShapeIndex.SWAGER_SHAPE||this._beginTip.shape==ShapeIndex.LINE_SHAPE||this._beginTip.shape==ShapeIndex.LINESMALL_SHAPE||this._beginTip.shape==ShapeIndex.T_SHAPE){
                var newboxFill=this.BoxFillOffest(boxfill,cc.p(0,1));
                for(var i in newboxFill){
                    var key=newboxFill[i];
                    if(key.y<FANGK_HEIGHT&&(key.y<0||key.x<0||key.x>=FANGK_WIDTH||this._chessfillinfo[key.x*FANGK_HEIGHT+key.y])){
                        tempbool=false;
                        break;
                    }
                }
            }else{
                tempbool=false;
            }
        }

        //向上
        if(tempbool){
            result.result=true;
            result.newTip.position.y+=1;
            return result;
        }else{
            return result;
        }
    },

    isTheTop:function (pt) {
        var tempbox=new BoxNode(pt.shape,pt.angle);
        var boxfill=tempbox.getBoxFill();
        for(var i in boxfill){
            boxfill[i].x+=pt.position.x;
            boxfill[i].y+=pt.position.y;
        }

        for(var i in boxfill){
            if(boxfill[i].y<this._toph[boxfill[i].x])
                return false;
        }
        return true;
    },

    BoxPathVecJudge:function (fronttip,nowtip,step) {
        for(var i in this._BoxPathVec){
            var key=this._BoxPathVec[i];
            if(key.NowTip==nowtip&&step>key.step){
                return true;
            }
        }
        return false;
    },

    BoxMove:function (recenttip,move) {
        var result=new BoxMoveResult(false,recenttip);
        var tempbox=new BoxNode(recenttip.shape,recenttip.angle);
        var boxfill=tempbox.getBoxFill();
        for(var i in boxfill){
            boxfill[i].x+=recenttip.position.x;
            boxfill[i].y+=recenttip.position.y;
        }

        var tempbool=true;
        var newboxfill=this.BoxFillOffest(boxfill,move);
        for(var i in newboxfill){
            var key=newboxfill[i];
            if(key.y<FANGK_HEIGHT&&(key.y<0||key.x<0||key.x>=FANGK_WIDTH||this._chessfillinfo[key.x*FANGK_HEIGHT+key.y])){
                tempbool=false;
                break;
            }
        }
        if(tempbool){
            result.result=true;
            result.newTip.position.x+=move.x;
            result.newTip.position.y+=move.y;
        }
        return result;
    },

    BoxFillOffest:function (vec,offest) {
        for(var i in vec){
            vec[i].x+=offest.x;
            vec[i].y+=offest.y;
        }
        return vec;
    },

    getJudge:function () {
        return this._canGet;
    },

    getData:function () {
        return this._BoxMoveVec;
    },
});

PointManage._instance=null;

PointManage.getInstance=function () {
    if(!PointManage._instance){
        PointManage._instance=new PointManage();
    }
    return PointManage._instance;
}