﻿FANGK_WIDTH=11;
FANGK_HEIGHT=14;
FANGK_SIZE_WIDTH=57;
FANGK_CHESS_SCALE=57/64.0;

var RECENTTAG=1111;
var CLONETAG=1112;
var droptime=0.02;

var FangkManager=GameLayer.extend({
    _PointTipLayer:null,
    _recentBox:-1,
    _touchbox:-1,
    _upboxtime:0.0,
    _canup:false,
    _judgetime:0,
    _showDelayTime:0,
    _nextBox:[],
    _chessfillinfo:[],
    _lastPos:cc.p(0,0),
    _pointPath:[],
    _pointTipPair:[],
    _pointTipPairTemp:[],
    _pointTipPriority:[],
    _recentPointNumber:1,
    _pointTipVec:[],
    _noCanPutIn:[],
    _scoretemppos:cc.p(0,0),
    _toph:[],
    _moveh:[],
    _BlankOfUnFillVec:[],
    _tempUnFillVec:[],
    _pointMoveP:[],
    _pointMoveNumber:0,
    _savechess:0,
    _guide:false,
    _guidenumber:0,
    _guidetime:0,
    _guideJudge:false,
    ctor:function () {
        this._super();

        this.init();
    },

    resurrenction:function () {
        this.setGameState(GameState.STATE_STOP);
        this.levelUpReward(4);

        this.runAction(new cc.Sequence(new cc.DelayTime(2.0),new cc.CallFunc(function () {
            this.setGameState(GameState.STATE_RUN);
            this.schedule(this.boxDropUpdate,Math.max(0.2,DROP_UPDATE_TIME+DROP_STOP_TIME-this.getLevel()*0.02));
            this.startDropBox();
        }.bind(this))));
    },

    levelUpReward:function (k) {
        var ret = false;
        var top = this.getChessTop();
        if (k > top)
            k = top;

        if (k < 1)
            return false;

        var movetime = 0.4;
        var newline = false;
        var newpos = -1;
        for (var i = 0; i < FANGK_WIDTH; i++)
        {
            newpos = -1;
            for (var j = (k - 1); j >= 0; j--)
            {
                newline = true;
                if (this._chessfillinfo[i*FANGK_HEIGHT+j] == 0)
                {
                    ret = true;
                    if (j > 0)
                    {
                        for (var t = j - 1; t >= 0; t--)
                        {
                            if (this._chessfillinfo[i*FANGK_HEIGHT+t] > 0)
                            {
                                var box = this._clip.getChildByTag(i*FANGK_HEIGHT + t);
                                box.runAction(new cc.MoveTo(movetime, this.chessPos(i, j)));
                                box.setTag(i*FANGK_HEIGHT + j);
                                this._chessfillinfo[i*FANGK_HEIGHT+j] = this._chessfillinfo[i*FANGK_HEIGHT+t];
                                this._chessfillinfo[i*FANGK_HEIGHT+t] = 0;
                                newline = false;
                                break;
                            }
                        }
                    }
                    if (newline)
                    {
                        var key = parseInt(wb.randNum(0,4));
                        var boxnode =new cc.Sprite(chesspng[key]);
                        this._clip.addChild(boxnode, CHESSMAN_LEVEL, i*FANGK_HEIGHT + j);
                        var pos=this.chessPos(i,0);
                        boxnode.setPosition(cc.p(pos.x,pos.y+FANGK_SIZE_WIDTH*newpos));
                        boxnode.runAction(new cc.MoveTo(movetime, this.chessPos(i, j)));
                        boxnode.setScale(FANGK_CHESS_SCALE);
                        this._chessfillinfo[i*FANGK_HEIGHT+j] = 1;
                        newpos--;
                    }
                }
            }
        }

        if (ret) {
            this.runAction(new cc.Sequence(new cc.DelayTime(movetime + 0.2),new cc.CallFunc(function () {
                var ttt;
                var eraselise = [];
                var map = this.getTopHeight();
                var smallh = FANGK_HEIGHT;
                for (var i = 0; i < FANGK_HEIGHT; i++) {
                    if (smallh > map[i])
                        smallh = map[i];
                }

                for (var j = 0; j <= smallh; j++) {
                    var tempb = true;
                    for (var i = 0; i < FANGK_WIDTH; i++) {
                        if (!this._chessfillinfo[i * FANGK_HEIGHT + j]) {
                            tempb = false;
                            break;
                        }
                    }
                    if (tempb)
                        eraselise.push(j);
                }

                if (eraselise.length > 0) {
                    this.rollEliminate(eraselise);
                }
            }.bind(this))));
        }
        return ret;
    },

    Rotate:function () {
        if(this.getGameState()==GameState.STATE_RUN&&!this._touchcan&&this._recentBox>=0){
            if(this._guide&&this._guidetime<guidetimemost)
                return;
            this._recentPointNumber++;
            if(this._recentPointNumber>=this._pointTipPair.length){
                this._recentPointNumber=1;
            }
            this.showTipWithId(this._recentPointNumber);
        }
    },

    //引导
    challengeGuide:function () {
        var bclayer=new cc.Layer();
        cc.director.getRunningScene().addChild(bclayer,100,BCLAYERTAG);

        this._guidepage=true;
        var v0=[cc.p(0,0),cc.p(WINSIZE.width,0),cc.p(WINSIZE.width,WINSIZE.height),cc.p(0,WINSIZE.height)];
        var drawback=new cc.DrawNode();
        drawback.drawPoly(v0,cc.color(0,0,0,200),2,cc.color(255, 0, 0, 0));

        var clipnode=new cc.ClippingNode(drawback);
        bclayer.addChild(clipnode);
        clipnode.addChild(drawback);

        var v1=[cc.p(1,766),cc.p(119,798),cc.p(1,798)];
        var v2=[cc.p(124,766),cc.p(279,766),cc.p(279,798),cc.p(124,798)];
        var v3=[cc.p(283,766),cc.p(439,766),cc.p(439,798),cc.p(283,798)];

        var sten=new cc.Node();
        bclayer.addChild(sten);

        var str=new Array();
        var ignore=false;
        str.push("拖动方块到上方区域");
        str.push("横竖满格才能消除");

        var person=ELSGameTool.getInstance().guidePerson(str,30,ignore);
        bclayer.addChild(person);
        person.setPosition(cc.p(WINSIZE.width/2.0,WINSIZE.height*0.5));

        var hand=ELSGameTool.getInstance().createHand();
        bclayer.addChild(hand);
        hand.setPosition(this.chessPos(4,1));

        var node1=new BoxNode(ShapeIndex.L_SHAPE);
        node1.setPosition(this.chessPos(5,FANGK_HEIGHT-2));
        sten.addChild(node1);

        for(var i=0;i<3;i++){
            var node3=new BoxNode(ShapeIndex.L_SHAPE);
            node3.setOpacity(0);
            sten.addChild(node3);
            var line3=new BoxNode(ShapeIndex.L_SHAPE);
            sten.addChild(line3);
            line3.setOpacity(200);
            var k=0;
            if(i>0)
                k=1;
            node3.setPosition(this.chessPos(3+3*i,k));
            line3.setPosition(this.chessPos(3+3*i,k));
        }

        var node3=new BoxNode(ShapeIndex.L_SHAPE);
        node3.setRotate(AngleIndex.ANGLE_90);
        node3.setOpacity(this.chessPos(0,2));
        node3.setOpacity(0);
        sten.addChild(node3);

        var line3=new BoxNode(ShapeIndex.L_SHAPE,AngleIndex.ANGLE_90);
        sten.addChild(line3);
        line3.setPosition(this.chessPos(0,2));

        clipnode.setStencil(sten);
        clipnode.addChild(drawback);
        clipnode.setInverted(true);
    },

    run:function () {
        this.schedule(this.boxDropUpdate,DROP_UPDATE_TIME+DROP_STOP_TIME);
        this.setGameState(GameState.STATE_RUN);
    },

    start:function () {
        this.setGameState(GameState.STATE_RUN);
    },

    init:function () {
        heightoffest=108;
        guidetimemost=2;

        this._guide=ELSGameData.getInstance().getGameGuide(GameName[3]);
        this._guidenumber=0;
        this._guidetime=0;
        this._guideJudge=false;

        this.initChess();
        this.setTouchState(TouchState.TOUCH_TRUE);
        this.setGameState(GameState.STATE_STOP);
        this._recentBox=-1;
        this._upboxtime=0.0;
        this._canup=false;
        this._judgetime=0;
        this._showDelayTime=0;

        this.initNextBox();
        this.setScore(0);
        this.setLevel(1);
        this.setTarget(this.getScoreByLevel(1));

        for(var i=0;i<FANGK_WIDTH;i++)
            for(var j=0;j<FANGK_HEIGHT;j++){
                this._chessfillinfo[i*FANGK_HEIGHT+j]=0;
            }

        this.setLastData();

        if(this._guide){
            this._guidenumber=1;
            this.guideChess();

            for(var i=0;i<FANGK_WIDTH;i++)
                for(var j=0;j<FANGK_HEIGHT;j++){
                    if(this._chessfillinfo[i*FANGK_HEIGHT+j]>0){
                        var boxnode=new cc.Sprite(chesspng[this._chessfillinfo[i*FANGK_HEIGHT+j]-1]);
                        this._clip.addChild(boxnode,CHESSMAN_LEVEL,i*FANGK_HEIGHT+j);
                        boxnode.setPosition(this.chessPos(i,j));
                        boxnode.setScale(FANGK_CHESS_SCALE);
                    }
                }
        }

        this.LevelUpMotion();

        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: this.onTouchBegan,
            onTouchMoved: this.onTouchMoved,
            onTouchEnded: this.onTouchEnded
        },this);

        this.schedule(this.timeSchedule);
    },

    //引导棋盘
    guideChess:function () {
       // var chess=[5,5,2,2,0,0,0,3,3,3,5,2,5,1,2,2,0,0,1,2,3,5,2,1,1,0,3,3,3,1,2,3,5,2,2,1,0,0,1,1,1,2,2,5];
        var chess=[5,2,2,2,5,5,1,2,2,1,1,1,2,2,0,0,0,2,3,0,0,0,3,1,0,0,3,1,3,1,1,1,3,2,2,2,3,3,3,2,5,5,5,5];
        for(var i=0;i<FANGK_WIDTH;i++)
            for(var j=0;j<FANGK_HEIGHT;j++){
                if(j<4){
                    this._chessfillinfo[i*FANGK_HEIGHT+j]=chess[i*4+j];
                }
            }
    },

    //恢复上次存档
    setLastData:function () {
        var lastdata=FKuaiTempData.getInstance().getSaveData();
        if(lastdata._issaved){
            this._firstsavein=true;
            this.setLevel(lastdata._level);
            this.setScore(lastdata._score);
            this.setTarget(lastdata._target);
            var chessinfo=lastdata._chesspad;
            for(var i=0;i<FANGK_WIDTH;i++)
                for(var j=0;j<FANGK_HEIGHT;j++) {
                    var k=parseInt(chessinfo[i*FANGK_HEIGHT+j]);
                    if(k>0){
                        var boxnode=new cc.Sprite(chesspng[k-1]);
                        this._clip.addChild(boxnode,CHESSMAN_LEVEL,i*FANGK_HEIGHT+j);
                        boxnode.setPosition(this.chessPos(i,j));
                        boxnode.setScale(FANGK_CHESS_SCALE)
                        this._chessfillinfo[i*FANGK_HEIGHT+j]=k;
                    }
                }
            var chessid=lastdata._chessid;
            var id="";
            var order=0;
            for(var i in chessid){
                if(chessid[i]==='#'){
                    var key=parseInt(id);
                    if(key>=0){
                        if(order==3){
                            this._savechess=parseInt(id);
                        }else{
                            this._nextBox[order]=parseInt(id);
                        }
                        order++;
                    }else{
                        this._savechess=parseInt(wb.randNum(0,6));
                    }
                    id="";
                }else{
                    id+=chessid[i];
                }
            }

        }
    },

    getNBox:function (i) {
        return this._nextBox[i];
    },

    onTouchBegan:function (touch,event) {
        var startpos=touch.getLocation();
        var target=event.getCurrentTarget();

        if(target._guide){
            var lay=cc.director.getRunningScene().getChildByTag(BCLAYERTAG);
            if(lay){
                var temp=false;
                var pos=new Array();
                if(target._guidenumber==1){
                    pos.push(cc.p(3,2));
                    pos.push(cc.p(3,3));
                    pos.push(cc.p(4,3));
                }else if(target._guidenumber==2){
                    pos.push(cc.p(5,0));
                    pos.push(cc.p(6,0));
                    pos.push(cc.p(5,1));
                    pos.push(cc.p(6,1));
                }
                var po=target.chessPt(startpos);
                if(ELSGameTool.getInstance().posIndexOf(pos,po)>=0){
                    temp=true;
                }

                if(temp){
                    target.setGameState(GameState.STATE_RUN);
                    cc.director.getRunningScene().removeChildByTag(BCLAYERTAG);
                    target._guidetime=0;
                    target._guidenumber++;

                    if(target._guidenumber==3){
                        target.endGuide();
                    }
                }
            }else
                return false;
        }

        if(target.getGameState()!=GameState.STATE_RUN||target.getTouchState()!=TouchState.TOUCH_TRUE||target._recentBox<0)
            return false;

        target._lastPos=touch.getLocation();
        target._touchbool=false;
        target._touchtime=0.0;
        target._touchcan=true;
        target._touchbox=-1;

        var pos=target.chessPt(startpos);
        var tipvec=target._pointTipPair[target._recentPointNumber];
        for(var i in tipvec){
            var boxfill=target.getBoxFill2(target._pointTipVec[tipvec[i]]);
            var temp=false;
            for(var j in boxfill){
                if(pos.x==boxfill[j].x&&pos.y==boxfill[j].y){
                    target.showTipWithBox(target._pointTipVec[tipvec[i]]);
                    target._touchbox=tipvec[i];
                    return true;
                }
            }
        }

        target._touchcan=false;
        return false;
    },

    onTouchMoved:function (touch,event) {
        var startpos=touch.getLocation();
        var target=event.getCurrentTarget();
        if(target._recentBox<0||!target._touchcan)
            return ;

    },

    onTouchEnded:function (touch,event) {
        var startpos=touch.getLocation();
        var target=event.getCurrentTarget();
        if(target._recentBox<0||!target._touchcan)
            return;

        if(target._touchbox>=0){
            target._PointTipLayer.removeAllChildren();
            target.moveBoxToId(target._touchbox);
        }
    },

    //引导结束
    endGuide:function () {
        this.guideTip(2);
        this._guide=false;
        this._guidenumber=0;
        ELSGameData.getInstance().setGameGuide(GameName[3],false);
    },

    guideTip:function (key) {
        var sst=gxpng[3];
        if(key==2){
            sst=gxpng[4];
        }
        var fnt2=new cc.Sprite(sst);
        this.addChild(fnt2,CHESSMAN_LEVEL+100);
        fnt2.setPosition(cc.p(WINSIZE.width/2,680));
        fnt2.runAction(new cc.Sequence(new cc.MoveBy(0.3,cc.p(0,60)),new cc.DelayTime(0.2),new cc.ScaleTo(0.2,1.1),new cc.DelayTime(0.5),new cc.FadeOut(0.3),new cc.CallFunc(function () {
            fnt2.removeFromParent();
        }.bind(this))));
    },

    moveBoxToId:function (boxid) {
        var recentbox=this._clip.getChildByTag(RECENTTAG);
        var ontop=true;
        var pointtip=this._pointTipVec[boxid];
        var fillbox=this.getBoxFill(pointtip);
        var topheight=this.getTopHeight();
        for(var i in fillbox){
            if(i.y<topheight[i.x])
                ontop=false;
        }

        if(ontop){
            this.setGameState(GameState.STATE_STOP);
            var ofpos=cc.p(0,0);
            ofpos.x=pointtip.position.x-this._recentPos.x;
            ofpos.y=pointtip.position.y-this._recentPos.y;
            var move1=new cc.MoveBy(droptime,cc.p(FANGK_SIZE_WIDTH*ofpos.x,0));
            var call=new cc.CallFunc(function (target,data) {
                data.rec.setRotate(data.poi.angle);
            }.bind(this),this,{rec:recentbox,poi:pointtip});
            var move2=new cc.MoveBy(droptime,cc.p(0,ofpos.y*FANGK_SIZE_WIDTH));
            recentbox.runAction(new cc.Sequence(move1,call,move2,new cc.CallFunc(function () {
                ELSGameTool.getInstance().playVideo(VIDEO[12]);
            }),new cc.DelayTime(CHESS_CHECK_TIME),new cc.CallFunc(function (target,data) {
                if(this.getGameState()==GameState.STATE_STOP)
                    this.setGameState(GameState.STATE_RUN);
                this._recentPos=data.poi.position;
                if(this.boxSure()){
                    this.checkChess();
                }else{
                    this.gameFaild();
                }
            }.bind(this),this,{rec:recentbox,poi:pointtip})));
        }else{
            this._pointMoveP=[];
            this._pointMoveP=this._pointPath[boxid];
            this._pointMoveNumber=0;

            var toptip=this._pointMoveP[this._pointMoveP.length-1];
            this.setGameState(GameState.STATE_STOP);
            var ofpos=cc.p(0,0);
            ofpos.x=toptip.position.x-this._recentPos.x;
            ofpos.y=toptip.position.y-this._recentPos.y;
            var move1=new cc.MoveBy(droptime,cc.p(FANGK_SIZE_WIDTH*ofpos.x,0));
            var call=new cc.CallFunc(function (target,data) {
                data.rec.setRotation(data.top.angle);
            }.bind(this),this,{rec:recentbox,top:toptip});
            var move2=new cc.MoveBy(droptime,cc.p(0,ofpos.y*FANGK_SIZE_WIDTH));
            recentbox.runAction(new cc.Sequence(move1,call,move2,new cc.CallFunc(function () {
                this.schedule(this.PointMove);
            }.bind(this))));
        }
    },

    PointMove:function (ft) {
        var ppp=this._pointMoveP[this._pointMoveP.length-1-this._pointMoveNumber];
        var box=this._clip.getChildByTag(RECENTTAG);
        box.setRotation(ppp.angle);

        this._pointMoveNumber++;
        if(this._pointMoveNumber>=this._pointMoveP.length){

            ELSGameTool.getInstance().playVideo(VIDEO[12]);

            box.runAction(new cc.MoveTo(1/60.0,this.chessPos(ppp.position.x,ppp.position.y)));
            this._recentPos=ppp.position;
            this.unschedule(this.PointMove);
            this.runAction(new cc.Sequence(new cc.DelayTime(CHESS_CHECK_TIME),new cc.CallFunc(function () {
                if(this.getGameState()==GameState.STATE_STOP)
                    this.setGameState(GameState.STATE_RUN);
                if(this.boxSure()){
                    this.checkChess();
                }else{
                    this.gameFaild();
                }
            }.bind(this))));
        }else{
            box.setPosition(this.chessPos(ppp.position.x,ppp.position.y));
        }
    },

    showTipWithBox:function (tip) {
        this._PointTipLayer.removeAllChildren();
        var box=new BoxNode(tip.shape,tip.angle);
        box.setLineModel();
        this._PointTipLayer.addChild(box);
        box.setPosition(this.chessPos(tip.position.x,tip.position.y));
    },

    timeSchedule:function (ft) {
        if(this.getGameState()!=GameState.STATE_RUN)
            return;

        this._upboxtime+=ft;
        var tti=10;
        var lev=this.getLevel();
        if(lev>40)
            tti=10;
        else if(lev>35)
            tti=15;
        else if(lev>30)
            tti=16;
        else if(lev>25)
            tti=17;
        else if(lev>20)
            tti=18;
        else if(lev>15)
            tti=20;
        else if(lev>10)
            tti=22;
        else if(lev>5)
            tti=25;
        else
            tti=99999;

        if(this._upboxtime>=tti)
        {
            this._canup=true;
            this._upboxtime=0.0;
        }
    },

    initChess:function () {
        var vec=[
            cc.p(WINSIZE.width/2.0-FANGK_SIZE_WIDTH*FANGK_WIDTH/2.0,heightoffest),
            cc.p(WINSIZE.width/2.0+FANGK_SIZE_WIDTH*FANGK_WIDTH/2.0,heightoffest),
            cc.p(WINSIZE.width/2.0+FANGK_SIZE_WIDTH*FANGK_WIDTH/2.0,heightoffest+FANGK_SIZE_WIDTH*FANGK_HEIGHT),
            cc.p(WINSIZE.width/2.0-FANGK_SIZE_WIDTH*FANGK_WIDTH/2.0,heightoffest+FANGK_SIZE_WIDTH*FANGK_HEIGHT),
        ];
        var node=new cc.DrawNode();
        node.drawPoly(vec,cc.color(255,255,255,0),2,cc.color(255, 0, 0, 0));

        this._clip=new cc.ClippingNode(node);

        this.addChild(this._clip,10);

        this._PointTipLayer=new cc.Layer();
        this._clip.addChild(this._PointTipLayer,CHESSMAN_LEVEL-1);

        for(var i=0;i<FANGK_WIDTH;i++)
            for(var j=0;j<FANGK_HEIGHT;j++){
                var sp=new cc.Sprite(res.chess_di_png)
                this.addChild(sp);
                sp.setScale(FANGK_SIZE_WIDTH/42.0);
                sp.setPosition(this.chessPos(i,j));
            }
    },

    initNextBox:function () {
        this.setStepNumber(0);
        for(var i=0;i<3;i++){
            if(this._guide){
                if(i==0){
                    this._nextBox[i]=ShapeIndex.ANGLE_SHAPE;
                }else if(i==1){
                    this._nextBox[i]=ShapeIndex.SQUARE_SHAPE;
                }else if(i==2){
                    this._nextBox[i]=wb.randNum(0,6);
                }
            }else{
                this._nextBox[i]=parseInt(wb.randNum(0,6));
            }
        }
    },

    chessPos:function (i,j) {
        return cc.p(WINSIZE.width/2+FANGK_SIZE_WIDTH*(i+0.5-FANGK_WIDTH/2.0),(j+0.5)*FANGK_SIZE_WIDTH+heightoffest);
    },
    
    chessPt:function (pt) {
        var x=(pt.x-WINSIZE.width/2.0)/FANGK_SIZE_WIDTH+FANGK_WIDTH/2;
        var y=(pt.y-heightoffest)/FANGK_SIZE_WIDTH;
        return cc.p(parseInt(x),parseInt(y));
    },

    getScoreByLevel:function (level) {
        var ret=this.getTarget();
        if(level==1)
            ret=300;
        if(level>1&&level<11)
            ret+=Math.pow(1.18,(level-1))*500;
        else if(level>10&&level<31)
            ret+=Math.pow(1.052,(level-10))*2218;
        else if(level>30)
            ret+=Math.pow(0.995,(level-30))*5885;
        var tnum=100;
        if(this.getLevel()>10)
            tnum=10;

        var kk=ret%tnum;
        if(kk>=50)
            ret=parseInt(ret/tnum)*tnum+tnum;
        else
            ret=parseInt(ret/tnum)*tnum;
        return ret;
    },

    LevelUpMotion:function () {
        if(this.getLevel()==1){
            ELSGameTool.getInstance().playVideo(VIDEO[1]);
        }

        var fnt1=new cc.LabelTTF("第 "+this.getLevel()+" 关");
        fnt1.setFontSize(40);
        this._clip.addChild(fnt1, CHESSMAN_LEVEL + 1);
        fnt1.setPosition(cc.p(WINSIZE.width/2.0,WINSIZE.height/2.0));
        fnt1.runAction(new cc.Sequence(new cc.MoveBy(0.3,cc.p(0,100)),new cc.DelayTime(1.0),new cc.FadeOut(0.3)));

        var fnt2=new cc.LabelTTF("目标："+this.getTarget());
        fnt2.setFontSize(40);
        this._clip.addChild(fnt2, CHESSMAN_LEVEL + 1);
        fnt2.setPosition(cc.p(fnt1.getPosition().x,fnt1.getPosition().y-60));
        fnt2.runAction(new cc.Sequence(new cc.MoveBy(0.3,cc.p(0,100)),new cc.DelayTime(1.0),new cc.FadeOut(0.3),new cc.CallFunc(function () {
            fnt1.removeFromParent();
            fnt2.removeFromParent();

            if(this.getGameState()==GameState.STATE_STOP)
                this.setGameState(GameState.STATE_RUN);
            this.startDropBox();

        }.bind(this))));

        if(this._guide){
            this.guideTip(1);
            fnt1.setVisible(false);
            fnt2.setVisible(false);
        }
    },

    //一个方块开始下落
    startDropBox:function(){
        var time= 0.0;
        if(this._canup)
        {
            this._canup=false;
            var numllnumber=parseInt(Math.random()*3)+1;
            var vec=[];
            for(var i=0;i<numllnumber;i++)
            {
                var k=0;
                var temp=false;
                do
                {
                    k=parseInt(Math.random()*FANGK_WIDTH);
                    if(vec.indexOf(k)==-1){
                        vec.push(k);
                        temp=true;
                    }
                } while (false);
            }

            for(var i=0;i<FANGK_WIDTH;i++)
            {
                if(this._chessfillinfo[i*FANGK_HEIGHT+FANGK_HEIGHT-1])
                {
                    this.gameFaild();
                    return;
                }
            }

            for(var i=0;i<FANGK_WIDTH;i++)
            {
                for(var j=(FANGK_HEIGHT-2);j>=0;j--)
                {
                    if(this._chessfillinfo[i*FANGK_HEIGHT+j])
                    {
                        var box=this._clip.getChildByTag(i*FANGK_HEIGHT+j);
                        box.runAction(cc.moveBy(upboxtime,cc.p(0,FANGK_SIZE_WIDTH)));
                        box.setTag(i*FANGK_HEIGHT+j+1);
                        this._chessfillinfo[i*FANGK_HEIGHT+j+1]=this._chessfillinfo[i*FANGK_HEIGHT+j];
                        this._chessfillinfo[i*FANGK_HEIGHT+j]=0;
                    }
                }
                if(vec.indexOf(i)==-1)
                {
                    var k=parseInt(Math.random()*5)+1;
                    var boxnode=new cc.Sprite(chesspng[k-1]);
                    this._clip.addChild(boxnode,CHESSMAN_LEVEL,i*FANGK_HEIGHT);
                    boxnode.setPosition(this.chessPos(i,-1));
                    boxnode.setScale(FANGK_CHESS_SCALE);
                    this._chessfillinfo[i*FANGK_HEIGHT]=k;
                    boxnode.runAction(new cc.moveBy(upboxtime,cc.p(0,FANGK_SIZE_WIDTH)));
                }
            }
        }

        this.runAction(new cc.Sequence(new cc.DelayTime(time),new cc.CallFunc(function () {
            this._touchcan=false;
            this._touchbox=-1;

            this._recentPos =cc.p(parseInt(FANGK_WIDTH/2),FANGK_HEIGHT-1);
            this._recentBox=this._nextBox[0];
            this._scorecolor = this._recentBox;
            var recentBox=new BoxNode(this._recentBox);
            this._clip.addChild(recentBox,CHESSMAN_LEVEL,RECENTTAG);
            var tempbool=true;
            var boxFill=this.getRetBoxFill();
            for(var i in boxFill)
            {
                var key=boxFill[i];
                if(key.y<FANGK_HEIGHT &&(key.x<0||key.x>=FANGK_WIDTH||this._chessfillinfo[key.x*FANGK_HEIGHT+key.y]))
                {
                    tempbool=false;
                    break;
                }
            }
            if(tempbool)
            {
                recentBox.setPosition(this.chessPos(parseInt(FANGK_WIDTH/2),FANGK_HEIGHT-1));
                this._nextBox[0]=-1;
                this.createNextBox();

                this.unschedule(this.timeUpdate);
                this.schedule(this.timeUpdate,1.0);
                this.boxDropTip();
            }
            else
            {
                this._clip.removeChildByTag(RECENTTAG);
                this._recentBox=-1;
                this.gameFaild();
            }

        }.bind(this))));
    },

    gameFaild:function () {

        this.unschedule(this.boxDropUpdate);

        this.setGameState(GameState.STATE_FAILD);

        FKuaiTempData.getInstance().clear();

        var lay=new FaildLayer();
        this.getParent().addChild(lay,100);
    },

    boxDropTip:function () {
        this._pointPath=[];
        this._pointTipPair=[];
        this._pointTipVec=[];
        this._pointTipPriority=[];
        this._noCanPutIn=[];
        var shape=this._recentBox;
        var angle=0;
        var pt=cc.p(0,0);
        var kk=4;
        if(shape==ShapeIndex.LINE_SHAPE||shape==ShapeIndex.SWAGER_SHAPE||shape==ShapeIndex.SWAGER_RESHAPE||shape==ShapeIndex.LINESMALL_SHAPE)
            kk=2;
        else if(shape==ShapeIndex.SQUARE_SHAPE||shape==ShapeIndex.POINT_SHAPE)
            kk=1;

        var unFillNumber=this.getBlankOfUnFill();

        for(var k=0;k<kk;k++){
            angle=k;
            for(var i=0;i<FANGK_WIDTH;i++){
                for(var j=0;j<FANGK_HEIGHT;j++){
                    var pt=new PointTip(shape,angle,cc.p(i,j));
                    var key=this.PointTipJudge(pt);
                    if(key==2)
                        break;
                    else if(key==1){
                        this._pointTipVec.push(pt);
                        break;
                    }else if(key==3){
                        if(this.canPutIn(pt)){
                            this._pointTipVec.push(pt);
                        }
                    }
                }
            }
        }

        if(this._pointTipVec.length==0){
            this.gameFaild();
            return;
        }

        var tipVecWithPriority=[];
        var tempk=0;
        for(var i in this._pointTipVec) {
            var value = 0;
            var boxfill = this.getBoxFill2(this._pointTipVec[i]);
            for (var k in boxfill) {
                var key = boxfill[k];
                if (key.x == 0)
                    value -= 1;
                else if (this._chessfillinfo[(key.x - 1) * FANGK_HEIGHT + key.y])
                    value -= 2;

                if (key.x == (FANGK_WIDTH - 1))
                    value -= 1;
                else if (this._chessfillinfo[(key.x + 1) * FANGK_HEIGHT + key.y])
                    value -= 2;

                if (key.y == 0)
                    value -= 1;
                else if (this._chessfillinfo[key.x * FANGK_HEIGHT + key.y - 1])
                    value -= 2;

                if (key.y < (FANGK_HEIGHT - 1) && this._chessfillinfo[key.x * FANGK_HEIGHT + key.y + 1])
                    value -= 3;
            }
            value -= this.getRemoveRow(boxfill[i]) * 100;
            tipVecWithPriority.push(cc.p(tempk, value));
            tempk++;
        }

        var pronumber=tipVecWithPriority.length;
        for(var i=0;i<(pronumber-1);i++){
            for(var j=0;j<(pronumber-1-i);j++){
                if(tipVecWithPriority[j].y>tipVecWithPriority[j+1].y){
                    var temp=tipVecWithPriority[j];
                    tipVecWithPriority[j]=tipVecWithPriority[j+1];
                    tipVecWithPriority[j+1]=temp;
                }else if(tipVecWithPriority[j].y==tipVecWithPriority[j+1].y&&this.getButtonPosition(this._pointTipVec[tipVecWithPriority[j].x])>this.getButtonPosition(this._pointTipVec[tipVecWithPriority[j+1].x])){
                    var temp=tipVecWithPriority[j];
                    tipVecWithPriority[j]=tipVecWithPriority[j+1];
                    tipVecWithPriority[j+1]=temp;
                }
            }
        }

        for(var i in tipVecWithPriority){
            this._pointTipPriority.push(tipVecWithPriority[i].x);
        }

        var pairnumber=1;
        var pairvec=[];
        do{
            this._pointTipPairTemp=[];
            pairvec=[];

            for(var i=0;i<tipVecWithPriority.length;){
                var key=tipVecWithPriority[i];
                if(this.pointTipPairTempJudge(key.x)){
                    pairvec.push(key.x);
                    tipVecWithPriority.splice(i,1);
                    if(pairvec.length>=4)
                        break;
                }else{
                    i++;
                }
            }

            if(pairvec.length<3){
                for(var i=0;i<this._pointTipVec.length;i++){
                    if(this.pointTipPairTempJudge(i)){
                        pairvec.push(i);
                        if(pairvec.length>=4)
                            break;
                    }
                }
            }

            this._pointTipPair[pairnumber]=pairvec;
            pairnumber++;
        }while(tipVecWithPriority.length>0);
        this._recentPointNumber=1;
        this.showTipWithId(this._recentPointNumber);
    },

    pointTipPairTempJudge:function (pairid) {
        var boxfill=this.getBoxFill2(this._pointTipVec[pairid]);
        for(var i in this._pointTipPairTemp){
            for(var j in boxfill){
                if(this._pointTipPairTemp[i].x==boxfill[j].x)
                    return false;
            }
        }

        for(var i in boxfill){
            this._pointTipPairTemp.push(cc.p(boxfill[i].x,boxfill[i].y));
        }
        return true;
    },

    getButtonPosition:function (tip) {
        var tempbox=new BoxNode(tip.shape,tip.angle);
        var boxfill=tempbox.getBoxFill();
        var buttonps=FANGK_HEIGHT-1;
        for(var i in boxfill){
            var key=boxfill[i];
            if(key.y<buttonps)
                buttonps=key.y;
        }
        return buttonps;
    },

    getRemoveRow:function (pt) {
        var map=this.getBoxFill(pt);
        var k=0;
        for(var j=0;j<FANGK_HEIGHT;j++){
            var temp=true;
            for(var i=0;i<FANGK_WIDTH;i++){
                if(this._chessfillinfo[i*FANGK_HEIGHT+j]==0&&ELSGameTool.getInstance().posIndexOf(map,cc.p(i,j))==-1){
                    temp=false;
                    break;
                }
            }
            if(temp)
                k++;
        }
        return k;
    },

    getPointPath:function (id) {
        for(var i in this._pointPath){
            if(this._pointPath[i].first==id){
                return this._pointPath[i].second;
            }
        }
        return null;
    },

    canPutIn:function (tip) {
        if(!this.getVecFromNoPutIn(tip)){
            var recenttip=new PointTip(this._recentBox,0,this._recentPos);
            var manage=PointManage.getInstance().pathAToB(recenttip,tip,this._chessfillinfo);
            if(manage.getJudge()){
                this._pointPath.push({first:this._pointTipVec.length,second:manage.getData()});
                return true;
            }else{
                this._noCanPutIn.push(tip);
                return false;
            }
        }else{
            return false;
        }
    },

    getVecFromNoPutIn:function (tip) {
        var canput=false;
        for(var i in this._noCanPutIn){
            if(this.getByLine(this._noCanPutIn[i],tip))
                return true;
        }
        return false;
    },
    
    getByLine:function (fronttip,targettip) {
        var temp=true;
        if(fronttip.position.y==targettip.position.y){
            temp=true;
            var len=Math.abs(fronttip.position.x-targettip.position.x);
            var kk=1;
            if(fronttip.position.x>targettip.position.x)
                kk=-1;
            var fillvec=this.getBoxFill(fronttip);
            for(var i in fillvec){
                var key=fillvec[i];
                for(var n=1;n<=len;n++){
                    if(this._chessfillinfo[(key.x+kk*n)*FANGK_HEIGHT+key.y]){
                        temp=false;
                        break;
                    }
                }
                if(!temp)
                    break;
            }
            if(temp)
                return true;
            else
                return false;
        }else if(fronttip.position.x==targettip.position.x){
            temp=true;
            var len=Math.abs(fronttip.position.y-targettip.position.y);
            var kk=1;
            if(fronttip.position.y>targettip.position.y)
                kk=-1;
            var fillvec=this.getBoxFill(fronttip);
            for(var i in fillvec){
                var key=fillvec[i];
                for(var n=1;n<=len;n++){
                    if(this._chessfillinfo[key.x*FANGK_HEIGHT+key.y+n*kk]){
                        temp=false;
                        break;
                    }
                }
                if(!temp)
                    break;
            }
            if(temp)
                return true;
            else
                return false;
        }else{
            return false;
        }

    },

    PointTipJudge:function (pt) {
        var boxfill=this.getBoxFill2(pt);
        for(var i in boxfill){
            var key=boxfill[i];
            if(key.x<0||key.x>=FANGK_WIDTH||key.y>=FANGK_HEIGHT){
                return 2;
            }
        }
        var tempbool=false;
        for(var i in boxfill){
            var key=boxfill[i];
            if(key.y<0||this._chessfillinfo[key.x*FANGK_HEIGHT+key.y])
                return 4;
            else if(key.y==0||this._chessfillinfo[key.x*FANGK_HEIGHT+key.y-1])
                tempbool=true;
        }

        if(!tempbool)
            return 4;

        var temp=false;
        for(var i in boxfill){
            var key=boxfill[i];
            if(ELSGameTool.getInstance().posIndexOf(this._BlankOfUnFillVec,key)==-1){
                temp=true;
                break;
            }
        }

        if(!temp)
            return 4;

        for(var i in boxfill){
            var key=boxfill[i];
            var topheight=this.getTopHeight();
            if(key.y<=topheight[key.x])
                return 3;
        }
        return 1;
    },

    getBlankOfUnFill:function () {
        var number=0;
        this._BlankOfUnFillVec=[];
        this._toph=this.getTopHeight();
        for(var i=0;i<FANGK_WIDTH;i++){
            for(var j=0;j<this._toph[i];j++){
                if(this._chessfillinfo[i*FANGK_HEIGHT+j]==0){
                    this._tempUnFillVec=[];
                    if(this.isBlankOfUnFill(cc.p(i,j))){
                        this._BlankOfUnFillVec.push(cc.p(i,j));
                        number++;
                    }
                }
            }
        }
        return number;
    },

    isBlankOfUnFill:function (pt) {
        if(((pt.x+1)<FANGK_WIDTH)&&!this._chessfillinfo[(pt.x+1)*FANGK_HEIGHT+pt.y]&&!this.tempUnFillJudeg(cc.p(pt.x+1,pt.y)))
        {
            this._tempUnFillVec.push(cc.p(pt.x+1,pt.y));
            if(pt.y>this._toph[pt.x+1])
                return false;
            else if(!this.isBlankOfUnFill(cc.p(pt.x+1,pt.y)))
                return false;
        }

        if((pt.x-1>=0)&&!this._chessfillinfo[(pt.x-1)*FANGK_HEIGHT+pt.y]&&!this.tempUnFillJudeg(cc.p(pt.x-1,pt.y)))
        {
            this._tempUnFillVec.push(cc.p(pt.x-1,pt.y));
            if(pt.y>this._toph[pt.x-1])
                return false;
            else if(!this.isBlankOfUnFill(cc.p(pt.x-1,pt.y)))
                return false;
        }

        if((pt.y-1>=0)&&!this._chessfillinfo[pt.x][pt.y-1]&&!this.tempUnFillJudeg(cc.p(pt.x,pt.y-1)))
        {
            this._tempUnFillVec.push(cc.p(pt.x,pt.y-1));
            if((pt.y-1)>this._toph[pt.x])
                return false;
            else if(!this.isBlankOfUnFill(cc.p(pt.x,pt.y-1)))
                return false;
        }

        if((pt.y+1<FANGK_HEIGHT)&&!this._chessfillinfo[pt.x*FANGK_HEIGHT+pt.y+1]&&!this.tempUnFillJudeg(cc.p(pt.x,pt.y+1)))
        {
            this._tempUnFillVec.push(cc.p(pt.x,pt.y+1));
            if((pt.y+1)>this._toph[pt.y])
                return false;
            else if(!this.isBlankOfUnFill(cc.p(pt.x,pt.y+1)))
                return false;
        }

        return true;
    },

    tempUnFillJudeg:function (vec) {
        for(var i in this._tempUnFillVec){
            var key=this._tempUnFillVec[i];
            if(vec.x==key.x&&vec.y==key.y)
                return true;
        }
        return false;
    },
    //
    createNextBox:function(){
        var step=this.getStepNumber();
        this.setStepNumber(++step);
        for(var i=1;i<3;i++){
            this._nextBox[i-1]=this._nextBox[i];
        }
        if(this._firstsavein){
            this._nextBox[2]=this._savechess;
            this._firstsavein=false;
        }else{
            this._nextBox[2]=parseInt(Math.random()*9);
        }
    },

    timeUpdate:function (ft) {
        this._showDelayTime++;
        if(this._recentBox<0||this.getGameState()!=GameState.STATE_RUN)
            return;
    },

    boxDropUpdate:function (ft) {
        if(this._recentBox<0||this.getGameState()!=GameState.STATE_RUN)
            return;

        if(this.boxMoveJudge(DirectionIndex.DIRECTION_D)){
            if(this._showDelayTime>=2||this._guide)
                this.boxDropOneLine();
            this.PointTipRemove();

            if(this._guide){
                this._guidetime++;
                if(this._guidetime==(guidetimemost-1)){
                    this.setGameState(GameState.STATE_STOP);
                    this.GameGuide();
                }
            }
        }else {
            ELSGameTool.getInstance().playVideo(VIDEO[12]);
            this._PointTipLayer.removeAllChildren();
            if(this.boxSure()){
                this.checkChess();
            }else{
                this.gameFaild();
            }
        }
    },

    GameGuide:function () {
        var bclayer=new cc.Layer();
        cc.director.getRunningScene().addChild(bclayer,100,BCLAYERTAG);

        var v0=[cc.p(0,0),cc.p(WINSIZE.width,0),cc.p(WINSIZE.width,WINSIZE.height),cc.p(0,WINSIZE.height)];
        var drawback=new cc.DrawNode();
        drawback.drawPoly(v0,cc.color(0,0,0,200),2,cc.color(255, 0, 0, 0));

        var clipnode=new cc.ClippingNode(drawback);
        bclayer.addChild(clipnode);
        clipnode.addChild(drawback);
        clipnode.setInverted(true);

        var node=new cc.Node();
        var str=new Array();
        var ignore=false;
        str.push("点击白色边框");
        str.push("方块即自动下落");

        var hand=ELSGameTool.getInstance().createHand();
        bclayer.addChild(hand,10);

        var targetpos;

        if(this._guidenumber==1){
            targetpos=cc.p(3,3);

            var selectbox=new BoxNode(ShapeIndex.ANGLE_SHAPE);
            node.addChild(selectbox,9);
            selectbox.setRotate(AngleIndex.ANGLE_0);
            selectbox.setPosition(this.chessPos(5,FANGK_HEIGHT-2));

            var selectbox2=new BoxNode(ShapeIndex.ANGLE_SHAPE);
            node.addChild(selectbox2,9);
            selectbox2.setRotate(AngleIndex.ANGLE_90);
            selectbox2.setPosition(this.chessPos(3,3));
        }else if(this._guidenumber==2){
            targetpos=cc.p(6,1);

            var selectbox=new BoxNode(ShapeIndex.SQUARE_SHAPE);
            node.addChild(selectbox,9);
            selectbox.setPosition(this.chessPos(5,FANGK_HEIGHT-2));

            var selectbox2=new BoxNode(ShapeIndex.SQUARE_SHAPE);
            node.addChild(selectbox2,9);
            selectbox2.setPosition(this.chessPos(5,0));
        }

        hand.setPosition(this.chessPos(targetpos.x,targetpos.y));

        clipnode.setStencil(node);

        var person=ELSGameTool.getInstance().guidePerson(str,30,ignore);
        bclayer.addChild(person);
        person.setPosition(cc.p(WINSIZE.width/2.0,WINSIZE.height*0.5));
    },

    checkChess:function () {
        var ttt;
        var eraselise=[];
        var map=this.getTopHeight();
        var smallh=FANGK_HEIGHT;
        for(var i=0;i<FANGK_WIDTH;i++){
            if(smallh>map[i])
                smallh=map[i];
        }

        for(var j=0;j<=smallh;j++){
            var tempb=true;
            for(var i=0;i<FANGK_WIDTH;i++){
                if(!this._chessfillinfo[i*FANGK_HEIGHT+j]){
                    tempb=false;
                    break;
                }
            }
            if(tempb)
                eraselise.push(j);
        }

        if(eraselise.length>0){
            var tt=this.rollEliminate(eraselise);
            var sc=(eraselise.length>1?eraselise.length*110:100)+10;
            this.scoreMotion(sc,cc.p(FANGK_WIDTH/2,eraselise[0]));
            
            this.runAction(new cc.Sequence(new cc.DelayTime(tt),new cc.CallFunc(function () {
                if(!this.levelUp()){
                    this.runAction(new cc.Sequence(new cc.DelayTime(CHESS_REMOVE_TIME),new cc.CallFunc(function () {
                        this.startDropBox();
                    }.bind(this))));
                }
            }.bind(this))));
            return true;
        }else{
            this.setScore(this.getScore()+10);

            if(!this.levelUp())
                this.startDropBox();
            return false;
        }
        
    },

    levelUp:function () {
        if(this.getScore()>=this.getTarget()&&!this._guide){
            wb.HjTaskManager.successGame(GameName[3],this.getScore());

            this.setLevel(this.getLevel()+1);
            this.setTarget(this.getScoreByLevel(this.getLevel()));

            this.unschedule(this.boxDropUpdate);
            this.schedule(this.boxDropUpdate,Math.max(0.2,(DROP_UPDATE_TIME+DROP_STOP_TIME)-this.getLevel()*0.02));

            this.setGameState(GameState.STATE_STOP);
            this.runAction(new cc.Sequence(new cc.DelayTime(1.0),new cc.CallFunc(function () {
                this.LevelUpMotion();
            }.bind(this))));
            return true;
        }
        return false;
    },

    //分数动画
    scoreMotion:function (score,pt) {
        this.setScore(this.getScore()+score);

        if(score>=100){
            var scorefnt=ELSGameTool.getInstance().getLabelAtlas(score.toString(),res.fnt_png1);
            scorefnt.setScale(1.5);
            this.addChild(scorefnt,15);
            scorefnt.setPosition(this.chessPos(pt.x,pt.y));
            scorefnt.runAction(new cc.Sequence(new cc.MoveBy(0.2,cc.p(0,TETRIS_SIZE_WIDTH)),new cc.CallFunc(function () {
                scorefnt.removeFromParent();
            })));
        }
    },

    rollEliminate:function (eraselise) {
        var ft=0.0;

        ELSGameTool.getInstance().playVideo(VIDEO[6]);

        this._moveh=[];
        for(var i=0;i<FANGK_HEIGHT;i++){
            this._moveh.push(0);
        }

        var action=[];
        for(var k in eraselise){
            var j=eraselise[k];
            for(var i=0;i<FANGK_WIDTH;i++){
                if(this._chessfillinfo[i*FANGK_HEIGHT+j]){
                    action.push(new cc.DelayTime(0.02));
                    action.push(new cc.CallFunc(function (target,data) {
                        this.addParticle(data.x,data.y);
                        this.removeBox(data.x,data.y);
                    }.bind(this),this,{x:i,y:j}));
                    ft+=0.02;
                }
            }

            for(var p=0;p<FANGK_HEIGHT;p++){
                if(p>j){
                    this._moveh[p]++;
                }
            }
        }

        action.push(new cc.DelayTime(0.2));
        action.push(new cc.CallFunc(function () {
            for(var i=0;i<FANGK_WIDTH;i++)
                for(var j=0;j<FANGK_HEIGHT;j++){
                    var box=this._clip.getChildByTag(i*FANGK_HEIGHT+j);
                    if(this._moveh[j]>0&&box){
                        var pos=box.getPosition();
                        box.runAction(new cc.MoveTo(CHESS_REMOVE_TIME*0.8,cc.p(pos.x,pos.y-this._moveh[j]*FANGK_SIZE_WIDTH)));
                        box.setTag(i*FANGK_HEIGHT+j-this._moveh[j]);
                        this._chessfillinfo[i*FANGK_HEIGHT+j-this._moveh[j]]=this._chessfillinfo[i*FANGK_HEIGHT+j];
                        this._chessfillinfo[i*FANGK_HEIGHT+j]=0;
                    }
                }
        }.bind(this)));

        this.runAction(new cc.Sequence(action));

        ft+=CHESS_REMOVE_TIME+0.2;
        return ft;

    },

    addParticle:function (x,y) {
      //  var key=this._chessfillinfo[x*FANGK_HEIGHT+y];
       // var index=(key-1)%5;
       // ELSGameTool.getInstance().addFkLizi(this,this.chessPos(x,y),index);
    },

    removeBox:function (x,y) {
        this._chessfillinfo[x*FANGK_HEIGHT+y]=0;
        this._clip.removeChildByTag(x*FANGK_HEIGHT+y);
    },

    //当前的层数
    getChessTop:function () {
        var k = 0;
        var top = this.getTopHeight();
        for (var i = 0; i < FANGK_WIDTH; i++)
        {
            if (top[i] > 0 || this._chessfillinfo[i*FANGK_HEIGHT] > 0)
                top[i]++;
            if (top[i] > k)
                k = top[i];
        }
        return k;
    },

    getTopHeight:function () {
        var topheight=[];
        for(var i=0;i<FANGK_WIDTH;i++){
            topheight[i]=-1;
            for(var j=(FANGK_HEIGHT-1);j>=0;j--){
                if(this._chessfillinfo[i*FANGK_HEIGHT+j]){
                    topheight[i]=j;
                    this._toph[i]=j;
                    break;
                }
            }
        }
        return topheight;
    },

    boxSure:function(){
        var ret=true;
        var boxfill=this.getBoxFill();
        for(var i in boxfill){
            var key=boxfill[i];
            if(key.y>(FANGK_HEIGHT-1))
                ret=false;

            if(key.y<FANGK_HEIGHT&&this._chessfillinfo[key.x*FANGK_HEIGHT+key.y]==0){
                var k=parseInt(this._recentBox%5)+1;
                var boxnode=new cc.Sprite(chesspng[k-1]);
                this._clip.addChild(boxnode,CHESSMAN_LEVEL,key.x*FANGK_HEIGHT+key.y);
                boxnode.setPosition(this.chessPos(key.x,key.y));
                boxnode.setScale(FANGK_CHESS_SCALE)
                this._chessfillinfo[key.x*FANGK_HEIGHT+key.y]=k;
            }
        }
        this._clip.removeChildByTag(RECENTTAG);
        this._recentBox=-1;
        this._scoretemppos=boxfill[0];

        return ret;
    },

    boxDropOneLine:function () {
        this._recentPos.y-=1;
        var recentbox=this._clip.getChildByTag(RECENTTAG);
        var pos=recentbox.getPosition();
        recentbox.setPosition(cc.p(pos.x,pos.y-FANGK_SIZE_WIDTH));
        return true;
    },

    PointTipRemove:function () {
        var removetip=[];
        var nowtip=new PointTip(this._recentBox,0,this._recentPos);
        for(var i in this._pointTipPair){
            var vec1=this._pointTipPair[i];
            for(var j=0;j<vec1.length;){
                var tip=null;
                var key=vec1[j];
                var tempdata=this.getPointPath(vec1[j]);
                if(tempdata){
                    tip=tempdata[tempdata.length-1];
                }
                else
                    tip=this._pointTipVec[key];

                if(this.getByAngle(nowtip,tip))
                    j++;
                else{
                    for(var i in this._pointTipPriority){
                        if(this._pointTipPriority[i]==key){
                            this._pointTipPriority.splice(i,1);
                            break;
                        }
                    }
                    removetip.push(key);
                    vec1.splice(j,1);
                }
            }
        }

        if(removetip.length>0){
            if(this._touchbox>0){
                if(removetip.indexOf(this._touchbox)!=-1){
                    this._touchbox=-1;
                    this.showTipWithId(this._recentPointNumber);
                }
            }else{
                this.showTipWithId(this._recentPointNumber);
            }
        }
    },

    showTipWithId:function (pairid) {
        this._PointTipLayer.removeAllChildren();
        var idvec=this._pointTipPair[pairid];
        for(var i in idvec){
            var pointTip=this._pointTipVec[idvec[i]];
            var box=new BoxNode(pointTip.shape,pointTip.angle);
            box.setLineModel();
            this._PointTipLayer.addChild(box);
            box.setOpacity(120);
            box.setPosition(this.chessPos(pointTip.position.x,pointTip.position.y));
        }
    },

    getByAngle:function (fronttip,targettip) {
        var frontfillvec=this.getBoxFill(fronttip);
        var buttony=FANGK_HEIGHT;
        var buttonx=0;
        for(var i in frontfillvec){
            var key=frontfillvec[i];
            if(key.y<buttony){
                buttony=key.y;
                buttonx=key.x;
            }
        }
        var targetfillvec=this.getBoxFill(targettip);
        var targety=FANGK_HEIGHT;
        var targetx=0;
        for(var i in targetfillvec){
            var key=targetfillvec[i];
            if(key.y<targety){
                targety=key.y;
                targetx=key.x;
            }
        }

        if(targety>buttony){
            return false;
        }

        var off=targetx-buttonx;
        var kk=1;
        if(off<0)
            kk=-1;
        for(var i=1;i<Math.abs(off);i++){
            for(var k in frontfillvec){
                var key=frontfillvec[k];
                if((key.y<FANGK_HEIGHT)&&this._chessfillinfo[(key.x+i*kk)*FANGK_SIZE_WIDTH+key.y])
                    return false;
            }
        }

        return true;
    },

    boxMoveJudge:function (dir,vec) {
        if(!vec)
            vec=cc.p(0,0);
         var boxfill=this.getBoxFill(vec);
         switch (dir){
             case DirectionIndex.DIRECTION_D:
                 for(var i in boxfill){
                     var key=boxfill[i];
                     if((0==key.y)||(key.y<=FANGK_HEIGHT&&this._chessfillinfo[key.x*FANGK_HEIGHT+key.y-1]>0))
                         return false;
                 }
                 break;
             case DirectionIndex.DIRECTION_R:
                 for(var i in boxfill){
                     var key=boxfill[i];
                     if((key.x==(FANGK_WIDTH-1))||(key.y<FANGK_HEIGHT&&this._chessfillinfo[(key.x+1)*FANGK_HEIGHT+key.y]>0))
                         return false;
                 }
                 break;
             case DirectionIndex.DIRECTION_L:
                 for(var i in boxfill){
                     var key=boxfill[i];
                     if((key.x==0)||(key.y<FANGK_HEIGHT&&this._chessfillinfo[(key.x-1)*FANGK_HEIGHT+key.y]>0))
                         return false;
                 }
                 break;
             default:
                 break;
         }
         return true;
    },

    getBoxFill:function (vec) {
        if(!vec)
            vec=cc.p(0,0);
        var boxfill=this._clip.getChildByTag(RECENTTAG).getBoxFill();
        for(var i in boxfill){
            boxfill[i].x+=this._recentPos.x+vec.x;
            boxfill[i].y+=this._recentPos.y+vec.y;
        }
        return boxfill;
    },

    getBoxFill2:function (tip) {
        var tempbox=new BoxNode(tip.shape,tip.angle);
        var boxfill=tempbox.getBoxFill();
        for(var i in boxfill) {
            boxfill[i].x+=tip.position.x;
            boxfill[i].y+=tip.position.y;
        }
        return boxfill;
    },

    getTipBoxFill:function (tip) {
        var tempbox=new BoxNode(tip.shape,tip.angle);
        var boxfill=tempbox.getBoxFill();
        for(var i in boxfill){
            boxfill[i].x+=tip.position.x;
            boxfill[i].y+=tip.position.y;
        }
        return boxfill;
    },

    //获取当前棋子的覆盖范围
    getRetBoxFill:function (vec) {
        if(!vec)
            vec=cc.p(0,0);
        var box=this._clip.getChildByTag(RECENTTAG);
        if(box){
            var boxfill=box.getBoxFill();
            for(var i in boxfill){
                boxfill[i].x+=this._recentPos.x+vec.x;
                boxfill[i].y+=this._recentPos.y+vec.y;
            }
            return boxfill;
        }
        return null;
    },
});