var FangkLayer=cc.Layer.extend({
    _nextbox:[],
    _nextBoxPosition:[],
    _stepnumber:0,
    ctor:function () {
        this._super();
        this._stepnumber=0;
        for(var i=0;i<3;i++){
            this._nextBoxPosition[i]=cc.p(137+150*i,980*(WINSIZE.height/1136));
            if(ELSGameLogic.getInstance().isFullScreen()){
                this._nextBoxPosition[i].y-=FULLSCENE_HEIGHT;
            }
        }

        ELSGameLogic.getInstance().setGameType(GameType.Type_Fangk);
        this.initLayer();
        this._manager=new FangkManager();
        this.addChild(this._manager);
        this._manager.run();
        this.dataUpdate();
        this.schedule(this.dataUpdate,0.1);
        var hbpos=cc.p(50,980*WINSIZE.height/1136.0);
        if(ELSGameLogic.getInstance().isFullScreen()){
            hbpos.y-=FULLSCENE_HEIGHT;
        }
        ELSGameLogic.getInstance().addLimitHb(this,hbpos);
        ELSGameLogic.getInstance().addReturnPage(2);
    },

    initLayer:function () {
        csb=ccs.load(res.FangkScene_json).node;
        this.addChild(csb);
        csb.setContentSize(WINSIZE);
        ccui.helper.doLayout(csb);

        var node=csb.getChildByName("node");
        if(ELSGameLogic.getInstance().isFullScreen()){
            var pos=node.getPosition();
            node.setPosition(cc.p(pos.x,pos.y-FULLSCENE_HEIGHT));
        }

        fnt_level=node.getChildByName("fnt_guanshu");
        fnt_score=node.getChildByName("fnt_fenshu");
        fnt_target=node.getChildByName("fnt_mbfs");

        wb.FW(node,"pause",function () {
            if(!this.getManager()._guide){
                var layer=new PauseLayer();
                this.addChild(layer,100);
                ELSGameTool.getInstance().playVideo(VIDEO[0]);
            }
        }.bind(this));

        var bt_rotate=new ccui.Button(res.rotate_png,res.rotate_png,res.rotate_png);
        this.addChild(bt_rotate);
        bt_rotate.setPosition(cc.p(575,this._nextBoxPosition[0].y));
        bt_rotate.addClickEventListener(function () {
            this.getManager().Rotate();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
    },

    getManager:function () {
        return this._manager;
    },

    restart:function () {
        FKuaiTempData.getInstance().clear();
        this._stepnumber=0;
        for(var i=0;i<3;i++)
            this.removeChildByTag(15+i);

        this._manager.removeFromParent();
        this._manager=null;
        this._manager=new FangkManager();
        this.addChild(this._manager);
        this._manager.run();
    },

    dataUpdate:function (ft) {
        fnt_level.setString(this.getManager().getLevel().toString());
        fnt_score.setString(this.getManager().getScore().toString());
        fnt_target.setString(this.getManager().getTarget().toString());

        if(this.getManager().getStepNumber()!=this._stepnumber&&this.getManager().getStepNumber()>0){
            this._stepnumber=this.getManager().getStepNumber();
            if(this._stepnumber==1){
                for(var i=0;i<3;i++){
                    var nextbox=new BoxNode(this.getManager().getNBox(i));
                    nextbox.setScale(0.5);
                    this.addChild(nextbox,3,15+i);
                    nextbox.setPosition(nextbox.getCenterAnPoint(this._nextBoxPosition[i]));
                }
            }else{
                this.removeChildByTag(15);
                for(var i=0;i<2;i++){
                    var box=this.getChildByTag(16+i);
                    box.setTag(15+i);
                    box.runAction(new cc.moveBy(0.1,cc.p(-150,0)));
                }
                var nextbox=new BoxNode(this.getManager().getNBox(2));
                nextbox.setScale(0.5);
                this.addChild(nextbox,4,17);
                nextbox.setVisible(false);
                nextbox.setPosition(nextbox.getCenterAnPoint(this._nextBoxPosition[2]));
                nextbox.runAction(new cc.Sequence(new cc.DelayTime(0.1),new cc.Show()));
            }
        }
    },
    
})

var FangkScene=cc.Scene.extend({
    onEnter:function () {
        this._super();

        var layer=new FangkLayer();
        this.addChild(layer,1,"layer");
    }
});