var CustomTableViewCell = cc.TableViewCell.extend({
    ctor: function (ctx) {
        this._super(ctx);
    }
});

var RankList=cc.Layer.extend({
    _pos:null,
    _rankid:0,
    _ranklist:null,
    ctor:function(pos,id){
        this._super();
        this._pos=pos;
        this._rankid=id;
        this._ranklist=RankData.getInstance().getRankData(id);
        this.init();
    },

    init:function(){
          var tableView=new cc.TableView(this,cc.size(540,360*(WINSIZE.height/1136.0)));
          tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
          tableView.setDelegate(this);
          tableView.setPosition(this._pos);
          tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
          this.addChild(tableView);

          tableView.reloadData();
          return true;
    },

    //设置点击cell的回调函数
    tableCellTouched:function(table,cell){
        cc.log("cell touched at index: "+cell.getIdx());
    },

    //设置cell的大小
    tableCellSizeForIndex:function(table,idx){
        return cc.size(540,96);
    },

    //添加cell
    tableCellAtIndex:function(table,idx){
        var strValue=idx.toFixed(0);

        //获得一个cell，滑动cell的时候会执行这个方法，把没有显示（没渲染）的cell拿过来，更改内容，为了减小内存的开销
        var cell=table.dequeueCell();
        var ranknode;
        if(!cell){
            cell=new cc.TableViewCell();
            ranknode=ccs.load(res.rankcell_json).node;
            ranknode.tag=123;
            ranknode.x=270;
            ranknode.y=48;
            cell.addChild(ranknode);
            this.setTabelCell(ranknode,idx);
        }else{
            ranknode=cell.getChildByTag(123);
            this.setTabelCell(ranknode,idx);
        }
        return cell;
    },

    //设置cell
    setTabelCell:function(cell,idx){
        var kk=this._ranklist.length-4-idx;
        var data=this._ranklist[kk];
        var level=cell.getChildByName("level");
        if(level){
            var kkk=Math.min(50,this._ranklist.length);
            level.setString((idx+4).toString());
        }

        var name=cell.getChildByName("name");
        if(name){
            name.setString(data.name);
        }

        var score=cell.getChildByName("score");
        if(score){
            score.setString("分数:"+data.score);
        }

        var touxiang=cell.getChildByName("picture");
        if(touxiang){
            if(data.isuser){
                touxiang.loadTexture(GameUserInfo.getInstance().getUserTx());
            }else{
                touxiang.loadTexture(data.image);
            }
        }

        var zsnode=cell.getChildByName("zsnode");
        if(zsnode){
            if((idx+4)>=4&&(idx+4)<=10)
                zsnode.getChildByName("zsnum").setString("x30");
            else if((idx+4)>10)
                zsnode.getChildByName("zsnum").setString("x10");
        }
    },

    //设置cell个数
    numberOfCellsInTableView:function(table){
        var num = this._ranklist.length - 3;
        if (num < 0)
            return 0;
        else if (num >= 47)
            return 47;
    },
})
