var AngleNode=cc.Node.extend({
    _boxfill:[],
    _box:[],
    _id:0,
    _boxcolor:ColorIndex.BOX_NORMAL,
    ctor:function (id) {
        this._super();

        this._boxfill=[];
        this._box=[];
        this._boxcolor=ColorIndex.BOX_NORMAL;
        this._id=id;
        this.initNode();
    },

    initNode:function () {
        this._boxfill.push(cc.p(0,0));
        switch (this._id){
            case 1:
                break;
            case 2:
                this._boxfill.push(cc.p(1,0));
                this._boxfill.push(cc.p(1,1));
                break;
            case 3:
                this._boxfill.push(cc.p(0,1));
                this._boxfill.push(cc.p(1,1));
                break;
            case 4:
                this._boxfill.push(cc.p(0,1));
                this._boxfill.push(cc.p(0,2));
                break;
            case 5:
                this._boxfill.push(cc.p(1,1));
                this._boxfill.push(cc.p(2,2));
                break;
            case 6:
                this._boxfill.push(cc.p(-1,0));
                this._boxfill.push(cc.p(1,0));
                break;
            case 7:
                this._boxfill.push(cc.p(-1,0));
                this._boxfill.push(cc.p(1,0));
                this._boxfill.push(cc.p(2,0));
                break;
            case 8:
                this._boxfill.push(cc.p(0,1));
                this._boxfill.push(cc.p(0,2));
                this._boxfill.push(cc.p(0,3));
                break;
            case 9:
                this._boxfill.push(cc.p(1,1));
                this._boxfill.push(cc.p(2,2));
                this._boxfill.push(cc.p(3,3));
                break;
            case 10:
                this._boxfill.push(cc.p(-1,0));
                this._boxfill.push(cc.p(1,0));
                this._boxfill.push(cc.p(2,1));
                break;
            case 11:
                this._boxfill.push(cc.p(0,1));
                this._boxfill.push(cc.p(1,0));
                this._boxfill.push(cc.p(2,0));
                break;
            case 12:
                this._boxfill.push(cc.p(1,1));
                this._boxfill.push(cc.p(2,2));
                this._boxfill.push(cc.p(2,1));
                break;
            case 13:
                this._boxfill.push(cc.p(0,1));
                this._boxfill.push(cc.p(0,2));
                this._boxfill.push(cc.p(-1,1));
                break;
            case 14:
                this._boxfill.push(cc.p(1,0));
                this._boxfill.push(cc.p(1,1));
                this._boxfill.push(cc.p(2,1));
                break;
            case 15:
                this._boxfill.push(cc.p(0,1));
                this._boxfill.push(cc.p(1,0));
                this._boxfill.push(cc.p(1,1));
                break;
            case 16:
                this._boxfill.push(cc.p(1,1));
                this._boxfill.push(cc.p(2,0));
                this._boxfill.push(cc.p(2,1));
                break;
            case 17:
                this._boxfill.push(cc.p(1,0));
                this._boxfill.push(cc.p(0,1));
                this._boxfill.push(cc.p(2,1));
                break;
            default:
                break;
        }
        for(var i in this._boxfill){
            var pos=this._boxfill[i];
            var sp=new cc.Sprite(ljchess[parseInt(this._id/2)]);
            this.addChild(sp,1,parseInt(i));
            sp.setPosition(cc.p(pos.x*LIUJIAO_SIZE_WIDTH-pos.y/2*LIUJIAO_SIZE_WIDTH,pos.y*LIUJIAO_SIZE_Height));
            this._box.push(sp);
        }
    },

    //X轴居中
    getCenterAnPointX:function(vec){
        var ret;
        var offestpos=cc.p(0,0);
        switch (this._id){
            case 1:
            case 3:
            case 6:
            case 1:
                offestpos=cc.p(0,0);
                break;
            case 2:
            case 5:
            case 7:
            case 10:
            case 11:
            case 14:
            case 17:
                offestpos=cc.p(-0.5,0);
                break;
            case 4:
                offestpos=cc.p(0.5,0);
                break;
            case 8:
            case 13:
                offestpos=cc.p(1,0);
                break;
            case 9:
            case 12:
            case 16:
                offestpos=cc.p(-1,0);
                break;
            default:
                break;
        }
        var sc=this.getScale();
        ret=cc.p(vec.x+(offestpos.x*LIUJIAO_SIZE_WIDTH)*sc,vec.y+(offestpos.y*LIUJIAO_SIZE_WIDTH)*sc+LIUJIAO_SIZE_WIDTH*0.5);
        return ret;
    },

    setGray:function () {
        if(this._boxcolor==ColorIndex.BOX_GRAY)
            return;
        this._boxcolor=ColorIndex.BOX_GRAY;
        for(var i in this._box){
            var node=this._box[i];
            if(node){
                node.setVisible(false);
                var graynode=this.getChildByTag(100+parseInt(i));
                if(graynode){
                    graynode.setVisible(true);
                }else{
                    var gnode=new cc.Sprite(ljchess[9]);
                    this.addChild(gnode,0,100+parseInt(i));
                    gnode.setScale(LIUJIAO_CHESS_SCALE);
                    gnode.setPosition(node.getPosition());
                }
            }
        }
    },

    setNormal:function () {
        if(this._boxcolor==ColorIndex.BOX_NORMAL){
            return;
        }

        this._boxcolor=ColorIndex.BOX_NORMAL;
        for(var i in this._box){
            var node=this._box[i];
            if(node){
                node.setVisible(true);
                var graynode=this.getChildByTag(100+parseInt(i));
                if(graynode){
                    graynode.setVisible(false);
                }
            }
        }
    },

    setNodeOpacity:function (key) {
        for(var i in this._box) {
            var node = this._box[i];
            if (node) {
                node.setOpacity(key);
            }
            var graynode=this.getChildByTag(100+parseInt(i));
            if(graynode){
                graynode.setOpacity(key);
            }
        }
    },

})