LIUJIAO_CHESS_SCALE=76.0/64.0;

var CHESSPROP=[80,100,100,150,150,150,60,60,60,50,50,50,50,80,80,50,50];

var LjManager=GameLayer.extend({
    _allnodetype:[],
    _clip:null,
    _tempshowblack:[],
    _chessInfo:[],
    _chessBack:[],
    _selectExit:[],
    _touchselect:0,
    _chesstippos:cc.p(-1,-1),
    _typeid:[],
    _firstsavein:false,
    _guide:false,
    _guidenumber:0,
    ctor:function () {
        this._super();

        this.init();
    },

    init:function () {
        selectboxoffes=BANER_HEIGHT;
        heightoffest=WINSIZE.height*0.32+10;
        if(ELSGameLogic.getInstance().isFullScreen()){
            heightoffest+=30;
        }
        selectboxsize=0.5;
        nextboxoffest=202;
        nextboxbegin=118;
        chessfilltime = 0.1;
        boxtofiger=60;
        shadomscale = 0.95;

        this._guide=ELSGameData.getInstance().getGameGuide(GameName[4]);
        this._guidenumber=0;

        this.initAllNodeType();
        this.initChess();

        this._tempshowblack=[];
        this._chessInfo=[];
        for(var i=0;i<LIUJIAO_WIDTH;i++)
            for(var j=0;j<LIUJIAO_HEIGHT;j++){
                this._chessInfo.push(0);
            }
        for(var i=0;i<3;i++)
            this._selectExit[i]=false;

        this.setTouchState(TouchState.TOUCH_TRUE);
        this.setScore(0);

        this.setLastData();

        this.startNewRound();

        if(this._guide){
            this._guidenumber=1;
            this.guideChess();
            for(var i=0;i<LIUJIAO_WIDTH;i++)
                for(var j=0;j<LIUJIAO_HEIGHT;j++){
                    if(this._chessInfo[i*LIUJIAO_HEIGHT+j]>0){
                        var box=new cc.Sprite(ljchess[this._chessInfo[i*LIUJIAO_HEIGHT+j]-1]);
                        this.addChild(box,CHESSMAN_LEVEL,i*LIUJIAO_HEIGHT+j);
                        box.setPosition(this.chessPos(i,j));
                        box.setScale(LIUJIAO_CHESS_SCALE);
                    }
                }

            this.runAction(new cc.Sequence(new cc.DelayTime(2.0),new cc.CallFunc(function () {
                this.GameGuide();
            }.bind(this))));

            this.guideTip(1);
        }

        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: this.onTouchBegan,
            onTouchMoved: this.onTouchMoved,
            onTouchEnded: this.onTouchEnded
        },this);
    },

    guideTip:function (key) {
        var sst=gxpng[3];
        if(key==2){
            sst=gxpng[4];
        }
        var fnt2=new cc.Sprite(sst);
        this.addChild(fnt2,CHESSMAN_LEVEL+100);
        fnt2.setPosition(cc.p(WINSIZE.width/2,680));
        fnt2.runAction(new cc.Sequence(new cc.MoveBy(0.3,cc.p(0,60)),new cc.DelayTime(0.2),new cc.ScaleTo(0.2,1.1),new cc.DelayTime(0.5),new cc.FadeOut(0.3),new cc.CallFunc(function () {
            fnt2.removeFromParent();
        }.bind(this))));
    },

    GameGuide:function () {
        var bclayer=new cc.LayerColor(cc.color(0,0,0,200),WINSIZE.width,WINSIZE.height);
        cc.director.getRunningScene().addChild(bclayer,100,BCLAYERTAG);

        var node=new cc.Node();
        var str=new Array();
        var ignore=false;
        str.push("拖动方块到上方区域");
        str.push("横竖满格才能消除");

        var hand=new cc.Sprite(wb.appendSceneStr("res/spine/shouzhi.png"));
        hand.setAnchorPoint(cc.p(0.15,0.9));
        bclayer.addChild(hand,10);

        var targetpos;
        var pos;
        var type;

        var peopleh=0.0;
        if(this._guidenumber==1){
            pos=cc.p(nextboxbegin,selectboxoffes+20);
            targetpos=cc.p(1,4);
            type=7;
            peopleh=0.7;
        }else if(this._guidenumber==2){
            pos=cc.p(nextboxbegin+nextboxoffest,selectboxoffes+20);
            targetpos=cc.p(5,5);
            type=9;
            peopleh=0.4;
        }else if(this._guidenumber==3){
            pos=cc.p(nextboxbegin+2*nextboxoffest,selectboxoffes+20);
            targetpos=cc.p(3,3);
            type=2;
            peopleh=0.7;
        }

        var selectbox=new AngleNode(type);
        selectbox.setScale(selectboxsize);
        bclayer.addChild(selectbox,9);
        selectbox.setPosition(selectbox.getCenterAnPointX(cc.p(nextboxbegin+nextboxoffest*(this._guidenumber-1),selectboxoffes)));

        var selectbox2=new AngleNode(type);
        bclayer.addChild(selectbox2,9);
        selectbox2.setPosition(this.chessPos(targetpos.x,targetpos.y));
        selectbox2.setGray();
        selectbox2.setNodeOpacity(120);

        hand.setPosition(pos);
        var seq1=new cc.Sequence(new cc.DelayTime(0.5),new cc.MoveTo(1.0,this.chessPos(targetpos.x,targetpos.y)));
        var seq2=new cc.Sequence(new cc.DelayTime(0.5),new cc.MoveTo(0.0,pos));
        hand.runAction(new cc.RepeatForever(new cc.Sequence(seq1,seq2)));

        var person=ELSGameTool.getInstance().guidePerson(str,30,ignore);
        bclayer.addChild(person);
        person.setPosition(cc.p(WINSIZE.width/2.0,WINSIZE.height*peopleh));
    },

    //引导初始棋盘
    guideChess:function () {
        var vec=[1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,3,3,3,3,0,0,0,0,4,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,4,0,0,0,0,];
        for(var i=0;i<LIUJIAO_WIDTH;i++)
            for(var j=0;j<LIUJIAO_HEIGHT;j++){
                this._chessInfo[i*LIUJIAO_HEIGHT+j]=vec[i*LIUJIAO_HEIGHT+j];
            }
    },

    //恢复上次存档
    setLastData:function () {
        var lastdata=LJTempData.getInstance().getSaveData();
        if(lastdata._issaved){
            this._firstsavein=true;
            this.setScore(lastdata._score);
            var chessinfo=lastdata._chesspad;
            for(var i=0;i<LIUJIAO_WIDTH;i++)
                for(var j=0;j<LIUJIAO_HEIGHT;j++) {
                    var k=parseInt(chessinfo[i*LIUJIAO_HEIGHT+j]);
                    if(k>0){
                        var box=new cc.Sprite(ljchess[k-1]);
                        this.addChild(box,CHESSMAN_LEVEL,i*LIUJIAO_HEIGHT+j);
                        box.setPosition(this.chessPos(i,j));
                        box.setScale(LIUJIAO_CHESS_SCALE);
                        this._chessInfo[i*LIUJIAO_HEIGHT+j]=k;
                    }
                }
            var chessid=lastdata._chessid;
            var id="";
            var order=0;
            for(var i in chessid){
                if(chessid[i]==='#'){
                    var key=parseInt(id);
                    if(key==0){
                        this._selectExit[order]=false;
                    }else{
                        this._selectExit[order]=true;
                        key--;
                    }
                    this._typeid[order]=key;
                    order++;
                    id="";
                    if(order===3){
                        break;
                    }
                }else{
                    id+=chessid[i];
                }
            }

        }
    },

    start:function () {
        this.setGameState(GameState.STATE_RUN);
    },

    run:function () {
        this.setGameState(GameState.STATE_RUN);
    },

    Rotate:function (key) {
        for(var i=0;i<3;i++){
            this.removeChildByTag(10000+i);
            this._selectExit[i]=false;
        }

        this.startNewRound(key);
        if(key==1)
            this.BoxFillJudge();
    },

    restart:function () {
        this.setGameState(GameState.STATE_RUN);
        this.setTouchState(TouchState.TOUCH_TRUE);
        this.setScore(0);
        for(var i=0;i<LIUJIAO_WIDTH;i++)
            for(var j=0;j<LIUJIAO_HEIGHT;j++){
                if(this._chessInfo[i*LIUJIAO_HEIGHT+j]>0){
                    this.removeChildByTag(i*LIUJIAO_HEIGHT+j);
                    this._chessInfo[i*LIUJIAO_HEIGHT+j]=0;
                }
            }
        this.Rotate(1);
    },

    resurrenction:function () {
        this.setGameState(GameState.STATE_RUN);
        this.Rotate(2);
        this.runAction(new cc.Sequence(new cc.DelayTime(0.1),new cc.CallFunc(function () {
            this.BoxFillJudge();
            this.setTouchState(TouchState.TOUCH_TRUE);
        }.bind(this))));
    },

    onTouchBegan:function (touch,event) {
        var startpos=touch.getLocation();
        var target=event.getCurrentTarget();

        if (target.getGameState() != GameState.STATE_RUN || target.getTouchState() != TouchState.TOUCH_TRUE || target._touchselect>0){
            if(target._touchselect>0&&target.getTouchState()==TouchState.TOUCH_TRUE){
                target.endTouch();
            }
            return false;
        }

        target._touchselect=0;
        if (startpos.y > 0 && startpos.y < heightoffest&&startpos.x)
        {
            var k = parseInt((startpos.x - nextboxbegin) / nextboxoffest + 0.5);
            if (k >= 0 && k < 3 && target._selectExit[k])
            {
                if(target._guide){
                    if(k==(target._guidenumber-1)){
                        var lay=cc.director.getRunningScene().getChildByTag(BCLAYERTAG);
                        if(lay){
                            lay.setVisible(false);
                        }else{
                            return false;
                        }
                    }else{
                        return false;
                    }
                }
                target._touchselect = k + 1;
                var box = target.getChildByTag(10000+k);
                if (box._boxcolor==ColorIndex.BOX_NORMAL)
                {
                    box.stopAllActions();
                    var pos=box.getCenterAnPointX(startpos);
                    box.setPosition(cc.p(pos.x,pos.y+boxtofiger));
                    box.setScale(shadomscale);
                    return true;
                }
                else
                {
                    target._touchselect = 0;
                    return false;
                }
            }
        }
        return false;
    },

    onTouchMoved:function (touch,event) {
        var recentpos=touch.getLocation();
        var target=event.getCurrentTarget();

        if(target._touchselect<0||target.getTouchState()==TouchState.TOUCH_FAILD)
            return;

        var selectbox=target.getChildByTag(10000+target._touchselect-1);
        var pos=selectbox.getCenterAnPointX(recentpos);
        selectbox.setPosition(cc.p(pos.x,pos.y+boxtofiger));

        target.showTipBox(selectbox);
    },

    onTouchEnded:function (touch,event) {
        var target=event.getCurrentTarget();
        if(target._touchselect<=0||target.getTouchState()==TouchState.TOUCH_FAILD)
            return;

        target.endTouch();
    },

    showTipBox:function (box) {
        var fillvec=this.getFillBlack(box,box.getPosition());
        if(fillvec.length>0){
            if(fillvec[0]!=this._chesstippos){
                for(var i in this._tempshowblack){
                    this.removeChildByTag(1000+this._tempshowblack[i].x*LIUJIAO_HEIGHT+this._tempshowblack[i].y);
                }
                this._tempshowblack=[];
                this._chesstippos=fillvec[0];
                for(var i in fillvec){
                    var sp=new cc.Sprite(ljchess[parseInt(box._id/2)]);
                    this.addChild(sp,CHESSMAN_LEVEL-1,1000+fillvec[i].x*LIUJIAO_HEIGHT+fillvec[i].y);
                    var pos=this.chessPos(fillvec[i].x,fillvec[i].y);
                    sp.setPosition(this.chessPos(fillvec[i].x,fillvec[i].y));
                    sp.setOpacity(120);
                }

                this._tempshowblack=fillvec.concat();
            }
        }else{
            for(var i in this._tempshowblack){
                this.removeChildByTag(1000+this._tempshowblack[i].x*LIUJIAO_HEIGHT+this._tempshowblack[i].y);
            }
            this._tempshowblack=[];
            this._chesstippos=this.chessPt(box.getPosition());
        }
    },

    endTouch:function () {
        this.removeTipBox();
        this.setTouchState(TouchState.TOUCH_FAILD);
        var box=this.getChildByTag(10000+this._touchselect-1);
        var fillvec=this.getFillBlack(box,box.getPosition());

        var guideposjudge=true;
        if(this._guide){
            var boxpos=this.chessPt(box.getPosition());
            if(this._guidenumber==1){
                if(boxpos.x!=1||boxpos.y!=4){
                    guideposjudge=false;
                }
            }else if(this._guidenumber==2){
                if(boxpos.x!=5||boxpos.y!=5){
                    guideposjudge=false;
                }
            }else if(this._guidenumber==3){
                if(boxpos.x!=3||boxpos.y!=3){
                    guideposjudge=false;
                }
            }
        }

        if(!fillvec||fillvec.length==0||!guideposjudge){
            if(this._guide){
                var lay=cc.director.getRunningScene().getChildByTag(BCLAYERTAG);
                if(lay){
                    lay.setVisible(true);
                }
            }

            box.setScale(selectboxsize);
            var resvec=cc.p(nextboxbegin+nextboxoffest*(this._touchselect-1),selectboxoffes);
            box.runAction(new cc.Sequence(new cc.MoveTo(0.1,box.getCenterAnPointX(resvec)),new cc.CallFunc(function () {
                this._touchselect=0;
                this.setTouchState(TouchState.TOUCH_TRUE);
            }.bind(this))));
        }else{
            if(this._guide){
                var lay=cc.director.getRunningScene().getChildByTag(BCLAYERTAG);
                lay.removeFromParent();

                if(this._guidenumber==3){
                    this.endGuide();
                }else{
                    this._guidenumber++;
                    this.runAction(new cc.Sequence(new cc.DelayTime(1.0),new cc.CallFunc(function () {
                        this.GameGuide();
                    }.bind(this))));
                }
            }

            ELSGameTool.getInstance().playVideo(VIDEO[12]);

            box.runAction(new cc.Sequence(new cc.MoveTo(0.01,this.chessPos(fillvec[0].x,fillvec[0].y)),new cc.CallFunc(function(){
                box.removeFromParent();
                this._selectExit[this._touchselect-1]=false;
                this.startNewRound();
                this._touchselect=0;
                this.chessFill(box._id,fillvec);
                this.runAction(new cc.Sequence(new cc.DelayTime(chessfilltime),new cc.CallFunc(function () {
                    var time=chessfilltime+this.chessCheck();
                    this.runAction(new cc.Sequence(new cc.DelayTime(time),new cc.CallFunc(function () {
                        this.BoxFillJudge();
                        this.faildJudge();
                    }.bind(this))));
                }.bind(this))));
            }.bind(this))));
        }
    },

    //结束引导
    endGuide:function () {
        this.guideTip(2);
        this._guide=false;
        ELSGameData.getInstance().setGameGuide(GameName[4],false);
    },

    BoxFillJudge:function(){
        for(var i=0;i<3;i++){
            if(this._selectExit[i]){
                var box=this.getChildByTag(10000+i);
                if(this.BoxJudge(box))
                    box.setNormal();
                else
                    box.setGray();
            }
        }
    },

    faildJudge:function () {
        if(this.chessFailedJudge()){
            this.runAction(new cc.Sequence(new cc.DelayTime(0.2),new cc.CallFunc(function () {
                this.gameFaild();
            }.bind(this))))
            LJTempData.getInstance().clear();
            return true;
        }else{
            this.setTouchState(TouchState.TOUCH_TRUE);
        }
    },

    chessFailedJudge:function () {
        for(var i=0;i<3;i++){
            if(this._selectExit[i]){
                var box=this.getChildByTag(10000+i);
                if(box._boxcolor==ColorIndex.BOX_NORMAL){
                    return false;
                }
            }
        }
        return true;
    },

    gameFaild:function () {
        cc.log("game failed");
        var lay=new FaildLayer();
        this.getParent().addChild(lay,100);
    },

    chessCheck:function () {
        var eliminatex=[];
        var eliminatey=[];
        var eliminatez=[];
        for(var i=0;i<LIUJIAO_WIDTH;i++){
            var temp=true;
            for(var j=0;j<LIUJIAO_HEIGHT;j++){
                if(this._chessInfo[i*LIUJIAO_HEIGHT+j]==0&&this._chessBack[i*LIUJIAO_HEIGHT+j]){
                    temp=false;
                }
            }
            if(temp){
                eliminatex.push(i);
            }
        }

        for(var j=0;j<LIUJIAO_HEIGHT;j++){
            var temp=true;
            for(var i=0;i<LIUJIAO_WIDTH;i++){
                if(this._chessInfo[i*LIUJIAO_HEIGHT+j]==0&&this._chessBack[i*LIUJIAO_HEIGHT+j]){
                    temp=false;
                }
            }
            if(temp){
                eliminatey.push(j);
            }
        }

        for(var i=-4;i<=4;i++){
            var temp=true;
            for(var j=0;j<9;j++){
                if(((i+j)>=0)&&(i+j)<LIUJIAO_WIDTH&&(this._chessInfo[(i+j)*LIUJIAO_HEIGHT+j]==0)&&(this._chessBack[(i+j)*LIUJIAO_HEIGHT+j])){
                    temp=false;
                    break;
                }
            }
            if(temp){
                eliminatez.push(i);
            }
        }

        if (eliminatex.length>0 || eliminatey.length>0||eliminatez.length>0) {
            return this.eliminateAnimation(eliminatex, eliminatey,eliminatez);
        }
        else
            return 0.0;
    },

    eliminateAnimation:function (vx,vy,vz) {
        var ftime=0.02;
        var orign=this._score;
        var action=[];
        if(vx.length>0){
            for(var i in vx){
                for(var j=0;j<LIUJIAO_HEIGHT;j++){
                    if(this._chessInfo[vx[i]*LIUJIAO_HEIGHT+j]){
                        if(j!=0){
                            action.push(new cc.DelayTime(0.02));
                        }
                        action.push(new cc.CallFunc(function (t,data) {
                            this.addParticle(data.kx,data.ky);
                            this.removeBox(data.kx,data.ky);
                        }.bind(this),this,{kx:vx[i],ky:j}))
                        ftime+=0.02;
                    }
                }
            }
        }

        if(vy.length>0){
            for(var j in vy){
                for(var i=0;i<LIUJIAO_WIDTH;i++){
                    if(vx.length==0||vx.indexOf(i)==-1){
                        if(i!=0){
                            action.push(new cc.DelayTime(0.02));
                        }
                        action.push(new cc.CallFunc(function (t,data) {
                            this.addParticle(data.kx,data.ky);
                            this.removeBox(data.kx,data.ky);
                        }.bind(this),this,{kx:i,ky:vy[j]}));
                        ftime+=0.02;
                    }
                }
            }
        }

        if(vz.length>0){
            for(var z in vz){
                for(var k=0;k<9;k++){
                    if(vx.indexOf(vz[z]+k)==-1&&vy.indexOf(k)==-1){
                        if((vz[z]+k)>=0&&(vz[z]+k)<LIUJIAO_WIDTH&&this._chessInfo[(vz[z]+k)*LIUJIAO_HEIGHT+k]){
                            if(k!=0){
                                action.push(new cc.DelayTime(0.02));
                            }
                            action.push(new cc.CallFunc(function (t,data) {
                                this.addParticle(data.kx,data.ky);
                                this.removeBox(data.kx,data.ky);
                            }.bind(this),this,{kx:vz[z]+k,ky:k}));
                            ftime+=0.02;
                        }
                    }
                }
            }
        }

        var xynum=vx.length+vy.length+vz.length;
        if(xynum>0){
            this._score+=this.getScoreByRow(xynum);
            ELSGameTool.getInstance().playVideo(VIDEO[6]);
        }

        if(action.length>0)
            this.runAction(new cc.Sequence(action));

        return ftime;
    },

    getScoreByRow:function (num) {
        var res = 0;
        if (num == 1) {
            res = 100;
        }
        else if (num == 2) {
            res = 300;
        }
        else if (num == 3) {
            res = 800;
        }
        else if (num == 4) {
            res = 1500;
        }
        else if (num == 5) {
            res = 2500;
        }
        else if (num == 6) {
            res = 4000;
        }
        else if (num == 7) {
            res = 6000;
        }
        else if (num == 8) {
            res = 10000;
        }
        return res;
    },

    removeBox:function (x,y) {
        this.removeChildByTag(x*LIUJIAO_HEIGHT+y);
        this._chessInfo[x*LIUJIAO_HEIGHT+y]=0;
    },

    addParticle:function (i,j) {
        var key=this._chessInfo[i*LIUJIAO_HEIGHT+j];
        ELSGameTool.getInstance().addFkLizi(this,this.chessPos(i,j),key,1.0,3);
    },

    removeTipBox:function () {
        for(var i in this._tempshowblack){
            this.removeChildByTag(1000+this._tempshowblack[i].x*LIUJIAO_HEIGHT+this._tempshowblack[i].y);
        }
        this._tempshowblack=[];
        this._chesstippos=cc.p(-1,-1);
    },

    getFillBlack:function (node,pt) {
        var vec=[];
        var centerpos = this.chessPt(cc.p(pt.x,pt.y));
        var centerx = centerpos.x;
        var centery = centerpos.y;
        if (centerx<0 || centery<0 || centerx>LIUJIAO_WIDTH || centery>LIUJIAO_HEIGHT)
        {
            //
        }
        else
        {
            var fillvec = node._boxfill;
            for (var i in fillvec) {
                var px=fillvec[i].x+centerx;
                var py=fillvec[i].y+centery;
                if (px < 0 || px >= LIUJIAO_WIDTH || py < 0 || py >= LIUJIAO_HEIGHT || this._chessInfo[px*LIUJIAO_HEIGHT + py]||!this._chessBack[px*LIUJIAO_HEIGHT+py]) {
                    vec=[];
                    break;
                }
                else {
                    vec.push(cc.p(px,py));
                }
            }
        }
        return vec;
    },

    chessFill:function (id,vec) {
        for(var i in vec){
            var box=new cc.Sprite(ljchess[parseInt(id/2)]);
            this.addChild(box,CHESSMAN_LEVEL,vec[i].x*LIUJIAO_HEIGHT+vec[i].y);
            box.setPosition(this.chessPos(vec[i].x,vec[i].y));
            this._chessInfo[vec[i].x*LIUJIAO_HEIGHT+vec[i].y]=parseInt(id/2)+1;
            box.runAction(new cc.Sequence(new cc.ScaleTo(0.1,1.05*LIUJIAO_CHESS_SCALE),new cc.ScaleTo(0.05,LIUJIAO_CHESS_SCALE)));
            this.setScore(this.getScore()+10);
        }
    },

    NodeType:function (type,angle) {
        var ttype=type?type:ShapeIndex.POINT_SHAPE;
        var tangle=angle?angle:AngleIndex.ANGLE_0;
        return {shape:ttype,angle:tangle};
    },

    //初始化所有图形
    initAllNodeType:function () {
        this._allnodetype.push(this.NodeType(ShapeIndex.POINT_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINETWO_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINETWO_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.ANGLE_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.ANGLE_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINESMALL_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINESMALL_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.SQUARE_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINE_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINE_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.L_RESHAPE,AngleIndex.ANGLE_270));
        this._allnodetype.push(this.NodeType(ShapeIndex.L_SHAPE,AngleIndex.ANGLE_270));
        this._allnodetype.push(this.NodeType(ShapeIndex.T_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.T_SHAPE,AngleIndex.ANGLE_270));
        this._allnodetype.push(this.NodeType(ShapeIndex.SWAGER_RESHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.SWAGER_RESHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LBIG_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LBIG_SHAPE,AngleIndex.ANGLE_180));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINEFINE_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINEFINE_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.TEN_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.U_SHAPE,AngleIndex.ANGLE_270));
        this._allnodetype.push(this.NodeType(ShapeIndex.U_SHAPE,AngleIndex.ANGLE_180));
        this._allnodetype.push(this.NodeType(ShapeIndex.W_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.TBIG_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.SQUAREBIG_SHAPE));
    },

    //初始化棋盘
    initChess:function () {
        for(var i=0;i<LIUJIAO_WIDTH;i++){
            for(var j=0;j<LIUJIAO_HEIGHT;j++){
                var temp=false;
                if(i<5){
                    if(j<=(4+i))
                        temp=true;
                }else{
                    if(j>=(i-4))
                        temp=true;
                }
                if(temp){
                    var pos=this.chessPos(i,j);
                    var temp=0;
                    if ((i == 1 && j == 5) || (i == 2 && j == 6) || (i == 3 && j == 7)||(i==4&&j==8))
                        temp = 1;
                    else if ((i == 5 && j == 1) || (i == 6 && j == 2) || (i == 7 && j == 3)||(i==4&&j==0))
                        temp = 2;
                    else if (j == 0)
                        temp = 3;
                    else if (j == (LIUJIAO_HEIGHT - 1))
                        temp = 4;
                    else if (i == 0)
                        temp = 5;
                    else if (i == (LIUJIAO_WIDTH - 1))
                        temp = 6;

                    if(temp>0){
                        var spdi=new cc.Sprite(ljchess[10]);
                        this.addChild(spdi);
                        spdi.setPosition(pos);

                        var spdi2=new cc.Sprite(ljchess[11]);
                        this.addChild(spdi2,1);
                        var spdipos2=cc.p(0,0);
                        if(temp==1){
                            spdipos2=cc.p(pos.x,pos.y-37);
                        }else if(temp==2){
                            spdipos2=cc.p(pos.x,pos.y+37);
                        }else if(temp==3){
                            spdipos2=cc.p(pos.x+34,pos.y+18);
                        }else if(temp==4){
                            spdipos2=cc.p(pos.x-34,pos.y-18);
                        }else if(temp==5){
                            spdipos2=cc.p(pos.x+34,pos.y-18);
                        }else if(temp==6){
                            spdipos2=cc.p(pos.x-34,pos.y+18);
                        }
                        spdi2.setPosition(spdipos2);
                    }else{
                        var spdi2=new cc.Sprite(ljchess[12]);
                        this.addChild(spdi2,1);
                        spdi2.setPosition(pos);
                    }
                    var sp=new cc.Sprite(ljchess[11]);
                    this.addChild(sp,2);
                    sp.setPosition(pos);
                    this._chessBack[i*LIUJIAO_HEIGHT+j]=true;
                }
            }
        }
    },

    chessPos:function (i,j) {
        var px=i+(2-(j+1)/2);
        var py=j;
        var x=WINSIZE.width/2+(px-(LIUJIAO_WIDTH/2-0.5))*LIUJIAO_SIZE_WIDTH;
        var y=(py+0.5)*LIUJIAO_SIZE_Height+heightoffest;
        x+=LIUJIAO_SIZE_WIDTH/2;
        return cc.p(x,y);
    },

    chessPt:function (pt) {
        var y=(pt.y-heightoffest)/LIUJIAO_SIZE_Height;
        var x=pt.x;

        if(y<0)
            y=-1;
        var py=parseInt(y);
         if(py%2>0)
             x-=LIUJIAO_SIZE_WIDTH/2;
        var tx=(x-WINSIZE.width/2)/LIUJIAO_SIZE_WIDTH+(LIUJIAO_WIDTH/2-0.5);
        var ttx=parseInt(tx+0.5);
        var px=parseInt(ttx-(2-(py+1)/2));
        return cc.p(px,py);
    },

    //随机获取出现的方块
    getSelectChess:function () {
        var allkey=0;
        for(var i in CHESSPROP){
            allkey+=CHESSPROP[i];
        }
        var selectk=wb.randNum(0,allkey);
        var ret=0;
        var tempk=0;
        for(var i in CHESSPROP){
            tempk+=CHESSPROP[i];
            if(selectk<tempk){
                ret=parseInt(i);
                break;
            }
        }
        return ret;

    },

    startNewRound:function (key) {

        key=key?key:1;

        if(!this._firstsavein){
            for(var i=0;i<3;i++){
                if(this._selectExit[i])
                    return;
            }
        }

        var shapeid=[];
        var ttemp=true;
        do{
            ttemp=true;
            for(var i=0;i<3;i++){
                var keyid=0;
                if(this._guide){
                    if(i==0){
                        keyid=7;
                    }else if(i==1){
                        keyid=9;
                    }else if(i==2){
                        keyid=2;
                    }
                }
                else if(this._firstsavein){
                    keyid=this._typeid[i];
                }
                else{
                    keyid=this.getSelectChess();
                }

                shapeid[i]=keyid;
                this._typeid[i]=keyid;
            }
            if(!this._firstsavein){
                ttemp=true;
                for(var i=0;i<3;i++){
                    var box=new AngleNode(shapeid[i]);
                    if(this.BoxJudge(box)){
                        ttemp=false;
                        break;
                    }
                }
            }else{
                ttemp=false;
            }
        }while(ttemp);

        for(var i=0;i<3;i++){
            if(!this._firstsavein||this._selectExit[i]){
                var selectBox=new AngleNode(shapeid[i]);
                selectBox.setScale(selectboxsize);
                this.addChild(selectBox,11,10000+i);
                var pos=selectBox.getCenterAnPointX(cc.p(nextboxbegin+nextboxoffest*i,selectboxoffes));
                selectBox.setPosition(pos);
                this._selectExit[i] = true;
            }
        }

        if(this._firstsavein){
            this._firstsavein=false;
        }
        this.BoxFillJudge();
    },

    BoxJudge:function (node) {
        var fillvec=node._boxfill;
        for(var i=0;i<LIUJIAO_WIDTH;i++){
            for(var j=0;j<LIUJIAO_HEIGHT;j++){
                var temp=true;
                for (var k in fillvec)
                {
                    var kx = fillvec[k].x + i;
                    var ky = fillvec[k].y + j;
                    if (kx >= 0 && kx < LIUJIAO_WIDTH&&ky >= 0 && ky < LIUJIAO_HEIGHT)
                    {
                        if (this._chessInfo[kx*LIUJIAO_HEIGHT + ky]||!this._chessBack[kx*LIUJIAO_HEIGHT+ky])
                        {
                            temp = false;
                            break;
                        }
                    }
                    else
                    {
                        temp = false;
                        break;
                    }
                }
                if (temp)
                    return true;
            }
        }
        return false;
    },

})