﻿STAR_WIDTH=10;
STAR_HEIGHT=10;
STAR_SIZE_WIDTH=64;
STAR_CHESS_SCALE=0.98;
tipdelaytime=0.6;

HANGTAG=1212;
GUIDELAYERTAG=1213;
HANDTAG=1214;
TIPFONTTAG=1215;
SECONDLAYERTAG=1216;
boxremovesingletime=0.12;
cleardelaytime=0.1;
chessmovetime=0.2;
ignoreposition=cc.p(460,200);

var PROPPRICE=[10,10,10,50];

var StarManager=GameLayer.extend({
    _clip:null,
    _candealwith:true,
    _lastLevelScore:0,
    _chessInfo:[],
    _selectbox:[],
    _eliminateNum:0,
    _eliminatePos:[],
    _propbt:[],
    _propprice:[],
    _propnum:[],
    _clicktiptime:0,
    _clicktipvec:[],
    levelupmusic:0,
    _firstsavein:false,
    _guide:false,
    _guidenumber:-1,
    ctor:function () {
        this._super();

        this.init();
        this.initChess();
        this.initData();

        this.LevelUpMotion();

        this.runAction(new cc.Sequence(new cc.DelayTime(1.0),new cc.CallFunc(function () {
            this.starDrop();
        }.bind(this))));

        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: this.onTouchBegan,
            onTouchMoved: this.onTouchMoved,
            onTouchEnded: this.onTouchEnded
        },this);
    },

    resurrenction:function () {
        this.setScore(this._lastLevelScore);
        this.LevelUpMotion();
        this.runAction(new cc.Sequence(new cc.DelayTime(1.0),new cc.CallFunc(function () {
            this.starDrop();
        }.bind(this))))
    },

    start:function () {
        this.setGameState(GameState.STATE_RUN);
    },

    run:function () {
        this.initProps();
        this.setGameState(GameState.STATE_RUN);
    },

    onTouchBegan:function (touch,event) {
        var position=touch.getLocation();
        var target=event.getCurrentTarget();

        cc.log("touch began!");

        if(target.getGameState()!=GameState.STATE_RUN){
            return false;
        }

        if(target._guide){
            if(target._guidenumber>3){
                var k=target.propTouch(position);
                if(k==(target._guidenumber-3)){
                    if(target._selectprop==0&&target._eliminateNum==0){
                        target.removeChildByTag(GUIDELAYERTAG);
                        target.removeChildByTag(HANDTAG);
                        if(k==1||k==2||k==3){
                            var ff=new cc.LabelTTF("点击画面上任一糖果","Arial",28);
                            target.addChild(ff,20,TIPFONTTAG);
                            var pos=target.chessPos(4,9);
                            ff.setPosition(cc.p(WINSIZE.width/2,pos.y+60));
                        }
                    }else{
                        return false;
                    }
                }else if(k>0)
                    return false;
            }else if(position.x>=0&&position.x<WINSIZE.width&&position.y>=heightoffest&&position.y<=(heightoffest+STAR_SIZE_WIDTH*STAR_HEIGHT)){
                var ps=target.chessPt(position);
                if(target._guidenumber==0){
                    if((ps.x==2||ps.x==3)&&ps.y==9){
                        var colorlay=cc.director.getRunningScene().getChildByTag(100);
                        for(var i=0;i<2;i++){
                            colorlay.removeChildByTag(i+1);
                        }
                        colorlay.setVisible(false);
                        var secondlay=target.getChildByTag(SECONDLAYERTAG);
                        secondlay.setVisible(false);
                        target.setGameState(GameState.STATE_STOP);
                    }else{
                        return false;
                    }
                }else if(target._guidenumber==1){
                    var vec=[cc.p(4,9),cc.p(5,9),cc.p(6,9),cc.p(7,9),cc.p(8,9)];
                    if(ELSGameTool.getInstance().posIndexOf(vec,ps)>=0){
                        target.setGameState(GameState.STATE_STOP);
                        var colorlay=cc.director.getRunningScene().getChildByTag(100);
                        for(var i=0;i<5;i++){
                            colorlay.removeChildByTag(i+1);
                        }
                        colorlay.setVisible(false);
                        var secondlay=target.getChildByTag(SECONDLAYERTAG);
                        secondlay.setVisible(false);
                    }else{
                        return false;
                    }
                }else{
                    return false;
                }
            }else{
                return false;
            }
        }

        var k=target.propTouch(position);
        if(k>0&&target._eliminateNum==0&&((!target._guide||(target._selectprop==0)))){
            target.propMotion(k);
            return true;
        }

        if(target._guide&&target._guidenumber>3&&target._selectprop==0)
            return true;

        if(position.x>=0&&position.x<WINSIZE.width&&position.y>=heightoffest&&position.y<=(heightoffest+STAR_SIZE_WIDTH*STAR_HEIGHT)){
            var pos=target.chessPt(position);
            if(target._chessInfo[pos.x*STAR_HEIGHT+pos.y]&&ELSGameTool.getInstance().posIndexOf(target._eliminatePos,pos)==-1){
                var temp=true;
                var vec=[];
                if(target._selectprop==1||target._selectprop==2||target._selectprop==4){
                    temp=target.propProcess(target._selectprop-1,pos);

                    if(target._guide){
                        target.removeChildByTag(TIPFONTTAG);
                        target._guidenumber++;
                    }
                }else if(target._selectprop==0){
                    target.boxTip(pos,vec);
                }
                var selectnumber=vec.length;
                if(selectnumber>1||(target._selectprop>0&&temp)){
                    target.endTip();
                    var ft=0.0;
                    if(target._selectprop==0){
                        target._eliminateNum++;
                        target.boxEliminate(vec);
                        ft=boxremovesingletime*selectnumber+cleardelaytime;
                    }else if(target._selectprop==1){
                        ft=boxremovesingletime+0.9;
                    }else if(target._selectprop==4){
                        ft=target._selectbox.length*0.15;
                        target.useProps4(pos);
                    }else if(target._selectprop==2){
                        target.useProps3(pos);
                    }
                    if(target._selectprop==1||target._selectprop==4){
                        target.setGameState(GameState.STATE_STOP);
                        target.runAction(new cc.Sequence(new cc.DelayTime(ft),new cc.CallFunc(function () {
                            target.touchHandle();
                        }.bind(target))));
                        target._selectprop=0;
                        target._selectbox=[];
                    }
                }
            }
            return true;
        }

        cc.log("touch began end!");
        return false;
    },

    onTouchMoved:function(touch,event){

    },

    onTouchEnded:function (touch,event) {

    },

    //道具引导
    setGuideProp:function (id) {
        var colorlay=new cc.LayerColor(cc.color(0,0,0,200),WINSIZE.width,WINSIZE.height*0.8-100);
        this.addChild(colorlay,100,GUIDELAYERTAG);

        var node=this.getParent().getBackLayer().getChildByName("prop"+id);
        node.setLocalZOrder(101);

        var hand=ELSGameTool.getInstance().createHand();
        this.addChild(hand,102,HANDTAG);
        hand.setRotation(-20);
        hand.setPosition(node.getPosition());

        var csb=ccs.load(res.guide_json).node;
        colorlay.addChild(csb);
        var nodes=csb.getChildByName("zi").getChildren();
        for(var i in nodes){
            nodes[i].setVisible(false);
        }

        var key=this._guidenumber;
        var font=csb.getChildByName("zi").getChildByName("zi_"+key);
        font.setVisible(true);

        var ignore=new ccui.ImageView(res.ignore_png);
        ignore.setTouchEnabled(true);
        ignore.addClickEventListener(function () {
            colorlay.removeFromParent();
            this.ignoreGuide();
        }.bind(this));
        colorlay.addChild(ignore);
        ignore.setPosition(ignoreposition)

    },

    useProps3:function (pos) {
        var node=this._clip.getChildByTag(pos.x*STAR_HEIGHT+pos.y);
        var nodepos=node.getPosition();

        var pPropChildLayer2=new cc.LayerColor(cc.Color(0,0,0,20));
        pPropChildLayer2.setOpacity(150);
        this.addChild(pPropChildLayer2,9);

        var pPropChildLayer=new cc.LayerColor(cc.Color(0,0,0,20));
        pPropChildLayer.setOpacity(150);
        this._clip.addChild(pPropChildLayer,100);

        var splayer=new cc.Layer();
        this.addChild(splayer,100);
        node.setLocalZOrder(101);
        node.runAction(new cc.RepeatForever(new cc.Sequence(new cc.ScaleTo(0.5,0.9*STAR_CHESS_SCALE),new cc.ScaleTo(0.5,STAR_CHESS_SCALE))));

        var guang=new cc.Sprite(starpng[13]);
        splayer.addChild(guang);
        guang.setLocalZOrder(100);
        guang.setPosition(node.getPosition());

        var jiantou=new cc.Sprite(starpng[12]);
        splayer.addChild(jiantou,102);
        jiantou.setAnchorPoint(cc.p(0.5,0.0));
        jiantou.setPosition(cc.p(nodepos.x,nodepos.y+STAR_SIZE_WIDTH/2));

        var kuang=new cc.Sprite(starpng[11]);
        splayer.addChild(kuang,101);
        kuang.setScaleX(1.12);
        var kuangsize=kuang.getContentSize();
        if(pos.x>2&&pos.x<(STAR_WIDTH-3)){
            kuang.setPosition(cc.p(nodepos.x,nodepos.y+STAR_SIZE_WIDTH/2+61));
        }else if(pos.x<=2){
            kuang.setPosition(cc.p(kuangsize.width*0.6,nodepos.y+STAR_SIZE_WIDTH/2+61));
        }else{
            kuang.setPosition(cc.p(WINSIZE.width-kuangsize.width*0.5*1.12,nodepos.y+STAR_SIZE_WIDTH/2+61));
        }
        var kuangpos=kuang.getPosition();

        var cancel=new ccui.ImageView(starpng[10]);
        cancel.addClickEventListener(function () {
            splayer.removeFromParent();
            pPropChildLayer.removeFromParent();
            pPropChildLayer2.removeFromParent();
            node.stopAllActions();
            node.setScale(STAR_CHESS_SCALE);
            node.setLocalZOrder(CHESSMAN_LEVEL);
            this._selectprop=0;
        }.bind(this));
        cancel.setTouchEnabled(true);
        splayer.addChild(cancel,103);
        cancel.setPosition(cc.p(kuangpos.x+kuangsize.width/2*1.12-38,kuangpos.y));

        if(this._guide)
            cancel.setTouchEnabled(false);

        var key=0;
        for(var i=0;i<5;i++){
            if((i+1)!=this.getChessInfo(pos)){
                var sp=new ccui.ImageView(starpng[i]);
                splayer.addChild(sp,103);
                sp.setTag(i);
                sp.setScale(STAR_CHESS_SCALE);
                sp.setTouchEnabled(true);
                sp.setPosition(cc.p(kuangpos.x-kuangsize.width/2+25+key*76,kuangpos.y));
                sp.addClickEventListener(function (target) {
                    this.setGameState(GameState.STATE_STOP);

                    var tt=target.getTag();

                    ELSGameTool.getInstance().playVideo(VIDEO[0]);
                    var anode=new cc.Sprite(starpng[tt]);
                    this._clip.addChild(anode,CHESSMAN_LEVEL);
                    anode.setPosition(target.getPosition());
                    anode.runAction(new cc.Sequence(new cc.ScaleTo(0.5,STAR_CHESS_SCALE*0.95),new cc.ScaleTo(0.2,STAR_CHESS_SCALE)));
                    anode.runAction(new cc.Sequence(new cc.MoveTo(0.5,nodepos),new cc.CallFunc(function (target,tt) {
                        anode.runAction(new cc.Sequence(new cc.ScaleTo(0.2,STAR_CHESS_SCALE),new cc.CallFunc(function () {
                            if(this.getGameState()==GameState.STATE_STOP){
                                this.setGameState(GameState.STATE_RUN);
                            }
                            this.touchHandle();
                        }.bind(this))));
                        anode.setTag(pos.x*STAR_HEIGHT+pos.y);
                        this.setChessInfo(pos,tt+1);
                    }.bind(this),this,tt)));

                    splayer.removeFromParent();
                    pPropChildLayer.removeFromParent();
                    pPropChildLayer2.removeFromParent();
                    node.stopAllActions();
                    node.setScale(STAR_CHESS_SCALE);
                    this._selectprop=0;

                    node.runAction(new cc.Sequence(new cc.ScaleTo(0.4,0.0),new cc.CallFunc(function () {
                        this._clip.removeChildByTag(pos.x*STAR_HEIGHT+pos.y);
                    }.bind(this))));

                    if(!this._guide){
                        if(ELSGameData.getInstance().getPropNum(1)==0){
                            ELSGameLogic.getInstance().useIcon(-PROPPRICE[1]);
                        }else{
                            ELSGameData.getInstance().changePropNum(1,-1);
                            this.setPropNum(1,ELSGameData.getInstance().getPropNum(1));
                        }
                    }
                }.bind(this));
                key++;
            }
        }

        ELSGameLogic.getInstance().addkeyListener(pPropChildLayer2);
    },

    useProps4:function (pos) {
        var pPropChildLayer=new cc.LayerColor(cc.Color(0,0,0,255));
        pPropChildLayer.setOpacity(150);

        var pPropChildLayer2=new cc.LayerColor(cc.Color(0,0,0,255));
        pPropChildLayer2.setOpacity(150);
        this.addChild(pPropChildLayer2,9,9);

        var tempk=this._selectbox[0];
        for(var i in this._selectbox){
            if(this._selectbox[i].x==pos.x&&this._selectbox[i].y==pos.y){
                this._selectbox[i].x=tempk.x;
                this._selectbox[i].y=tempk.y;

                this._selectbox[0].x=pos.x;
                this._selectbox[0].y=pos.y;
                break;
            }
        }

        var selectbox=this._selectbox.slice(1,this._selectbox.length);
        selectbox.sort(function (a,b) {
            return Math.random()>0.5?-1:1;
        });
        selectbox.splice(0,0,this._selectbox[0]);

        var actions=[];
        var color=this.getChessInfo(pos);
        for(var i=0; i<selectbox.length;i++){

            var key1=selectbox[i];
            var node=this._clip.getChildByTag(key1.x*STAR_HEIGHT+key1.y);
            node.setLocalZOrder(101);

            actions.push(new cc.CallFunc(function (target,key) {
                this.addParticle(key);
                this.removeBox(key);
            }.bind(this),this,key1));

            if(i==selectbox.length-1){
                break;
            }

            var key2=selectbox[i+1];

            var position1=this.chessPos(key1.x,key1.y);
            var position2=this.chessPos(key2.x,key2.y);

            actions.push(new cc.CallFunc(function (target,data) {
                var line=new cc.Sprite(starpng[wb.randNum(14,18)]);
                line.setAnchorPoint(cc.p(0,0.5));
                var length=Math.sqrt(Math.abs(data.pos1.x-data.pos2.x)*Math.abs(data.pos1.x-data.pos2.x)+Math.abs(data.pos1.y-data.pos2.y)*Math.abs(data.pos1.y-data.pos2.y));
                var lengthscale=length*1.0/line.getContentSize().width;
                line.setScaleX(0.06*lengthscale);
                line.runAction(new cc.Sequence(new cc.ScaleTo(0.1,1.0*lengthscale,1.5),new cc.ScaleTo(0.25,1.0*lengthscale,0.06*1.5),new cc.CallFunc(function () {
                    line.removeFromParent();
                })));

                line.setPosition(data.pos1);
                var angle1=Math.atan2(data.pos2.y-data.pos1.y, data.pos2.x-data.pos1.x);
                var angle=-1*cc.radiansToDegrees(angle1);
                line.setRotation(angle);
                this._clip.addChild(line,102);

            }.bind(this),this,{pos1:position1,pos2:position2}));
            actions.push(new cc.DelayTime(0.15));
        }
        actions.push(new cc.CallFunc(function () {
            pPropChildLayer.removeFromParent();
            pPropChildLayer2.removeFromParent();
        }));
        pPropChildLayer.runAction(new cc.Sequence(actions));

        this._clip.addChild(pPropChildLayer,100);

        ELSGameLogic.getInstance().addkeyListener(pPropChildLayer2);
    },

    boxEliminate:function (vec) {
        var score=this.getScoreByNum(vec.length);
        this._score+=score;
        this.scoreMotion(score,vec[0]);

        if(this.getScore()>=this.getTarget()&&(this.getScore()-score)<this.getTarget()){
            this.spriteShow(gxpng[0]);
        }else{
            if(vec.length==5){
                this.spriteShow(gxpng[1]);
            }else if(vec.length>5){
                this.spriteShow(gxpng[2]);
            }
        }
        this.levelupmusic=0;
        this.boxSequence(vec,true);
        var arrayOfActions=[];
        for(var i in vec){
            if(i!="0"){
                arrayOfActions.push(new cc.DelayTime(boxremovesingletime));
            }
            var key=vec[i];
            arrayOfActions.push(new cc.CallFunc(function (target,data) {
                this.addParticle(data);
                this.removeBox(data);
            }.bind(this),this,key));
        }
        arrayOfActions.push(new cc.DelayTime(cleardelaytime));
        arrayOfActions.push(new cc.CallFunc(function () {
            this._eliminateNum--;
            if(this._eliminateNum==0){
                this._eliminatePos=[];
                this.setGameState(GameState.STATE_STOP);
                this.touchHandle();
            }
        }.bind(this)));
        this.runAction(new cc.Sequence(arrayOfActions));
    },

    touchHandle:function () {
        var time=0.0;
        if(this.chessMove()){
            time+=chessmovetime;
        }
        this.runAction(new cc.Sequence(new cc.DelayTime(time),new cc.CallFunc(function () {
            if(this._candealwith){
                this.handleHandle();
            }
        }.bind(this))));
    },

    handleHandle:function () {
        if(this.chessCanEliminate()){
            this.setGameState(GameState.STATE_RUN);
            if(this._guide){
                if(this._guidenumber==0){
                    this.setGameState(GameState.STATE_STOP);
                    this.runAction(new cc.Sequence(new cc.DelayTime(0.5),new cc.CallFunc(function () {
                        this._guidenumber=4;
                        this.setGameState(GameState.STATE_RUN);
                        this.setGuideProp(1);
                    }.bind(this))));
                }else if(this._guidenumber>3){
                    if(this._guidenumber==8){
                        this.ignoreGuide();
                    }else{
                        this.setGameState(GameState.STATE_STOP);
                        this.runAction(new cc.Sequence(new cc.DelayTime(tipdelaytime),new cc.CallFunc(function () {
                            this.setGameState(GameState.STATE_RUN);
                            this.setGuideProp(this._guidenumber-3);
                        }.bind(this))));
                    }
                }
            }else{
                this.beganTip();
            }
        }else{
            this.runAction(new cc.Sequence(new cc.DelayTime(0.5),new cc.CallFunc(function () {
                this.chessClear();
            }.bind(this))))
        }
    },

    chessClear:function () {
        var eliminatebox=[];
        for(var i=0;i<STAR_WIDTH;i++)
            for(var j=0;j<STAR_HEIGHT;j++){
                if(this.getChessInfo(cc.p(i,j))){
                    eliminatebox.push(cc.p(i,j));
                }
            }

         if(eliminatebox.length>0){
             eliminatebox.sort(function (a,b) {
                 return Math.random()>0.5?-1:1;
             })
         }
         this.levelupmusic=0;
        this.boxSequence(eliminatebox,false);

        var num=this.getRetainScore(eliminatebox.length);
        this._score+=num;
        this.scoreMotion(num,cc.p(WINSIZE.width/2,WINSIZE.height/2));

        var ftime=this.smallPeopleCollect(eliminatebox);
        this.retainScoreMotion(eliminatebox.length,num,3.0);
        var ft=Math.max(ftime,3);

        if(this.getScore()>this.getTarget()&&(this.getScore()-num)<this.getTarget()){
            this.spriteShow(gxpng[0]);
        }

        this.runAction(new cc.Sequence(new cc.DelayTime(ft),new cc.CallFunc(function () {
            this.faildJudge();
        }.bind(this))));

    },

    smallPeopleCollect:function (vec) {
        var tt=cleardelaytime;
        var action=[];
        for(var i in vec){
            var pos=vec[i];
            action.push(new cc.CallFunc(function (target,pos) {
                this.addParticle(pos,2);
                this.removeBox(pos);
            }.bind(this),this,pos));
            action.push(new cc.DelayTime(boxremovesingletime));
            tt+=boxremovesingletime;
        }
        if(action.length>0){
            this.runAction(new cc.Sequence(action));
        }
        return tt;
    },

    faildJudge:function () {
        if(this.getScore()<this.getTarget()){
            this.gameFaild();
            MatchTempData.getInstance().clear();
        }else{
            cc.log("wb hjTaskManager");
            wb.HjTaskManager.successGame(GameName[0],this.getScore());

            this.setLevel(this.getLevel()+1);
            this.setTarget(this.getTargetScoreByRound(this.getLevel()));
            this._lastLevelScore=this.getScore();

            this.removeChildByTag(777);
            this.LevelUpMotion;
            this.runAction(new cc.Sequence(new cc.DelayTime(0.5),new cc.CallFunc(function () {
                this._firstsavein=false;
                this.starDrop();
            }.bind(this))));

            if(ELSGameLogic.getInstance().canOpenWinAd(this.getLevel()-1)){
                ELSGameLogic.getInstance().openAd("level_win");
            }
        }
    },

    gameFaild:function () {
        cc.log("game failed");
        var lay=new FaildLayer();
        this.getParent().addChild(lay,100);
    },

    retainScoreMotion:function (number,score,ft) {
        var fnt1=new cc.LabelTTF("奖励"+score+"分","Arial",50);
        this.addChild(fnt1,12);
        fnt1.setPosition(cc.p(WINSIZE.width+100,WINSIZE.height/2.0+heightoffest*0.5+60));
        fnt1.runAction(new cc.Sequence(new cc.MoveBy(0.2,cc.p(-WINSIZE.width/2-100,0)),new cc.DelayTime(ft-0.4),new cc.MoveBy(0.2,cc.p(-WINSIZE.width/2.0-100,0))));

        var fnt2=new cc.LabelTTF("剩余"+number+"颗糖果","Arial",50);
        this.addChild(fnt2,21);
        fnt2.setPosition(cc.p(WINSIZE.width+100,WINSIZE.height/2.0+heightoffest*0.5-40));
        fnt2.runAction(new cc.Sequence(new cc.MoveBy(0.2,cc.p(-WINSIZE.width/2-100,0)),new cc.DelayTime(ft-0.4),new cc.MoveBy(0.2,cc.p(-WINSIZE.width/2.0-100,0)),new cc.CallFunc(function () {
            fnt1.removeFromParent();
            fnt2.removeFromParent();
        })));
    },

    getRetainScore:function (number) {
        var score=1500;
        for(var i=1;i<=number;i++){
            score-=30*i-15;
        }
        if(score<0)
            score=0;
        return score;
    },

    chessMove:function () {
        var temp=false;
        var downstep=[];
        var step=0;
        for(var i=0;i<STAR_WIDTH;i++){
            step=0;
            for(var j=0;j<STAR_HEIGHT;j++){
                if(this.getChessInfo(cc.p(i,j))==0){
                    step++;
                }else if(step>0){
                    temp=true;
                    var box=this._clip.getChildByTag(i*STAR_HEIGHT+j);
                    box.runAction(new cc.MoveTo(0.15,this.chessPos(i,j-step)));
                    box.setTag(i*STAR_HEIGHT+(j-step));
                    this.setChessInfo(cc.p(i,j-step),this.getChessInfo(cc.p(i,j)));
                    this.setChessInfo(cc.p(i,j),0);
                }
            }
        }

        step=0;
        for(var i=0;i<STAR_WIDTH;i++){
            if(this.getChessInfo(cc.p(i,0))==0){
                step++;
            }else if(step>0){
                for(var j=0;j<STAR_HEIGHT;j++){
                    if(this.getChessInfo(cc.p(i,j))){
                        temp=true;
                        var box=this._clip.getChildByTag(i*STAR_HEIGHT+j);
                        box.runAction(new cc.Sequence(new cc.DelayTime(0.1),new cc.MoveBy(0.05,cc.p(-step*STAR_SIZE_WIDTH,0))));
                        box.setTag((i-step)*STAR_HEIGHT+j);
                        this.setChessInfo(cc.p(i-step,j),this.getChessInfo(cc.p(i,j)));
                        this.setChessInfo(cc.p(i,j),0);
                    }
                }
            }
        }
        return temp;
    },

    boxSequence:function (vec,sx) {
        var k=vec.length;
        if(k>0){
            for(var i=0;i<k;i++){
                for(var j=k-1;j>i;j--){
                    if(sx){
                        if(this.getnum(vec[j])<this.getnum(vec[j-1])){
                            var temp=vec[j];
                            vec[j]=vec[j-1];
                            vec[j-1]=temp;
                        }
                    }else{
                        if(this.getrenum(vec[j])<this.getrenum(vec[j-1])){
                            var temp=vec[j];
                            vec[j]=vec[j-1];
                            vec[j-1]=temp;
                        }
                    }
                }
            }
        }
    },

    getnum:function (pos) {
        return pos.x*STAR_HEIGHT+pos.y;
    },

    getrenum:function (pos) {
        return pos.x*STAR_HEIGHT+(STAR_HEIGHT-pos.y);
    },

    spriteShow:function (str) {
        if(str==gxpng[0]){
            var endpos=cc.p(102,WINSIZE.height-96);
            if(ELSGameLogic.getInstance().isFullScreen())
                endpos.y-=FULLSCENE_HEIGHT;

            var spr=new cc.Sprite(str);
            this.addChild(spr,12,777);
            spr.setPosition(cc.p(WINSIZE.width/2.0,WINSIZE.height/2.0+heightoffest/2.0));
            spr.runAction(new cc.Sequence(new cc.FadeOut(0.08),new cc.FadeIn(0.08),new cc.FadeOut(0.08),new cc.FadeIn(0.08),new cc.FadeOut(0.08),new cc.FadeIn(0.08),
                new cc.ScaleTo(0.2,0.8),new cc.DelayTime(0.52),new cc.MoveTo(0.5,endpos)));
            spr.runAction(new cc.Sequence(new cc.DelayTime(1.2),new cc.ScaleTo(0.5,0.25),new cc.CallFunc(function () {
                spr.setLocalZOrder(8);
            })));
        }else{
            ELSGameTool.getInstance().spriteShow(str,cc.p(WINSIZE.width/2.0,WINSIZE.height/2.0));
        }

    },

    scoreMotion:function (score,pt) {
        var scorefnt=ELSGameTool.getInstance().getLabelAtlas(score.toString(),res.fnt_png1);
        scorefnt.setScale(1.5);
        this.addChild(scorefnt,15);
        scorefnt.setPosition(this.chessPos(pt.x,pt.y));
        scorefnt.runAction(new cc.Sequence(new cc.MoveBy(1.0,cc.p(0,STAR_SIZE_WIDTH)),new cc.CallFunc(function () {
            scorefnt.removeFromParent();
        })));
    },

    getScoreByNum:function (num) {
        var k=5;
        var t=5;
        for(var i=0;i<num;i++){
            k+=t;
            t+=10;
        }
        return k;
    },

    endTip:function () {
        this._clicktiptime=0;
        for(var i in this._clicktipvec){
            var key=this._clicktipvec[i];
            var box=this._clip.getChildByTag(key.x*STAR_HEIGHT+key.y);
            this.setBoxMotion(box,false);
        }
        this._clicktipvec=[];
    },

    boxTip:function (pos,vect) {
        var vec=this.boxGet(pos);
        if(vec.length>1){
            for(var i in vec){
                vect.push(vec[i]);
                this._eliminatePos.push(vec[i]);
                var box=this._clip.getChildByTag(vec[i].x*STAR_HEIGHT+vec[i].y);
                this.setBoxMotion(box,true);
            }
        }
    },

    setBoxMotion:function (box,bol) {
        if(bol){
            box.runAction(new cc.RepeatForever(new cc.Sequence(new cc.ScaleTo(1.0,0.95),new cc.ScaleTo(1.0,1.0))));
        }else{
            box.stopAllActions();
            box.setScale(1.0);
        }
    },

    boxGet:function (pos) {
        var vec=[];
        this.boxAdd(pos,vec);
        return vec;
    },

    boxAdd:function (pos,vec) {
        vec.push(pos);
        //x-1
        if((pos.x-1)>=0&&ELSGameTool.getInstance().posIndexOf(vec,cc.p(pos.x-1,pos.y))==-1&&(this.getChessInfo(pos)==this.getChessInfo(cc.p(pos.x-1,pos.y)))){
            this.boxAdd(cc.p(pos.x-1,pos.y),vec);
        }

        //x+1
        if((pos.x+1)<STAR_WIDTH&&ELSGameTool.getInstance().posIndexOf(vec,cc.p(pos.x+1,pos.y))==-1&&(this.getChessInfo(pos)==this.getChessInfo(cc.p(pos.x+1,pos.y)))){
            this.boxAdd(cc.p(pos.x+1,pos.y),vec);
        }

        //y-1
        if((pos.y-1)>=0&&ELSGameTool.getInstance().posIndexOf(vec,cc.p(pos.x,pos.y-1))==-1&&(this.getChessInfo(pos)==this.getChessInfo(cc.p(pos.x,pos.y-1)))){
            this.boxAdd(cc.p(pos.x,pos.y-1),vec);
        }

        //y+1
        if((pos.y+1)<STAR_HEIGHT&&ELSGameTool.getInstance().posIndexOf(vec,cc.p(pos.x,pos.y+1))==-1&&(this.getChessInfo(pos)==this.getChessInfo(cc.p(pos.x,pos.y+1)))){
            this.boxAdd(cc.p(pos.x,pos.y+1),vec);
        }
    },

    propMotion:function (k) {
        if(k==3){
            this.propProcess(2);
            if(!this._guide)
                this.endTip();
        }
        cc.log("match touch began2");
        if(k>0&&k<5){
            cc.log("this._selectprop="+this._selectprop+"....k="+k);
            if(this._selectprop>0){
                this._propbt[this._selectprop-1].stopAllActions();
                this._propbt[this._selectprop-1].setScale(1.0);
            }
            cc.log("match touch began3");
            if(this._selectprop==k){
                this.beganTip();
                this._selectprop=0;
            }else{
                cc.log("match touch began4");
                if(!this._guide)
                    this.endTip();

                if(k!=3){
                    cc.log("match touch began5");
                    this._selectprop=k;
                    this._propbt[k-1].runAction(new cc.RepeatForever(new cc.Sequence(new cc.ScaleTo(0.5,0.95),new cc.ScaleTo(0.5,1.05))));
                }
            }
        }
    },

    //使用道具
    propProcess:function (id,pos) {
        if(!pos){
            pos=cc.p(0,0);
        }
        if(this._selectprop>0){
            this._propbt[this._selectprop-1].stopAllActions();
            this._propbt[this._selectprop-1].setScale(1.0);
        }

        if(!this._guide){
            if(PROPPRICE[id]>ELSGameLogic.getInstance().getIcon()&&ELSGameData.getInstance().getPropNum(id)==0){
                this._selectprop=0;
                if(ELSGameTool.getInstance().isGiftExist(2)){
                    var layer=new ShopLayer();
                    cc.director.getRunningScene().addChild(layer,100);
                }else{
                    ELSGameTool.getInstance().gameTip("钻石不足");
                }
                return false;
            }else{
                if(id!=1){
                    if(ELSGameData.getInstance().getPropNum(id)==0){
                        ELSGameLogic.getInstance().useIcon(-PROPPRICE[id]);
                    }else{
                        ELSGameData.getInstance().changePropNum(id,-1);
                        this.setPropNum(id,ELSGameData.getInstance().getPropNum(id));
                    }
                }
            }
        }

        //棋盘刷新
        if(id==2){
            ELSGameTool.getInstance().playVideo(VIDEO[13]);

            this._propbt[2].runAction(new cc.RotateBy(0.6,360));
            this._propbt[2].runAction(new cc.Sequence(new cc.ScaleTo(0.3,0.9),new cc.ScaleTo(0.3,1.0)));

            var selectbox=[];
            do{
                selectbox=[];
                for(var i=0;i<STAR_WIDTH;i++)
                    for(var j=0;j<STAR_HEIGHT;j++){
                        if(this.getChessInfo(cc.p(i,j))){
                            this.setChessInfo(cc.p(i,j),wb.randNum(1,5));
                            selectbox.push(cc.p(i,j));
                        }
                    }
            }while (!this.chessCanEliminate());
            selectbox.sort(function (a,b) {
                return Math.random()>0.5?-1:1;
            })
            this.setGameState(GameState.STATE_STOP);
            var boxaction=[];
            for(var i in selectbox){
                var key=selectbox[i];
                boxaction.push(new cc.DelayTime(1.0/60.0));
                boxaction.push(new cc.CallFunc(function (target,data) {
                    var pp=this._clip.getChildByTag(data.x*STAR_HEIGHT+data.y);
                    pp.runAction(new cc.Sequence(new cc.ScaleTo(0.1,0.0),new cc.CallFunc(function (target,data) {
                        this._clip.removeChildByTag(data.x*STAR_HEIGHT+data.y);
                        var newbox=new cc.Sprite(starpng[this.getChessInfo(data)-1]);
                        this._clip.addChild(newbox,CHESSMAN_LEVEL,data.x*STAR_HEIGHT+data.y);
                        newbox.setPosition(this.chessPos(data.x,data.y));
                        newbox.setScale(0.0);
                        newbox.runAction(new cc.Sequence(new cc.ScaleTo(0.2,STAR_CHESS_SCALE*1.1),new cc.ScaleTo(0.2,STAR_CHESS_SCALE*0.9),
                            new cc.ScaleTo(0.2,STAR_CHESS_SCALE)));
                    }.bind(this),this,data)));
                }.bind(this),this,key));
            }

            boxaction.push(new cc.CallFunc(function () {
                if(!this._guide){
                    if(this.getGameState()==GameState.STATE_STOP)
                        this.setGameState(GameState.STATE_RUN);
                    this.BeganTip();
                }else{
                    this._guidenumber++;
                    this.runAction(new cc.Sequence(new cc.DelayTime(1.0),new cc.CallFunc(function () {
                        this.setGameState(GameState.STATE_RUN);
                        this.setGuideProp(4);
                    }.bind(this))));
                }
            }.bind(this)));
            this.runAction(new cc.Sequence(boxaction));
        }
        else if(id==3){
            var key=this.getChessInfo(pos);
            for(var i=0;i<STAR_WIDTH;i++)
                for(var j=0;j<STAR_HEIGHT;j++){
                    if(key==this.getChessInfo(cc.p(i,j))){
                        this._selectbox.push(cc.p(i,j));
                    }
                }
        }else if(id==0){
            var ssp=new cc.Sprite(starpng[5]);
            this.addChild(ssp,10);
            ssp.setPosition(this._propbt[0].getParent().getPosition());

            var v1=ssp.getPosition();
            var tempv=this.chessPos(pos.x,pos.y);
            var v2=cc.p(tempv.x+10,tempv.y-10);
            var v3=cc.p(0,0);
            if(v2.x<WINSIZE.width/2)
                v3=cc.p(v1.x+200,v1.y-100);
            else
                v3=cc.p(v1.x+200,v1.y+100);
            var bezierpath=[v1,v3,v2];

            var bezier=new cc.BezierTo(0.7,bezierpath);
            ssp.runAction(new cc.Sequence(bezier,new cc.CallFunc(function (target,tempv) {
                var lizi=new cc.Sprite(starpng[9]);
                this.addChild(lizi);
                lizi.setPosition(tempv);
                lizi.setScale(0.0);
                lizi.runAction(new cc.Sequence(new cc.ScaleTo(0.3,1.5),new cc.CallFunc(function () {
                    lizi.removeFromParent();
                })));
                lizi.runAction(new cc.Sequence(new cc.DelayTime(0.2),new cc.FadeOut(0.2)));
                ssp.removeFromParent();
            }.bind(this),this,tempv)));
            ssp.runAction(new cc.ScaleTo(0.15,1.5));
            this.runAction(new cc.Sequence(new cc.DelayTime(0.7),new cc.CallFunc(function (target,pos) {
                this.runAction(new cc.Sequence(new cc.DelayTime(0.0),new cc.CallFunc(function (target,pos) {
                    for(var i=pos.x-1;i<=pos.x+1;i++)
                        for(var j=pos.y-1;j<=pos.y+1;j++){
                            if(i>=0&&i<STAR_WIDTH&&j>=0&&j<STAR_HEIGHT&&this.getChessInfo(cc.p(i,j))){
                                this.addParticle(cc.p(i,j));
                                this.removeBox(cc.p(i,j));
                            }
                        }
                }.bind(this),this,pos)));
            }.bind(this),this,pos)));
        }
        return true;
    },

    addParticle:function (pos,key) {
        if(!key)
            key=1;
        if(key==1)
            ELSGameTool.getInstance().addFkLizi(this,this.chessPos(pos.x,pos.y),this.getChessInfo(pos)-1,1.0,2);
        else
            ELSGameTool.getInstance().addFkLizi(this,this.chessPos(pos.x,pos.y),5,1.0,2);
    },

    removeBox:function (pos) {
        this._clip.removeChildByTag(pos.x*STAR_HEIGHT+pos.y);
        this.setChessInfo(pos,0);

        ELSGameTool.getInstance().playVideo(VIDEO[7+this.levelupmusic%4]);
        this.levelupmusic++;
    },

    BeganTip:function () {
        var hand=this.getChildByTag(HANGTAG);
        if(hand){
            hand.setVisible(false);
        }else{

        }
    },

    chessCanEliminate:function () {
        for(var i=0;i<STAR_WIDTH;i++)
            for(var j=0;j<STAR_HEIGHT;j++){
                if(this.singelCanEliminate(cc.p(i,j))){
                    return true;
                }
            }
        return false;
    },

    singelCanEliminate:function (pos) {
        var i=pos.x;
        var j=pos.y;
        var key=this.getChessInfo(pos);
        if(key>0){
            if((i-1)>=0&&key==this.getChessInfo(cc.p(i-1,j))){
                return true;
            }
            if((i+1)<STAR_WIDTH&&key==this.getChessInfo(cc.p(i+1,j))){
                return true;
            }
            if((j-1)>=0&&key==this.getChessInfo(cc.p(i,j-1))){
                return true;
            }
            if((j+1)<STAR_HEIGHT&&key==this.getChessInfo(cc.p(i,j+1))){
                return true;
            }
        }
        return false;
    },

    getChessInfo:function (pos) {
        return this._chessInfo[pos.x*STAR_HEIGHT+pos.y];
    },

    setChessInfo:function (pos, key) {
        this._chessInfo[pos.x*STAR_HEIGHT+pos.y]=key;
    },

    propTouch:function (pos) {
        for(var i=0;i<4;i++){
            var po=this._propbt[i].getParent().getPosition();
            if(Math.abs(pos.x-po.x)<=50&&Math.abs(pos.y-po.y)<=50)
                return i+1;
        }
        return 0;
    },

    init:function () {
        heightoffest=105;
        propsheight = 930 + (WINSIZE.height - 1136);
        this._guide=ELSGameData.getInstance().getGameGuide(GameName[0]);
        this._guidenumber=-1;
    },

    initChess:function () {
        var vec=[
            cc.p(WINSIZE.width/2.0-STAR_SIZE_WIDTH*STAR_WIDTH/2.0,heightoffest),
            cc.p(WINSIZE.width/2.0+STAR_SIZE_WIDTH*STAR_WIDTH/2.0,heightoffest),
            cc.p(WINSIZE.width/2.0+STAR_SIZE_WIDTH*STAR_WIDTH/2.0,heightoffest+STAR_SIZE_WIDTH*STAR_HEIGHT),
            cc.p(WINSIZE.width/2.0-STAR_SIZE_WIDTH*STAR_WIDTH/2.0,heightoffest+STAR_SIZE_WIDTH*STAR_HEIGHT),
        ];
        var node=new cc.DrawNode();
        node.drawPoly(vec,cc.color(255,255,255,0),2,cc.color(255, 0, 0, 0));

        this._clip=new cc.ClippingNode(node);

        this.addChild(this._clip,10);
    },

    initData:function () {
        this._candealwith=true;
        this.setLevel(1);
        this.setScore(0);
        this.setTarget(this.getTargetScoreByRound(1));
        this._lastLevelScore=0;

        for(var i=0;i<STAR_WIDTH;i++)
            for(var j=0;j<STAR_HEIGHT;j++)
                this._chessInfo[i*STAR_HEIGHT+j]=0;

        this._selectbox=[];
        this._eliminateNum=0;
        this._eliminatePos=[];

        this.setLastData();
    },

    //恢复上次存档
    setLastData:function () {
        var lastdata=MatchTempData.getInstance().getSaveData();
        if(lastdata._issaved){
            this._firstsavein=true;
            this.setLevel(lastdata._level);
            this.setScore(lastdata._score);
            this.setTarget(lastdata._target);
            this._lastLevelScore=lastdata._lastscore;
            var chessinfo=lastdata._chesspad;
            for(var i=0;i<STAR_WIDTH;i++)
                for(var j=0;j<STAR_HEIGHT;j++) {
                    if(parseInt(chessinfo[i*STAR_HEIGHT+j])>0){
                        this._chessInfo[i*STAR_HEIGHT+j]=parseInt(chessinfo[i*STAR_HEIGHT+j]);
                    }
                }
            this.handleHandle();
        }
    },

    initProps:function () {
        this._selectprop=0;

        for(var i=0;i<4;i++){
            var ke=this.getParent();
            var node=this.getParent().getBackLayer().getChildByName("prop"+(i+1));
            this._propbt[i]=node.getChildByName("prop");
            this._propbt[i].setTouchEnabled(false);
            this._propprice[i]=node.getChildByName("price");
            this._propnum[i]=node.getChildByName("number");
            this.setPropNum(i,ELSGameData.getInstance().getPropNum(i));

            if(this._guide){
                this._propnum[i].setVisible(false);
                this._propprice[i].setVisible(false);
                node.getChildByName("kuang").setVisible(false);
            }else{
                node.getChildByName("kuang").setVisible(true);
            }
        }
    },

    setPropNum:function (id,num) {
        if(num==0){
            this._propprice[id].setVisible(true);
            this._propnum[id].setVisible(false);
        }else{
            this._propprice[id].setVisible(false);
            this._propnum[id].setVisible(true);
            var fnt=this._propnum[id].getChildByName("fnt");
            fnt.setString("x "+num);
        }
    },

    getTargetScoreByRound:function (level) {
        var targetscore=0;
        if(level==1)
            targetscore=1000;
        else
            targetscore=10*level*level+1950*level-1440;
        return targetscore;
    },

    starDrop:function () {
        this.setGameState(GameState.STATE_STOP);
        if(!this._firstsavein||this._guide){
            for(var i=0;i<STAR_WIDTH;i++)
                for(var j=0;j<STAR_HEIGHT;j++){
                    var color=wb.randNum(1,5);

                    if(this._guide){
                        var vec1=[cc.p(4,9),cc.p(5,9),cc.p(6,9),cc.p(7,9),cc.p(8,9)];
                        var vec2=[cc.p(1,9),cc.p(9,9),cc.p(2,8),cc.p(3,8),cc.p(4,8),cc.p(5,8),cc.p(6,8),cc.p(7,8),cc.p(8,8)];
                        if((i==2||i==3)&&j==9){
                            color=1;
                        }else if(ELSGameTool.getInstance().posIndexOf(vec1,cc.p(i,j))>=0){
                            color=2;
                        }else if(ELSGameTool.getInstance().posIndexOf(vec2,cc.p(i,j))>=0){
                            color=wb.randNum(3,5);
                        }
                    }

                    this._chessInfo[i*STAR_HEIGHT+j]=color;
                }
        }else{
            this._firstsavein=false;
            if(this.getScore()>=this.getTarget()){
                this.spriteShow(gxpng[0]);
            }
        }

        var time=this.chessAppear(wb.randNum(1,6));
        this.runAction(new cc.Sequence(new cc.DelayTime(time),new cc.CallFunc(function () {
            this.setGameState(GameState.STATE_RUN);

            if(this._guide){
                this.runAction(new cc.Sequence(new cc.DelayTime(0.5),new cc.CallFunc(function () {
                    this._guidenumber=0;
                    this.startGuide();
                }.bind(this))));
            }else{
                this.beganTip();
            }
        }.bind(this))));

    },

    startGuide:function () {
        var colorlay=new cc.LayerColor(cc.color(0,0,0,0),WINSIZE.width,WINSIZE.height);
        cc.director.getRunningScene().addChild(colorlay,100,100);

        var colorlaysecond=new cc.LayerColor(cc.color(0,0,0,200),WINSIZE.width,WINSIZE.height);
        this.addChild(colorlaysecond,100,SECONDLAYERTAG);

        var csb=ccs.load(res.guide_json).node;
        colorlay.addChild(csb,3);
        csb.setContentSize(WINSIZE);
        ccui.helper.doLayout(csb);

        var nodes=csb.getChildByName("zi").getChildren();
        for(var i in nodes){
            nodes[i].setVisible(false);
        }

        var zi=csb.getChildByName("zi").getChildByName("zi_2");
        zi.setVisible(true);

        for(var i=0;i<2;i++){
            var sp=new cc.Sprite(starpng[0]);
            colorlay.addChild(sp,2,i+1);
            sp.setScale(STAR_CHESS_SCALE);
            sp.setPosition(this.chessPos(2+i,9));
        }

        var handnode=ELSGameTool.getInstance().createHand();
        colorlay.addChild(handnode,4,HANDTAG);
        handnode.setPosition(this.chessPos(3,9));

        var ignore=new ccui.ImageView(res.ignore_png);
        ignore.setTouchEnabled(true);
        ignore.addClickEventListener(function () {
            colorlay.removeFromParent();
            this.ignoreGuide();
        }.bind(this));
        colorlay.addChild(ignore);
        ignore.setPosition(ignoreposition);
    },

    ignoreGuide:function () {
        ELSGameLogic.getInstance().addLimitHb(this.getParent(),cc.p(80,900*(WINSIZE.height/1136.0)));
        this._guide=false;
        this._guidenumber=0;
        ELSGameData.getInstance().setGameGuide(GameName[0],false);
        this.getParent().restart();
    },

    chessPos:function (i,j) {
        return cc.p(WINSIZE.width/2.0+(i+0.5-STAR_WIDTH/2.0)*STAR_SIZE_WIDTH,heightoffest+(j+0.5)*STAR_SIZE_WIDTH);
    },

    chessPt:function (pos) {
        var x=parseInt((pos.x-WINSIZE.width/2.0)/STAR_SIZE_WIDTH+STAR_WIDTH/2.0);
        var y=parseInt((pos.y-heightoffest)/STAR_SIZE_WIDTH);
        return cc.p(x,y);
    },

    chessAppear:function (key) {
        var time=[0.1*STAR_HEIGHT+0.3,0.3,0.3,1.1,0.2,0.3,0.6,0.02*STAR_HEIGHT*STAR_WIDTH+0.25];
        for(var i=0;i<STAR_WIDTH;i++)
            for(var j=0;j<STAR_HEIGHT;j++){
                var id=this._chessInfo[i*STAR_HEIGHT+j];
                if(id>0){
                    var box=new cc.Sprite(starpng[id-1]);
                    box.setScale(STAR_CHESS_SCALE);
                    this._clip.addChild(box,CHESSMAN_LEVEL,i*STAR_HEIGHT+j);
                    var pos=this.chessPos(i,j);
                    if(key==0){
                        box.setPosition(cc.p(pos.x,pos.y+STAR_HEIGHT*STAR_SIZE_WIDTH));
                        box.runAction(new cc.Sequence(new cc.DelayTime(j*0.1+wb.randNum(0,9)*0.01),new cc.MoveBy(0.2,cc.p(0,-STAR_SIZE_WIDTH*STAR_HEIGHT))));
                    }
                    else if(key==1) {
                        box.setPosition(cc.p(pos.x-STAR_WIDTH*STAR_SIZE_WIDTH,pos.y));
                        box.runAction(new cc.MoveTo(0.2,pos));
                    }
                    else if(key==2) {
                        box.setPosition(cc.p(pos.x+STAR_WIDTH*STAR_SIZE_WIDTH,pos.y));
                        box.runAction(new cc.MoveTo(0.2,pos));
                    }
                    else if(key==3) {
                        box.setPosition(pos);
                        box.setOpacity(0);
                        box.runAction(new cc.FadeIn(1.0));
                    }
                    else if(key==4) {
                        if(i<STAR_WIDTH/2.0){
                            box.setPosition(cc.p(pos.x-(STAR_WIDTH*STAR_SIZE_WIDTH/2.0),pos.y));
                        }else{
                            box.setPosition(cc.p(pos.x+(STAR_WIDTH*STAR_SIZE_WIDTH/2.0),pos.y));
                        }
                        box.runAction(new cc.MoveTo(0.2,pos));
                    }
                    else if(key==5) {
                        if(j<STAR_HEIGHT/2.0){
                            box.setPosition(cc.p(pos.x,pos.y-(STAR_HEIGHT*STAR_SIZE_WIDTH/2.0)));
                        }else{
                            box.setPosition(cc.p(pos.x,pos.y+(STAR_HEIGHT*STAR_SIZE_WIDTH/2.0)));
                        }
                        box.runAction(new cc.MoveTo(0.2,pos));
                    }
                    else if(key==6) {
                        var k=1;
                        if((j%2)==0)
                            k=-1;
                        box.setPosition(cc.p(pos.x+k*STAR_WIDTH*STAR_SIZE_WIDTH,pos.y));
                        box.runAction(new cc.MoveTo(0.5,pos));
                    }
                }

            }
        return time[key];
    },

    beganTip:function () {

    },

    LevelUpMotion:function () {
        if(this._guide){
            ELSGameTool.getInstance().spriteShow(gxpng[3],cc.p(WINSIZE.width/2,WINSIZE.height/2));
            return;
        }

        if(this.getLevel()==1){
            this.setGameState(GameState.STATE_STOP);
            ELSGameTool.getInstance().playVideo(VIDEO[1]);
        }

        var fnt1=new cc.LabelTTF("第 "+this.getLevel()+" 关");
        fnt1.setFontSize(40);
        this.addChild(fnt1, 11);
        fnt1.setPosition(cc.p(WINSIZE.width/2.0,WINSIZE.height/2.0));
        fnt1.runAction(new cc.Sequence(new cc.MoveBy(0.3,cc.p(0,100)),new cc.DelayTime(1.0),new cc.FadeOut(0.3)));

        var fnt2=new cc.LabelTTF("目标："+this.getTarget());
        fnt2.setFontSize(40);
        this.addChild(fnt2, 11);
        fnt2.setPosition(cc.p(fnt1.getPosition().x,fnt1.getPosition().y-60));
        fnt2.runAction(new cc.Sequence(new cc.MoveBy(0.3,cc.p(0,100)),new cc.DelayTime(1.0),new cc.FadeOut(0.3),new cc.CallFunc(function () {
            fnt1.removeFromParent();
            fnt2.removeFromParent();

        }.bind(this))));
    },

});