var StarLayer=cc.Scene.extend({
    _manager:null,

    ctor:function () {
        this._super();

        ELSGameLogic.getInstance().setGameType(GameType.Type_Star);
        this.initLayer();
        this._manager=new StarManager();
        this.addChild(this._manager);
        this._manager.run();
        this.dataUpdate();
        this.schedule(this.dataUpdate,0.1);

        if(!ELSGameData.getInstance().getGameGuide(GameName[0])){
            ELSGameLogic.getInstance().addLimitHb(this,cc.p(80,900*(WINSIZE.height/1136.0)));
        }
        ELSGameLogic.getInstance().addReturnPage(2);
    },

    getManager:function () {
        return this._manager;
    },


    initLayer:function () {
        bg=ccs.load(res.StartScene_json).node;
        this.addChild(bg);
        bg.setContentSize(WINSIZE);
        ccui.helper.doLayout(bg);

        var node=bg.getChildByName("node");
        if(ELSGameLogic.getInstance().isFullScreen()){
            var pos=node.getPosition();
            node.setPosition(cc.p(pos.x,pos.y-FULLSCENE_HEIGHT));
        }

        fnt_level=ccui.helper.seekWidgetByName(bg,"fnt_guanshu");
        fnt_mbfs=ccui.helper.seekWidgetByName(bg,"fnt_mbfs");
        fnt_score=ccui.helper.seekWidgetByName(bg,"fnt_fenshu");
        fnt_diamond=ccui.helper.seekWidgetByName(bg,"diaNum");

        //暂停
        wb.FW(bg,"pause",function(){
            if(!this.getManager()._guide){
                var layer=new PauseLayer();
                this.addChild(layer,100);
                ELSGameTool.getInstance().playVideo(VIDEO[0]);
            }
        }.bind(this));

        //加钻石
        var bt_add=wb.FW(bg,"Button_add",function(){
            var layer=new ShopLayer
            this.addChild(layer,100,100);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
        if(!ELSGameTool.getInstance().isGiftExist(2))
            bt_add.setVisible(false);
    },

    getBackLayer:function () {
        return bg;
    },

    restart:function () {
        MatchTempData.getInstance().clear();
        this._manager.removeFromParent();
        this._manager=null;
        this._manager=new StarManager();
        this.addChild(this._manager);
        this._manager.run();
    },

    dataUpdate:function () {
        fnt_level.setString(this.getManager().getLevel().toString());
        fnt_mbfs.setString(this.getManager().getTarget().toString());
        fnt_score.setString(this.getManager().getScore().toString());
        fnt_diamond.setString(ELSGameLogic.getInstance().getIcon().toString());
    },

})

var StarScene=cc.Scene.extend({
    onEnter:function () {
        this._super();

        var layer=new StarLayer();
        this.addChild(layer,1,"layer");
    }
})