﻿ONEZERO_CHESS_SCALE=76.0/64.0;

var Onezeromanager=GameLayer.extend({
    _allnodetype:[],
    _clip:null,
    _tempshowblack:[],
    _chessInfo:[],
    _selectExit:[],
    _touchselect:0,
    _chesstippos:cc.p(-1,-1),
    _typeid:[],
    _firstsavein:false,
    _guide:false,
    _guidenumber:0,
    ctor:function () {
        this._super();

        this.init();
    },

    init:function () {
        selectboxoffes=BANER_HEIGHT;
        heightoffest=364;
        selectboxsize=0.5;
        nextboxoffest=202;
        nextboxbegin=118;
        chessfilltime = 0.1;
        boxtofiger=60;
        shadomscale = 0.95;

        this._guide=ELSGameData.getInstance().getGameGuide(GameName[2]);
        this._guidenumber=0;

        this.initAllNodeType();
        this.initChess();

        this._tempshowblack=[];
        this._chessInfo=[];
        for(var i=0;i<ONEZERO_WIDTH;i++)
            for(var j=0;j<ONEZERO_HEIGHT;j++){
                this._chessInfo.push(0);
            }
        for(var i=0;i<3;i++)
            this._selectExit[i]=false;

        this.setTouchState(TouchState.TOUCH_TRUE);
        this.setScore(0);

        this.setLastData();

        this.startNewRound();

        if(this._guide){
            this._guidenumber=1;
            this.guideChess();
            for(var i=0;i<ONEZERO_WIDTH;i++)
                for(var j=0;j<ONEZERO_HEIGHT;j++){
                    if(this._chessInfo[i*ONEZERO_HEIGHT+j]>0){
                        var box=new cc.Sprite(chesspng[this._chessInfo[i*ONEZERO_HEIGHT+j]-1]);
                        this._clip.addChild(box,CHESSMAN_LEVEL,i*ONEZERO_HEIGHT+j);
                        box.setPosition(this.chessPos(i,j));
                        box.setScale(ONEZERO_CHESS_SCALE);
                    }
                }

            this.runAction(new cc.Sequence(new cc.DelayTime(2.0),new cc.CallFunc(function () {
                this.GameGuide();
            }.bind(this))));

            this.guideTip(1);
        }

        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: this.onTouchBegan,
            onTouchMoved: this.onTouchMoved,
            onTouchEnded: this.onTouchEnded
        },this);
    },

    guideTip:function (key) {
        var sst=gxpng[3];
        if(key==2){
            sst=gxpng[4];
        }
        var fnt2=new cc.Sprite(sst);
        this.addChild(fnt2,CHESSMAN_LEVEL+100);
        fnt2.setPosition(cc.p(WINSIZE.width/2,680));
        fnt2.runAction(new cc.Sequence(new cc.MoveBy(0.3,cc.p(0,60)),new cc.DelayTime(0.2),new cc.ScaleTo(0.2,1.1),new cc.DelayTime(0.5),new cc.FadeOut(0.3),new cc.CallFunc(function () {
            fnt2.removeFromParent();
        }.bind(this))));
    },

    GameGuide:function () {
        var bclayer=new cc.Layer();
        cc.director.getRunningScene().addChild(bclayer,100,BCLAYERTAG);

        var v0=[cc.p(0,0),cc.p(WINSIZE.width,0),cc.p(WINSIZE.width,WINSIZE.height),cc.p(0,WINSIZE.height)];
        var drawback=new cc.DrawNode();
        drawback.drawPoly(v0,cc.color(0,0,0,200),2,cc.color(255, 0, 0, 0));

        var clipnode=new cc.ClippingNode(drawback);
        bclayer.addChild(clipnode);
        clipnode.addChild(drawback);
        clipnode.setInverted(true);

        var node=new cc.Node();
        var str=new Array();
        var ignore=false;
        str.push("拖动方块到上方区域");
        str.push("横竖满格才能消除");

        var hand=new cc.Sprite(wb.appendSceneStr("res/spine/shouzhi.png"));
        hand.setAnchorPoint(cc.p(0.15,0.9));
        bclayer.addChild(hand,10);

        var targetpos;
        var pos;
        var type;

        if(this._guidenumber==1){
            pos=cc.p(nextboxbegin,selectboxoffes+20);
            targetpos=cc.p(2,0);
            type=this._allnodetype[1];
        }else if(this._guidenumber==2){
            pos=cc.p(nextboxbegin+nextboxoffest,selectboxoffes+20);
            targetpos=cc.p(1,2);
            type=this._allnodetype[2];
        }else if(this._guidenumber==3){
            pos=cc.p(nextboxbegin+2*nextboxoffest,selectboxoffes+20);
            targetpos=cc.p(0,0);
            type=this._allnodetype[7];
        }

        var selectbox=new BoxNode(type.shape);
        selectbox.setScale(selectboxsize);
        node.addChild(selectbox,9);
        selectbox.setRotate(type.angle);
        selectbox.setPosition(selectbox.getCenterAnPointX(cc.p(nextboxbegin+nextboxoffest*(this._guidenumber-1),selectboxoffes)));

        var selectbox2=new BoxNode(type.shape);
        node.addChild(selectbox2,9);
        selectbox2.setRotate(type.angle);
        selectbox2.setPosition(this.chessPos(targetpos.x,targetpos.y));

        hand.setPosition(pos);
        var seq1=new cc.Sequence(new cc.DelayTime(0.5),new cc.MoveTo(1.0,this.chessPos(targetpos.x,targetpos.y)));
        var seq2=new cc.Sequence(new cc.DelayTime(0.5),new cc.MoveTo(0.0,pos));
        hand.runAction(new cc.RepeatForever(new cc.Sequence(seq1,seq2)));

        clipnode.setStencil(node);

        var person=ELSGameTool.getInstance().guidePerson(str,30,ignore);
        bclayer.addChild(person);
        person.setPosition(cc.p(WINSIZE.width/2.0,WINSIZE.height*0.6));
    },

    //引导初始棋盘
    guideChess:function () {
        var vec=[0,0,0,3,3,3,3,3,0,0,0,3,3,3,3,3,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,4,4,0,0,0,0,0,0,4,4,0,0,0,0,0,0,4,4,0,0,0,0,0,0,4,4,0,0,0,0,0,0];
        for(var i=0;i<ONEZERO_WIDTH;i++)
            for(var j=0;j<ONEZERO_HEIGHT;j++){
                this._chessInfo[i*ONEZERO_HEIGHT+j]=vec[j*ONEZERO_WIDTH+i];
            }
    },

    //恢复上次存档
    setLastData:function () {
        var lastdata=OneZeroTempData.getInstance().getSaveData();
        if(lastdata._issaved){
            this._firstsavein=true;
            this.setScore(lastdata._score);
            var chessinfo=lastdata._chesspad;
            for(var i=0;i<ONEZERO_WIDTH;i++)
                for(var j=0;j<ONEZERO_HEIGHT;j++) {
                    var k=parseInt(chessinfo[i*ONEZERO_HEIGHT+j]);
                    if(k>0){
                        var box=new cc.Sprite(chesspng[k-1]);
                        this._clip.addChild(box,CHESSMAN_LEVEL,i*ONEZERO_HEIGHT+j);
                        box.setPosition(this.chessPos(i,j));
                        box.setScale(ONEZERO_CHESS_SCALE);
                        this._chessInfo[i*ONEZERO_HEIGHT+j]=k;
                    }
                }
            var chessid=lastdata._chessid;
            var id="";
            var order=0;
            for(var i in chessid){
                if(chessid[i]==='#'){
                    var key=parseInt(id);
                    if(key==0){
                        this._selectExit[order]=false;
                    }else{
                        this._selectExit[order]=true;
                        key--;
                    }
                    this._typeid[order]=key;
                    order++;
                    id="";
                    if(order===3){
                        break;
                    }
                }else{
                    id+=chessid[i];
                }
            }

        }
    },

    start:function () {
        this.setGameState(GameState.STATE_RUN);
    },

    run:function () {
        this.setGameState(GameState.STATE_RUN);
    },

    Rotate:function (key) {
        for(var i=0;i<3;i++){
            this.removeChildByTag(1000+i);
            this._selectExit[i]=false;
        }

        this.startNewRound(key);
        if(key==1)
            this.BoxFillJudge();
    },

    restart:function () {
        this.setGameState(GameState.STATE_RUN);
        this.setTouchState(TouchState.TOUCH_TRUE);
        this.setScore(0);
        for(var i=0;i<ONEZERO_WIDTH;i++)
            for(var j=0;j<ONEZERO_HEIGHT;j++){
                if(this._chessInfo[i*ONEZERO_HEIGHT+j]>0){
                    this._clip.removeChildByTag(i*ONEZERO_HEIGHT+j);
                    this._chessInfo[i*ONEZERO_HEIGHT+j]=0;
                }
            }
        this.Rotate(1);
    },

    resurrenction:function () {
        this.setGameState(GameState.STATE_RUN);
        this.Rotate(2);
        this.runAction(new cc.Sequence(new cc.DelayTime(0.1),new cc.CallFunc(function () {
            this.BoxFillJudge();
            this.setTouchState(TouchState.TOUCH_TRUE);
        }.bind(this))));
    },

    onTouchBegan:function (touch,event) {
        var startpos=touch.getLocation();
        var target=event.getCurrentTarget();

        cc.log("touchxxx");

        if (target.getGameState() != GameState.STATE_RUN || target.getTouchState() != TouchState.TOUCH_TRUE || target._touchselect>0){
            if(target._touchselect>0&&target.getTouchState()==TouchState.TOUCH_TRUE){
                this.endTouch();
            }
            return false;
        }

        target._touchselect=0;
        if (startpos.y > 0 && startpos.y < heightoffest&&startpos.x)
        {
            var k = parseInt((startpos.x - nextboxbegin) / nextboxoffest + 0.5);
            if (k >= 0 && k < 3 && target._selectExit[k])
            {
                if(target._guide){
                    if(k==(target._guidenumber-1)){
                        var lay=cc.director.getRunningScene().getChildByTag(BCLAYERTAG);
                        if(lay){
                            lay.setVisible(false);
                        }else{
                            return false;
                        }
                    }else{
                        return false;
                    }
                }
                target._touchselect = k + 1;
                var box = target.getChildByTag(1000 + k);
                if (box.getColor().r==255)
                {
                    box.stopAllActions();
                    var pos=box.getCenterAnPoint(startpos);
                    box.setPosition(cc.p(pos.x,pos.y+boxtofiger));
                    box.setScale(shadomscale);
                    return true;
                }
                else
                {
                    target._touchselect = 0;
                    return false;
                }
            }
        }
        return false;
    },

    onTouchMoved:function (touch,event) {
        var recentpos=touch.getLocation();
        var target=event.getCurrentTarget();

        if(target._touchselect<0||target.getTouchState()==TouchState.TOUCH_FAILD)
            return;

        var selectbox=target.getChildByTag(1000+target._touchselect-1);
        var pos=selectbox.getCenterAnPoint(recentpos);
        selectbox.setPosition(cc.p(pos.x,pos.y+boxtofiger));

        target.showTipBox(selectbox);
    },

    onTouchEnded:function (touch,event) {
        var target=event.getCurrentTarget();
        if(target._touchselect<=0||target.getTouchState()==TouchState.TOUCH_FAILD)
            return;

        target.endTouch();
    },

    showTipBox:function (box) {
        var fillvec=this.getFillBlack(box,box.getPosition());
        if(fillvec.length>0){
            if(fillvec[0]!=this._chesstippos){
                for(var i in this._tempshowblack){
                    this._clip.removeChildByTag(1000+this._tempshowblack[i].x*ONEZERO_HEIGHT+this._tempshowblack[i].y);
                }
                this._tempshowblack=[];
                this._chesstippos=fillvec[0];
                for(var i in fillvec){
                    var sp=new cc.Sprite(chesspng[box._shape%5]);
                    this._clip.addChild(sp,CHESSMAN_LEVEL-1,1000+fillvec[i].x*ONEZERO_HEIGHT+fillvec[i].y);
                    sp.setPosition(this.chessPos(fillvec[i].x,fillvec[i].y));
                    sp.setScale(ONEZERO_CHESS_SCALE*shadomscale);
                    sp.setOpacity(120);
                }
                this._tempshowblack=fillvec.concat();
            }
        }else{
            for(var i in this._tempshowblack){
                this._clip.removeChildByTag(1000+this._tempshowblack[i].x*ONEZERO_HEIGHT+this._tempshowblack[i].y);
            }
            this._tempshowblack=[];
            this._chesstippos=this.chessPt(box.getPosition());
        }
    },

    endTouch:function () {
        this.removeTipBox();
        this.setTouchState(TouchState.TOUCH_FAILD);
        var box=this.getChildByTag(1000+this._touchselect-1);
        var fillvec=this.getFillBlack(box,box.getPosition());

        var guideposjudge=true;
        if(this._guide){
            var boxpos=this.chessPt(box.getPosition());
            if(this._guidenumber==1){
                if(boxpos.x!=2||boxpos.y!=0){
                    guideposjudge=false;
                }
            }else if(this._guidenumber==2){
                if(boxpos.x!=1||boxpos.y!=2){
                    guideposjudge=false;
                }
            }else if(this._guidenumber==3){
                if(boxpos.x!=0||boxpos.y!=0){
                    guideposjudge=false;
                }
            }
        }

        if(!fillvec||fillvec.length==0||!guideposjudge){
            if(this._guide){
                var lay=cc.director.getRunningScene().getChildByTag(BCLAYERTAG);
                if(lay){
                    lay.setVisible(true);
                }
            }

            box.setScale(selectboxsize);
            var resvec=cc.p(nextboxbegin+nextboxoffest*(this._touchselect-1),selectboxoffes);
            box.runAction(new cc.Sequence(new cc.MoveTo(0.1,box.getCenterAnPointX(resvec)),new cc.CallFunc(function () {
                this._touchselect=0;
                this.setTouchState(TouchState.TOUCH_TRUE);
            }.bind(this))));
        }else{
            if(this._guide){
                var lay=cc.director.getRunningScene().getChildByTag(BCLAYERTAG);
                lay.removeFromParent();

                if(this._guidenumber==3){
                    this.endGuide();
                }else{
                    this._guidenumber++;
                    this.runAction(new cc.Sequence(new cc.DelayTime(1.0),new cc.CallFunc(function () {
                        this.GameGuide();
                    }.bind(this))));
                }
            }
			
			ELSGameTool.getInstance().playVideo(VIDEO[12]);

            box.runAction(new cc.Sequence(new cc.MoveTo(0.01,this.chessPos(fillvec[0].x,fillvec[0].y)),new cc.CallFunc(function(){
                box.removeFromParent();
                this._selectExit[this._touchselect-1]=false;
                this.startNewRound();
                this._touchselect=0;
                this.chessFill(box._shape,fillvec);
                this.runAction(new cc.Sequence(new cc.DelayTime(chessfilltime),new cc.CallFunc(function () {
                    var time=chessfilltime+this.chessCheck();
                    this.runAction(new cc.Sequence(new cc.DelayTime(time),new cc.CallFunc(function () {
                        this.BoxFillJudge();
                        this.faildJudge();
                    }.bind(this))));
                }.bind(this))));
            }.bind(this))));
        }
    },

    //结束引导
    endGuide:function () {
        this.guideTip(2);
        this._guide=false;
        ELSGameData.getInstance().setGameGuide(GameName[2],false);
    },

    BoxFillJudge:function(){
        for(var i=0;i<3;i++){
            if(this._selectExit[i]){
                var box=this.getChildByTag(1000+i);
                if(this.BoxJudge(i))
                    box.setNormal();
                else
                    box.setGray();
            }
        }
    },

    faildJudge:function () {
        if(this.chessFailedJudge()){
            this.runAction(new cc.Sequence(new cc.DelayTime(0.2),new cc.CallFunc(function () {
                this.gameFaild();
            }.bind(this))))
            OneZeroTempData.getInstance().clear();
            return true;
        }else{
           this.setTouchState(TouchState.TOUCH_TRUE);
        }
    },

    chessFailedJudge:function () {
        for(var i=0;i<3;i++){
            if(this._selectExit[i]){
                var box=this.getChildByTag(1000+i);
                if(box._boxcolor==ColorIndex.BOX_NORMAL){
                    return false;
                }
            }
        }
        return true;
    },

    gameFaild:function () {
        cc.log("game failed");
        var lay=new FaildLayer();
        this.getParent().addChild(lay,100);
    },

    chessCheck:function () {
        var eliminatex=[];
        var eliminatey=[];
        for(var i=0;i<ONEZERO_WIDTH;i++){
            var temp=true;
            for(var j=0;j<ONEZERO_HEIGHT;j++){
                if(this._chessInfo[i*ONEZERO_HEIGHT+j]==0){
                    temp=false;
                }
            }
            if(temp){
                eliminatex.push(i);
            }
        }

        for(var j=0;j<ONEZERO_HEIGHT;j++){
            var temp=true;
            for(var i=0;i<ONEZERO_WIDTH;i++){
                if(this._chessInfo[i*ONEZERO_HEIGHT+j]==0){
                    temp=false;
                }
            }
            if(temp){
                eliminatey.push(j);
            }
        }

        if (eliminatex.length>0 || eliminatey.length>0) {
            return this.eliminateAnimation(eliminatex, eliminatey);
        }
        else
            return 0.0;
    },

    eliminateAnimation:function (vx,vy) {
        var ftime=0.02;
        var orign=this._score;
        var action=[];
        if(vx.length>0){
            for(var i in vx){
                for(var j=0;j<ONEZERO_HEIGHT;j++){
                    if(this._chessInfo[vx[i]*ONEZERO_HEIGHT+j]){
                        if(j!=0){
                            action.push(new cc.DelayTime(0.02));
                        }
                        action.push(new cc.CallFunc(function (t,data) {
                            this.addParticle(data.kx,data.ky);
                            this.removeBox(data.kx,data.ky);
                        }.bind(this),this,{kx:vx[i],ky:j}))
                        ftime+=0.02;
                    }
                }
            }
        }

        if(vy.length>0){
            for(var j in vy){
                for(var i=0;i<ONEZERO_WIDTH;i++){
                    if(vx.length==0||vx.indexOf(i)==-1){
                        if(i!=0){
                            action.push(new cc.DelayTime(0.02));
                        }
                        action.push(new cc.CallFunc(function (t,data) {
                            this.addParticle(data.kx,data.ky);
                            this.removeBox(data.kx,data.ky);
                        }.bind(this),this,{kx:i,ky:vy[j]}));
                        ftime+=0.02;
                    }
                }
            }
        }

        var xynum=vx.length+vy.length;
        if(xynum>0){
            this._score+=this.getScoreByRow(xynum);
            ELSGameTool.getInstance().playVideo(VIDEO[6]);
        }

        if(action.length>0)
            this.runAction(new cc.Sequence(action));

        return ftime;
    },

    getScoreByRow:function (num) {
        var res = 0;
        if (num == 1) {
            res = 100;
        }
        else if (num == 2) {
            res = 300;
        }
        else if (num == 3) {
            res = 800;
        }
        else if (num == 4) {
            res = 1500;
        }
        else if (num == 5) {
            res = 2500;
        }
        else if (num == 6) {
            res = 4000;
        }
        else if (num == 7) {
            res = 6000;
        }
        else if (num == 8) {
            res = 10000;
        }
        return res;
    },

    removeBox:function (x,y) {
        this._clip.removeChildByTag(x*ONEZERO_HEIGHT+y);
        this._chessInfo[x*ONEZERO_HEIGHT+y]=0;
    },

    addParticle:function (i,j) {
        var key=this._chessInfo[i*ONEZERO_HEIGHT+j];
        var index=(key-1)%5;
        ELSGameTool.getInstance().addFkLizi(this,this.chessPos(i,j),index);
    },

    removeTipBox:function () {
        for(var i in this._tempshowblack){
            this._clip.removeChildByTag(1000+this._tempshowblack[i].x*ONEZERO_HEIGHT+this._tempshowblack[i].y);
        }
        this._tempshowblack=[];
        this._chesstippos=cc.p(-1,-1);
    },

    getFillBlack:function (node,pt) {
        var vec=[];
        var centerpos = this.chessPt(pt);
        var centerx = centerpos.x;
        var centery = centerpos.y;
        if (centerx<0 || centery<0 || centerx>ONEZERO_WIDTH || centery>ONEZERO_HEIGHT)
        {
            //
        }
        else
        {
            var fillvec = node.getBoxFill();
            for (var i in fillvec) {
                fillvec[i].x += centerx;
                fillvec[i].y += centery;
                if (fillvec[i].x < 0 || fillvec[i].x >= ONEZERO_WIDTH || fillvec[i].y < 0 || fillvec[i].y >= ONEZERO_HEIGHT || this._chessInfo[fillvec[i].x*ONEZERO_HEIGHT + fillvec[i].y]) {
                    vec=[];
                    break;
                }
                else {
                    vec.push(fillvec[i]);
                }
            }
        }
        return vec;
    },

    chessFill:function (shape,vec) {
        for(var i in vec){
            var box=new cc.Sprite(chesspng[shape%5]);
            this._clip.addChild(box,CHESSMAN_LEVEL,vec[i].x*ONEZERO_HEIGHT+vec[i].y);
            box.setPosition(this.chessPos(vec[i].x,vec[i].y));
            box.setScale(ONEZERO_CHESS_SCALE);
            this._chessInfo[vec[i].x*ONEZERO_HEIGHT+vec[i].y]=shape%5+1;
            box.runAction(new cc.Sequence(new cc.ScaleTo(0.1,1.05*ONEZERO_CHESS_SCALE),new cc.ScaleTo(0.05,ONEZERO_CHESS_SCALE)));
            this.setScore(this.getScore()+10);
        }
    },

    NodeType:function (type,angle) {
        var ttype=type?type:ShapeIndex.POINT_SHAPE;
        var tangle=angle?angle:AngleIndex.ANGLE_0;
        return {shape:ttype,angle:tangle};
    },

    //初始化所有图形
    initAllNodeType:function () {
        this._allnodetype.push(this.NodeType(ShapeIndex.POINT_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINETWO_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINETWO_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.ANGLE_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.ANGLE_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINESMALL_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINESMALL_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.SQUARE_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINE_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINE_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.L_RESHAPE,AngleIndex.ANGLE_270));
        this._allnodetype.push(this.NodeType(ShapeIndex.L_SHAPE,AngleIndex.ANGLE_270));
        this._allnodetype.push(this.NodeType(ShapeIndex.T_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.T_SHAPE,AngleIndex.ANGLE_270));
        this._allnodetype.push(this.NodeType(ShapeIndex.SWAGER_RESHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.SWAGER_RESHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LBIG_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.LBIG_SHAPE,AngleIndex.ANGLE_180));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINEFINE_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.LINEFINE_SHAPE,AngleIndex.ANGLE_90));
        this._allnodetype.push(this.NodeType(ShapeIndex.TEN_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.U_SHAPE,AngleIndex.ANGLE_270));
        this._allnodetype.push(this.NodeType(ShapeIndex.U_SHAPE,AngleIndex.ANGLE_180));
        this._allnodetype.push(this.NodeType(ShapeIndex.W_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.TBIG_SHAPE));
        this._allnodetype.push(this.NodeType(ShapeIndex.SQUAREBIG_SHAPE));
    },

    //初始化棋盘
    initChess:function () {
        var vec=[
            cc.p(WINSIZE.width/2-ONEZERO_SIZE_WIDTH*ONEZERO_WIDTH/2,heightoffest),
            cc.p(WINSIZE.width/2+ONEZERO_SIZE_WIDTH*ONEZERO_WIDTH/2,heightoffest),
            cc.p(WINSIZE.width/2+ONEZERO_SIZE_WIDTH*ONEZERO_WIDTH/2,heightoffest+ONEZERO_SIZE_WIDTH*ONEZERO_HEIGHT),
            cc.p(WINSIZE.width/2-ONEZERO_SIZE_WIDTH*ONEZERO_WIDTH/2,heightoffest+ONEZERO_SIZE_WIDTH*ONEZERO_HEIGHT),
        ];
        var node=new cc.DrawNode();
        node.drawPoly(vec,cc.color(255,255,255,0),2,cc.color(255, 0, 0, 0));

        this._clip=new cc.ClippingNode(node);

        this.addChild(this._clip,10);

        this._PointTipLayer=new cc.Layer();
        this._clip.addChild(this._PointTipLayer,CHESSMAN_LEVEL-1);

        for(var i=0;i<ONEZERO_WIDTH;i++)
            for(var j=0;j<ONEZERO_HEIGHT;j++){
                var sp=new cc.Sprite(res.chess_di_png)
                this.addChild(sp);
                sp.setScale(ONEZERO_SIZE_WIDTH/42.0);
                sp.setPosition(this.chessPos(i,j));
            }
    },

    chessPos:function (i,j) {
        return cc.p(WINSIZE.width/2+(i-(ONEZERO_WIDTH-1)/2.0)*ONEZERO_SIZE_WIDTH,heightoffest+(0.5+j)*ONEZERO_SIZE_WIDTH);
    },

    chessPt:function (pt) {
        var centerx=((pt.x-WINSIZE.width/2.0)/ONEZERO_SIZE_WIDTH)+ONEZERO_HEIGHT/2.0;
        var centery=(pt.y-heightoffest)/ONEZERO_SIZE_WIDTH;
        if(centerx<0)
            centerx-=1;
        if(centery<0)
            centery-=1;
        return cc.p(parseInt(centerx),parseInt(centery));
    },

    startNewRound:function (key) {

        key=key?key:1;

        if(!this._firstsavein){
            for(var i=0;i<3;i++){
                if(this._selectExit[i])
                    return;
            }
        }

        var shapeid=[];
        var ttemp=true;
        do{
            ttemp=true;
            for(var i=0;i<3;i++){
                var keyid=OnezeroConfig.getInstance().getIndexByScore(this.getScore());
                if(this._guide){
                    if(i==0){
                        keyid=1;
                    }else if(i==1){
                        keyid=2;
                    }else if(i==2){
                        keyid=7;
                    }
                }
                else if(this._firstsavein){
                    keyid=this._typeid[i];
                }
                else if(key==2){
                    if(i==0){
                        keyid=0;
                    }else if(i==1){
                        keyid=parseInt(wb.randNum(1,2));
                    }
                }

                shapeid[i]=keyid;
                this._typeid[i]=keyid;
                if(!this._firstsavein){
                    if(this.BoxJudge(i))
                        ttemp=false;
                }else{
                    ttemp=false;
                }
            }
        }while(ttemp);

        for(var i=0;i<3;i++){
            if(!this._firstsavein||this._selectExit[i]){
                var key=this._allnodetype[shapeid[i]];
                var selectBox=new BoxNode(key.shape);
                selectBox.setScale(selectboxsize);
                selectBox.setRotate(key.angle)
                this.addChild(selectBox,11,1000+i);
                var pos=selectBox.getCenterAnPointX(cc.p(nextboxbegin+nextboxoffest*i,selectboxoffes));
                selectBox.setPosition(pos);
                this._selectExit[i] = true;
            }
        }

        if(this._firstsavein){
            this._firstsavein=false;
        }
        this.BoxFillJudge();
    },

    BoxJudge:function (key) {
        var nodekey=this._allnodetype[this._typeid[key]];
        var node=new BoxNode(nodekey.shape,nodekey.angle);
        var fillvec=node.getBoxFill();
        for(var i=0;i<ONEZERO_WIDTH;i++){
            for(var j=0;j<ONEZERO_HEIGHT;j++){
                var temp=true;
                for (var k in fillvec)
                {
                    var kx = fillvec[k].x + i;
                    var ky = fillvec[k].y + j;
                    if (kx >= 0 && kx < ONEZERO_WIDTH&&ky >= 0 && ky < ONEZERO_HEIGHT)
                    {
                        if (this._chessInfo[kx*ONEZERO_HEIGHT + ky])
                        {
                            temp = false;
                            break;
                        }
                    }
                    else
                    {
                        temp = false;
                        break;
                    }
                }
                if (temp)
                    return true;
            }
        }
        return false;
    },



})