TETRIS_CHESS_SCALE=42.0/64.0;
TETRIS_SIZE_WIDTH=42;
TETRIS_WIDTH=10;
TETRIS_HEIGHT=20;
CHESS_REMOVE_TIME=0.1;
DROP_UPDATE_TIME=0.1;	//方块每行下落需要的时间
DROP_STOP_TIME=1.0;	//方块停顿的时间
sprintshowtime=0.1; //精灵动画时间
CHESS_CHECK_TIME=0.2;	//棋盘cheak的时间

BCLAYERTAG=1211;

var guidenumber=2;

var deltime=10;
var droptime=0.02;
var leveluptime=1.8;	//升级动画时间
var textdelaytime=0.25;//一排方块消失的时间
var upboxtimecycle=18.0;	//升方块时间周期
var upboxtime=0.5;	//上升时间
var SPECIALTIME = 0.3;

var RECENTTAG=1111;
var CLONETAG=1112;

var TetrisManager = GameLayer.extend({

    _clip:null,
    _chessfillinfo:[],
    _nextBox:[],
    _recentBox:-1,
    _recentPos:cc.p(0,0),
    _scoretemppos:cc.p(0,0),
    _toph:[],
    _moveh:[],
    _canup:false,
    _touchcan:true,
    _touchbox:-1,
    _touchft:0,
    _scorecolor:0,
    _specialTime:0,
    _losttouchpos:cc.p(0,0),
    _starttouchpos:cc.p(0,0),
    _firstsavein:false,
    _guide:false,
    _guidenumber:0,
    _guideJudge:false,
    _guidepage:false,
    ctor:function () {
        this._super();
        this.init();
    },

    init:function(){

        this._guide=ELSGameData.getInstance().getGameGuide(GameName[1]);
        this._guidenumber=0;
        this._guideJudge=false;
        this._guidepage=false;

        this.initChess();

        this.setTouchState(TouchState.TOUCH_TRUE);
        this.setGameState(GameState.STATE_STOP);

        this.initNextBox();
        this.setScore(0);
        this.setLevel(1);
        this.setTarget(this.getScoreByLevel(1));
        this.setHang(0);
        for(var i=0;i<TETRIS_WIDTH;i++){
            for(var j=0;j<TETRIS_HEIGHT;j++){
                this._chessfillinfo[i*TETRIS_HEIGHT+j]=0;
            }
        }

        this.setLastData();

        if(this._guide){
            var vec=[1,1,0,3,3,5,0,5,4,4,1,0,0,0,3,5,0,5,5,4,2,2,2,2,5,5,0,0,5,4];
            this.setGameState(GameState.STATE_STOP);
            for(var i=0;i<TETRIS_WIDTH;i++)
                for(var j=0;j<3;j++){
                    var key=vec[j*TETRIS_WIDTH+i];
                    if(key>0){
                        var boxnode=new cc.Sprite(chesspng[key-1]);
                        this._clip.addChild(boxnode,CHESSMAN_LEVEL,i*TETRIS_HEIGHT+j);
                        boxnode.setPosition(this.chessPos(i,j));
                        boxnode.setScale(TETRIS_CHESS_SCALE);
                        this._chessfillinfo[i*TETRIS_HEIGHT+j]=1;
                    }
                }
        }

        this.levelUpMotion();
        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: this.onTouchBegan,
            onTouchMoved: this.onTouchMoved,
            onTouchEnded: this.onTouchEnded
        },this);

        this.schedule(this.timeSchedule);
        this.schedule(this.specicalTime);

        this.run();
    },

    //恢复上次存档
    setLastData:function () {
        var lastdata=TetrisTempData.getInstance().getSaveData();
        if(lastdata._issaved){
            this._firstsavein=true;
            this.setLevel(lastdata._level);
            this.setScore(lastdata._score);
            this.setTarget(lastdata._target);
            this.setHang(lastdata._hang);
            var chessinfo=lastdata._chesspad;
            for(var i=0;i<TETRIS_WIDTH;i++)
                for(var j=0;j<TETRIS_HEIGHT;j++) {
                    var k=parseInt(chessinfo[i*TETRIS_HEIGHT+j]);
                    if(k>0){
                        var boxnode=new cc.Sprite(chesspng[k-1]);
                        this._clip.addChild(boxnode,CHESSMAN_LEVEL,i*TETRIS_HEIGHT+j);
                        boxnode.setPosition(this.chessPos(i,j));
                        boxnode.setScale(TETRIS_CHESS_SCALE);
                        this._chessfillinfo[i*TETRIS_HEIGHT+j]=k;
                    }
                }
            var chessid=lastdata._chessid;
            var id="";
            var order=0;
            for(var i in chessid){
                if(chessid[i]==='#'){
                    var key=parseInt(id);
                    if(key>=0){
                        this._nextBox[order]=parseInt(id);
                        order++;
                    }else{
                        this._nextBox[2]=parseInt(Math.random()*9);
                    }
                    id="";
                    if(order===3){
                        break;
                    }
                }else{
                    id+=chessid[i];
                }
            }

        }
    },

    run:function(){
        this.schedule(this.boxDropTip,0.1);
        this.runAction(new cc.Sequence(new cc.DelayTime(0.8),new cc.CallFunc(function () {
            this.schedule(this.boxDropUpdate,DROP_UPDATE_TIME+DROP_STOP_TIME);
        }.bind(this))));
        this.setGameState(GameState.STATE_RUN);
    },

    start:function(){
        this.setGameState(GameState.STATE_RUN);
    },

    restart:function(){
        this.setLevel(1);
        this.setTarget(this.getScoreByLevel(1));
        this.setHang(0);
        this.setScore(0);

        for (var i = 0; i < TETRIS_WIDTH; i++)
             for (var j = 0; j < TETRIS_HEIGHT; j++) {
                if (this._chessfillinfo[i*TETRIS_HEIGHT+j]) {
                    this._clip.removeChildByTag(i*TETRIS_HEIGHT+j);
                    this._clip.removeChildByTag(1000 + i*TETRIS_HEIGHT + j);
                    this._chessfillinfo[i*TETRIS_HEIGHT+j] = 0;
                }
            }

        this._canup=false;
        this.initNextBox();
        this._clip.removeChildByTag(CLONETAG);
        this._clip.removeChildByTag(RECENTTAG);
        this.schedule(this.boxDropTip,0.1);
        this.schedule(this.boxDropUpdate,Math.max(0.2, (DROP_UPDATE_TIME + DROP_STOP_TIME)-0.008*this.getLevel()));
        this.startDropBox();
        this.setGameState(GameState.STATE_RUN);
    },

    resurrenction:function () {
        this.setGameState(GameState.STATE_STOP);
        this.levelUpReward(8);

        this.runAction(new cc.Sequence(new cc.DelayTime(4.0),new cc.CallFunc(function () {
            this.setGameState(GameState.STATE_RUN);
            this.schedule(this.boxDropTip,0.1);
            this.schedule(this.boxDropUpdate,Math.max(0.2,(DROP_UPDATE_TIME+DROP_STOP_TIME)-0.008*this.getLevel()));
            this.startDropBox();
        }.bind(this))));
    },

    specicalTime:function(ft){
        this._specialTime += ft;
    },

    onTouchBegan:function (touch,event) {
        var pos=touch.getLocation();
        var target=event.getCurrentTarget();

        if(target._guide){
            if((guidenumber==3||guidenumber==7)&&target._guidepage){
                target._guidepage=false;
                cc.director.getRunningScene().removeChildByTag(BCLAYERTAG);
                if(guidenumber==3){
                    target.runAction(new cc.Sequence(new cc.DelayTime(0.5),new cc.CallFunc(function () {
                        target.GameGuide();
                    }.bind(target))));
                }
            }else if(guidenumber==7){
                target.endGuide();
            }
            return false;
        }else{
            if (target.getGameState() != GameState.STATE_RUN || target.getTouchState() != TouchState.TOUCH_TRUE || target._recentBox<0)
                return false;
        }

        if ((pos.x > (CenterPoint.x + TETRIS_SIZE_WIDTH*TETRIS_WIDTH / 2)) || (pos.y<(CenterPoint.y))) {
            return false;
        }

        target._losttouchpos=pos;
        target._starttouchpos=pos;
        target._touchbool = false;
        target._touchtime = 0.0;
        target._touchcan = true;
        target._touchbox = -1;

        return true;
    },

    onTouchMoved:function (touch,event) {
        var target=event.getCurrentTarget();

        if(target._recentBox<0||!target._touchcan)
            return;
        var recentpos=touch.getLocation();
        var startpos=target._starttouchpos;
        var previouspos=target._losttouchpos;

        if(Math.sqrt(Math.abs(recentpos.x-startpos.x)*Math.abs(recentpos.x-startpos.x)+Math.abs(recentpos.y-startpos.y)*Math.abs(recentpos.y-startpos.y))>5)
            target._touchbool=true;

        //向右
        if ((recentpos.x>previouspos.x) && (Math.abs(recentpos.x - previouspos.x) >= Math.abs(recentpos.y - previouspos.y)) && (recentpos.x - previouspos.x) >= TETRIS_SIZE_WIDTH)
        {
            target._losttouchpos=recentpos;

            target.MoveRight();

        }
        //向左
        else if ((recentpos.x<previouspos.x) && (Math.abs(recentpos.x - previouspos.x) >= Math.abs(recentpos.y - previouspos.y)) && (previouspos.x - recentpos.x) >= TETRIS_SIZE_WIDTH)
        {
            target._losttouchpos=recentpos;

            target.MoveLeft();

        }
        //向下
        else if (target._touchtime >= 0.3 && (recentpos.y<previouspos.y) && (Math.abs(recentpos.x - previouspos.x)<Math.abs(recentpos.y - previouspos.y)) && (previouspos.y - recentpos.y) >= TETRIS_SIZE_WIDTH*0.5)
        {
            target._losttouchpos=recentpos;

            target.MoveDown();
        }
    },

    onTouchEnded:function (touch,event) {
        var target=event.getCurrentTarget();
        if(target._recentBox<0||!target._touchcan)
            return;

        if (!target._touchbool) {
            target._touchcan = false;
            target.MoveRotate();
        }
        else {
            var previouspos = target._starttouchpos;
            var recentpos = touch.getLocation();
            if (target._touchtime<0.3 && (recentpos.y<previouspos.y) && (Math.abs(recentpos.x - previouspos.x)<Math.abs(recentpos.y - previouspos.y)) && (previouspos.y - recentpos.y) >= TETRIS_SIZE_WIDTH) {
                target.MoveDownDown();
            }else{
                target._touchcan = false;
            }
        }
    },

    timeSchedule:function(ft){
        if(this.getGameState()!=GameState.STATE_RUN)
            return;

        this._touchtime+=ft;
    },

    initChess:function () {
        var vec=[
            cc.p(CenterPoint.x-TETRIS_SIZE_WIDTH*TETRIS_WIDTH/2-5,CenterPoint.y),
            cc.p(CenterPoint.x+TETRIS_SIZE_WIDTH*TETRIS_WIDTH/2+5,CenterPoint.y),
            cc.p(CenterPoint.x+TETRIS_SIZE_WIDTH*TETRIS_WIDTH/2+5,CenterPoint.y+TETRIS_HEIGHT*TETRIS_SIZE_WIDTH+10),
            cc.p(CenterPoint.x-TETRIS_SIZE_WIDTH*TETRIS_WIDTH/2-5,CenterPoint.y+TETRIS_HEIGHT*TETRIS_SIZE_WIDTH+10),
        ];
        var node=new cc.DrawNode();
        node.drawPoly(vec,cc.color(255,255,255,0),2,cc.color(255, 0, 0, 0));

        this._clip=new cc.ClippingNode(node);

        this.addChild(this._clip,10);
      //  this._clip.setInverted(false);

        for(var i=0;i<TETRIS_WIDTH;i++)
            for(var j=0;j<TETRIS_HEIGHT;j++){
                var sp=new cc.Sprite(res.chess_di_png)
                sp.setScale(0.98);
                this.addChild(sp);
                sp.setPosition(this.chessPos(i,j));
            }
    },

    initNextBox:function () {
        this.setStepNumber(0);
        for(var i=0;i<3;i++){
            if(this._guide){
                if(i==0)
                    this._nextBox[i]=ShapeIndex.L_RESHAPE;
                else if(i==1)
                    this._nextBox[i]=ShapeIndex.T_SHAPE;
                else if(i==2)
                    this._nextBox[i]=parseInt(Math.random()*9);
            }else{
                this._nextBox[i]=parseInt(Math.random()*9);
            }
        }
    },

    //当前的层数
    getChessTop:function () {
        var k = 0;
        var top = this.getTopHeight();
        for (var i = 0; i < TETRIS_WIDTH; i++)
        {
            if (top[i] > 0 || this._chessfillinfo[i*TETRIS_HEIGHT] > 0)
                top[i]++;
            if (top[i] > k)
                k = top[i];
        }
        return k;
    },

    levelUpMotion:function () {

        if(this.getLevel()==1){
            ELSGameTool.getInstance().playVideo(VIDEO[1]);
        }

        var fnt=new cc.LabelTTF("第 "+this.getLevel()+" 关");
        fnt.setFontSize(48);
        this._clip.addChild(fnt,CHESSMAN_LEVEL+1);
        fnt.setPosition(cc.p(225,WINSIZE.height/2+100))
        fnt.runAction(new cc.Sequence(new cc.MoveBy(0.3,cc.p(0,100)),new cc.DelayTime(0.5),new cc.CallFunc(function () {
            fnt.removeFromParent();
            if(this.getGameState()==GameState.STATE_STOP){
                this.setGameState(GameState.STATE_RUN);
            }
            this.startDropBox();

        }.bind(this,fnt))));

        if(this._guide){
            fnt.setVisible(false);
            this.guideTip(1);
            return;
        }
    },

    levelUpReward:function (k) {
        var ret = false;
        var top = this.getChessTop();
        if (k > top)
            k = top;

        if (k < 1)
            return false;

        var movetime = 0.4;
        var newline = false;
        var newpos = -1;
        for (var i = 0; i < TETRIS_WIDTH; i++)
        {
            newpos = -1;
            for (var j = (k - 1); j >= 0; j--)
            {
                newline = true;
                if (this._chessfillinfo[i*TETRIS_HEIGHT+j] == 0)
                {
                    ret = true;
                    if (j > 0)
                    {
                        for (var t = j - 1; t >= 0; t--)
                        {
                            if (this._chessfillinfo[i*TETRIS_HEIGHT+t] > 0)
                            {
                                var box = this._clip.getChildByTag(i*TETRIS_HEIGHT + t);
                                box.runAction(new cc.MoveTo(movetime, this.chessPos(i, j)));
                                box.setTag(i*TETRIS_HEIGHT + j);
                                this._chessfillinfo[i*TETRIS_HEIGHT+j] = this._chessfillinfo[i*TETRIS_HEIGHT+t];
                                this._chessfillinfo[i*TETRIS_HEIGHT+t] = 0;
                                newline = false;
                                break;
                            }
                        }
                    }
                    if (newline)
                    {
                        var key = parseInt(wb.randNum(0,4));
                        var boxnode =new cc.Sprite(chesspng[key]);
                        this._clip.addChild(boxnode, CHESSMAN_LEVEL, i*TETRIS_HEIGHT + j);
                        var pos=this.chessPos(i,0);
                        boxnode.setPosition(cc.p(pos.x,pos.y+TETRIS_SIZE_WIDTH*newpos));
                        boxnode.runAction(new cc.MoveTo(movetime, this.chessPos(i, j)));
                        boxnode.setScale(TETRIS_CHESS_SCALE);
                        this._chessfillinfo[i*TETRIS_HEIGHT+j] = 1;
                        newpos--;
                    }
                }
            }
        }

        if (ret) {
            this.runAction(new cc.Sequence(new cc.DelayTime(movetime + 0.2),new cc.CallFunc(function () {
                var ttt;
                var eraselise = [];
                var map = this.getTopHeight();
                var smallh = TETRIS_HEIGHT;
                for (var i = 0; i < TETRIS_HEIGHT; i++) {
                    if (smallh > map[i])
                        smallh = map[i];
                }

                for (var j = 0; j <= smallh; j++) {
                    var tempb = true;
                    for (var i = 0; i < TETRIS_WIDTH; i++) {
                        if (!this._chessfillinfo[i * TETRIS_HEIGHT + j]) {
                            tempb = false;
                            break;
                        }
                    }
                    if (tempb)
                        eraselise.push(j);
                }

                if (eraselise.length > 0) {
                    this.rollEliminate(eraselise);
                }
            }.bind(this))));
        }
        return ret;
    },

    chessPos:function (x,y) {
        return cc.p(CenterPoint.x+TETRIS_SIZE_WIDTH*(x - (TETRIS_WIDTH - 1) / 2.0), CenterPoint.y+10 + (y + 0.5)*TETRIS_SIZE_WIDTH);
    },

    //关卡分数
    getScoreByLevel:function (level) {
        return level*1500 + 60;
    },

    boxDropTip:function (ft) {
        if(!this._guide&&(this.getGameState()!=GameState.STATE_RUN||this._recentBox<0))
            return;

        var recentBox=this._clip.getChildByTag(RECENTTAG);
        var cloneBox=this._clip.getChildByTag(CLONETAG);
        if(cloneBox) {
            cloneBox.setRotation(recentBox.getAngle()*90);

            var vec=cc.p(0,0);
            if(this.boxMoveJudge(DirectionIndex.DIRECTION_D))
            {
                do
                {
                    vec.y-=1;
                } while (this.boxMoveJudge(DirectionIndex.DIRECTION_D,vec));
            }
            if(vec.y<0)
                cloneBox.setPosition(this.chessPos(this._recentPos.x,this._recentPos.y+vec.y));
            else
                cloneBox.setVisible(false);
        }
    },

    //棋子位置更新
    boxDropUpdate:function (ft) {
        if(this._recentBox<0||this.getGameState()!=GameState.STATE_RUN)
            return;

        if(this.boxMoveJudge(DirectionIndex.DIRECTION_D)){
            this.boxDropOneLine();
            if(this._guide){
                this._guidenumber++;
                if(this._guidenumber==guidenumber){
                    this.setGameState(GameState.STATE_STOP);
                    this.GameGuide();
                }
            }
            if(!this.boxMoveJudge(DirectionIndex.DIRECTION_D)){
                ELSGameTool.getInstance().playVideo(VIDEO[12]);
            }
        }else{
            if(this.boxSure()){
                this.checkChess();
            }else{
                TetrisTempData.getInstance().clear();
                this.gameFaild();
            }
        }
    },

    GameGuide:function () {
        var bclayer=new cc.Layer();
        cc.director.getRunningScene().addChild(bclayer,100,BCLAYERTAG);

        this._guidepage=true;
        var v0=[cc.p(0,0),cc.p(WINSIZE.width,0),cc.p(WINSIZE.width,WINSIZE.height),cc.p(0,WINSIZE.height)];
        var drawback=new cc.DrawNode();
        drawback.drawPoly(v0,cc.color(0,0,0,200),2,cc.color(255, 0, 0, 0));

        var clipnode=new cc.ClippingNode(drawback);
        bclayer.addChild(clipnode);
        clipnode.addChild(drawback);
        clipnode.setInverted(true);

        var node=new cc.Node();
        var str=new Array();
        var ignore=false;
        if(guidenumber==2){
            for(var i=0;i<2;i++){
                var tempbox=new BoxNode(ShapeIndex.L_RESHAPE);
                node.addChild(tempbox,9);
                if(i==0){
                    tempbox.setPosition(this.chessPos(5,17));
                }else if(i==1){
                    tempbox.setPosition(this.chessPos(6,1));
                    tempbox.setRotate(AngleIndex.ANGLE_90);
                }
            }
            str.push("通过操作填满空缺的位置");
            str.push("消除横排获取分数");

            var hand=ELSGameTool.getInstance().createHand();
            bclayer.addChild(hand);
            hand.setPosition(this.chessPos(7,2));

            ignore=true;
        }else if(guidenumber==3){
            var tempbox=new BoxNode(ShapeIndex.L_RESHAPE);
            node.addChild(tempbox,9);
            tempbox.setPosition(this.chessPos(5,17));

            var xuanzhuan=new cc.Sprite(wb.appendSceneStr("res/animation/main_ygb/moshi/n_xuanzhuan.png"));
            node.addChild(xuanzhuan,9);
            xuanzhuan.setPosition(cc.p(WINSIZE.width*0.6,WINSIZE.height*0.15));

            str.push("再试试旋转");
            str.push("点击旋转按钮");

            var hand=ELSGameTool.getInstance().createHand();
            bclayer.addChild(hand);
            hand.setPosition(cc.p(WINSIZE.width*0.6,WINSIZE.height*0.15));
        }else if(guidenumber==4){
            var tempbox=new BoxNode(ShapeIndex.L_RESHAPE);
            tempbox.setRotate(AngleIndex.ANGLE_90);
            node.addChild(tempbox,9);
            tempbox.setPosition(this.chessPos(5,17));

            var right=new cc.Sprite(wb.appendSceneStr("res/animation/main_ygb/moshi/n_you.png"));
            node.addChild(right,9);
            right.setPosition(cc.p(WINSIZE.width*0.36,WINSIZE.height*0.15));

            str.push("向右边一点");
            str.push("点击右移按钮");

            var hand=ELSGameTool.getInstance().createHand();
            bclayer.addChild(hand);
            hand.setPosition(cc.p(WINSIZE.width*0.36,WINSIZE.height*0.15));
        }else if(guidenumber==5){
            var tempbox=new BoxNode(ShapeIndex.L_RESHAPE);
            tempbox.setRotate(AngleIndex.ANGLE_90);
            node.addChild(tempbox,9);
            tempbox.setPosition(this.chessPos(6,17));

            var downdown=new cc.Sprite(wb.appendSceneStr("res/animation/main_ygb/moshi/n_sujiang.png"));
            node.addChild(downdown,9);
            downdown.setPosition(cc.p(WINSIZE.width*0.84,WINSIZE.height*0.15));

            str.push("试试快速下落吧");

            var hand=ELSGameTool.getInstance().createHand();
            bclayer.addChild(hand);
            hand.setPosition(cc.p(WINSIZE.width*0.84,WINSIZE.height*0.15));
        }else if(guidenumber==6){
            this.setGameState(GameState.STATE_STOP);

            var next=new cc.Sprite(wb.appendSceneStr("res/animation/main_ygb/moshi/pic2.png"));
            node.addChild(next,9);
            next.setPosition(cc.p(541,900));

            var hand=ELSGameTool.getInstance().createHand();
            bclayer.addChild(hand);
            hand.setPosition(cc.p(541,900));

            str.push("这是即将出现的下一块方块");
            str.push("在方框内用手势也可以操作哦");

            ignore=true;
        }

        guidenumber++;
        clipnode.setStencil(node);

        var person=ELSGameTool.getInstance().guidePerson(str,30,ignore);
        bclayer.addChild(person);
        person.setPosition(cc.p(WINSIZE.width/2.0,WINSIZE.height*0.6));

        var ignore=new ccui.ImageView(res.ignore_png);
        ignore.setTouchEnabled(true);
        ignore.addClickEventListener(function () {
            bclayer.removeFromParent();
            this.endGuide();
        }.bind(this));
        bclayer.addChild(ignore);
        ignore.setPosition(cc.p(120,500))
    },

    endGuide:function () {
        this.guideTip(2);
        this._guide=false;
        this.setGameState(GameState.STATE_RUN);
        ELSGameData.getInstance().setGameGuide(GameName[1],false);
    },

    guideTip:function (key) {
        var kk=0;
        var sst=gxpng[3];
        if(key==2){
            sst=gxpng[4];
        }
        var fnt2=new cc.Sprite(sst);
        this.addChild(fnt2,CHESSMAN_LEVEL+1);
        fnt2.setPosition(cc.p(WINSIZE.width/2-95+kk,680));
        fnt2.runAction(new cc.Sequence(new cc.MoveBy(0.3,cc.p(0,60)),new cc.DelayTime(0.2),new cc.ScaleTo(0.2,1.1),new cc.DelayTime(0.5),new cc.FadeOut(0.3),new cc.CallFunc(function () {
            fnt2.removeFromParent();
        }.bind(this))));
    },

    checkChess:function () {
        var ttt;
        var eraselise=[];
        var map=this.getTopHeight();
        var smallh=TETRIS_HEIGHT;
        for(var i=0;i<TETRIS_WIDTH;i++)
        {
            if(smallh>map[i])
                smallh=map[i];
        }

        for(var j=0;j<=smallh;j++)
        {
            var tempb=true;
            for(var i=0;i<TETRIS_WIDTH;i++)
            {
                if(!this._chessfillinfo[i*TETRIS_HEIGHT+j])
                {
                    tempb=false;
                    break;
                }
            }
            if(tempb)
                eraselise.push(j);
        }
        if(eraselise.length>0)
        {
            if(eraselise.length==2)
            {
                ELSGameTool.getInstance().spriteShow(gxpng[1],cc.p(225,WINSIZE.height/2+100));
            }
            else if(eraselise.length>2)
            {
                ELSGameTool.getInstance().spriteShow(gxpng[2],cc.p(225,WINSIZE.height/2+100));
            }

            var tt=this.rollEliminate(eraselise);

            this._hang += eraselise.length;

            var sc = (eraselise.length > 1 ? eraselise.length * 110 : 100) + 10;

            this.scoreMotion(sc, cc.p(TETRIS_WIDTH / 2, eraselise[0]));

            this.runAction(new cc.Sequence(new cc.DelayTime(tt),new cc.CallFunc(function () {
                if(!this.levelUp())
                {
                    this.runAction(new cc.Sequence(new cc.DelayTime(CHESS_REMOVE_TIME),new cc.CallFunc(function(){
                        this.startDropBox();
                    }.bind(this))));
                }
            }.bind(this))));
            return true;;
        }
        else
        {
            this.scoreMotion(10);

            if(!this.levelUp())
                this.startDropBox();

            return false;
        }
        return ttt;
    },

    //关卡升级
    levelUp:function () {
        if(this.getScore()>=this.getTarget()){
            wb.HjTaskManager.successGame(GameName[1],this.getScore());

            this.setLevel(this.getLevel()+1);
            this.setTarget(this.getTarget()+this.getScoreByLevel(this.getLevel()));

            this.unschedule(this.boxDropUpdate);
            this.schedule(this.boxDropUpdate,Math.max(0.2,(DROP_UPDATE_TIME+DROP_STOP_TIME)-0.008*this.getLevel()));

            this.setGameState(GameState.STATE_STOP);

            this.runAction(new cc.Sequence(new cc.DelayTime(sprintshowtime),new cc.CallFunc(function () {
                this.LevelUpEliminate();
            }.bind(this))));
            return true;
        }
        return false;
    },

    //升级动画
    LevelUpEliminate:function () {
        var tt=false;
        if(this.getChessTop()<10)
            tt=this.levelUpReward(1);
        else
            tt=this.levelUpReward(2);
        var time=0.0;
        if(tt)
            time=1.0;
        this.runAction(new cc.Sequence(new cc.DelayTime(tt),new cc.CallFunc(function () {
            this.levelUpMotion();
        }.bind(this))));
    },

    //分数动画
    scoreMotion:function (score,pt) {
        this.setScore(this.getScore()+score);

        if(score>=100){
            var scorefnt=ELSGameTool.getInstance().getLabelAtlas(score.toString(),res.fnt_png1);
            scorefnt.setScale(1.5);
            this.addChild(scorefnt,15);
            scorefnt.setPosition(this.chessPos(pt.x,pt.y));
            scorefnt.runAction(new cc.Sequence(new cc.MoveBy(1.0,cc.p(0,TETRIS_SIZE_WIDTH)),new cc.CallFunc(function () {
                scorefnt.removeFromParent();
            })));
        }
    },

    //一个方块开始下落
    startDropBox:function(){
        var time=0.0;
        if(this._canup)
        {
            this._touchcan=false;
            this._canup=false;
            var numllnumber=parseInt(Math.random()*3)+1;
            var vec=[];
            for(var i=0;i<numllnumber;i++)
            {
                var k=0;
                var temp=false;
                do
                {
                    k=parseInt(Math.random()*TETRIS_WIDTH);
                    if(vec.indexOf(k)==-1){
                        vec.push(k);
                        temp=true;
                    }
                } while (false);
            }

            for(var i=0;i<TETRIS_WIDTH;i++)
            {
                if(this._chessfillinfo[i*TETRIS_HEIGHT+TETRIS_HEIGHT-1])
                {
                    this.gameFaild();
                    return;
                }
            }

            for(var i=0;i<TETRIS_WIDTH;i++)
            {
                for(var j=(TETRIS_HEIGHT-2);j>=0;j--)
                {
                    if(this._chessfillinfo[i*TETRIS_HEIGHT+j])
                    {
                        var box=this._clip.getChildByTag(i*TETRIS_HEIGHT+j);
                        box.runAction(cc.moveBy(upboxtime,cc.p(0,TETRIS_SIZE_WIDTH)));
                        box.setTag(i*TETRIS_HEIGHT+j+1);
                        this._chessfillinfo[i*TETRIS_HEIGHT+j+1]=this._chessfillinfo[i*TETRIS_HEIGHT+j];
                        this._chessfillinfo[i*TETRIS_HEIGHT+j]=0;
                    }
                }
                if(vec.indexOf(i)==-1)
                {
                    var k=parseInt(Math.random()*5)+1;
                    var boxnode=new cc.Sprite(chesspng[k-1]);
                    this._clip.addChild(boxnode,CHESSMAN_LEVEL,i*TETRIS_HEIGHT);
                    var pos=this.chessPos(i,0);
                    boxnode.setPosition(cc.p(pos.x,pos.y-TETRIS_SIZE_WIDTH));
                    boxnode.setScale(TETRIS_CHESS_SCALE);
                    this._chessfillinfo[i*TETRIS_HEIGHT]=k;
                    boxnode.runAction(new cc.MoveBy(upboxtime,cc.p(0,TETRIS_SIZE_WIDTH)));
                }
            }
        }

        this.runAction(new cc.Sequence(new cc.DelayTime(time),new cc.CallFunc(function () {
            this._touchcan=false;
            this._touchbox=-1;

            this._recentPos =cc.p(TETRIS_WIDTH/2.0,TETRIS_HEIGHT-1);
            this._recentBox=this._nextBox[0];
            cc.log(this._nextBox[0]);
            this._scorecolor = this._recentBox;
            var recentBox=new BoxNode(this._recentBox);
            this._clip.addChild(recentBox,CHESSMAN_LEVEL,RECENTTAG);
            var tempbool=true;
            var boxFill=this.getRetBoxFill();
            for(var i in boxFill)
            {
                var key=boxFill[i];
                if(key.y<TETRIS_HEIGHT &&(key.x<0||key.x>=TETRIS_WIDTH||this._chessfillinfo[key.x*TETRIS_HEIGHT+key.y]))
                {
                    tempbool=false;
                    break;
                }
            }
            if(tempbool)
            {
                recentBox.setPosition(this.chessPos(TETRIS_WIDTH/2.0,TETRIS_HEIGHT-1));
                this._nextBox[0]=-1;
                this.createNextBox();

                var cloneBox=new BoxNode(this._recentBox);
                cloneBox.setPosition(this.chessPos(-100,-100));
                this._clip.addChild(cloneBox,CHESSMAN_LEVEL-1,CLONETAG);
                cloneBox.setOpacity(150);
            }
            else
            {
                this._clip.removeChildByTag(RECENTTAG);
                this._recentBox=-1;
                this.gameFaild();
            }

        }.bind(this))));
    },

    //游戏失败
    gameFaild:function () {
        this.unschedule(this.boxDropOneLine);
        this.unschedule(this.boxDropTip);
        this.setGameState(GameState.STATE_FAILD);

        TetrisTempData.getInstance().clear();
        cc.log("game failed");
        var lay=new FaildLayer();
        this.getParent().addChild(lay,100);
    },

    //行消除
    rollEliminate:function (eraselise) {
        var ft=0.0;

        ELSGameTool.getInstance().playVideo(VIDEO[6]);

        _moveh=[];
        for(var i=0;i<TETRIS_HEIGHT;i++) {
            _moveh.push(0);
        }

        var action=[];

        for(var k in eraselise)
        {
            var j=eraselise[k];
            for(var i=0;i<TETRIS_WIDTH;i++)
            {
                if(this._chessfillinfo[i*TETRIS_HEIGHT+j])
                {
                    var k1=i;
                    var k2=j;
                    action.push(new cc.DelayTime(0.02));
                    action.push(new cc.CallFunc(function(t,data){

                        this.addParticle(data.k1,data.k2,this._chessfillinfo[data.k1*TETRIS_HEIGHT+data.k2]);
                        this.removeBox(data.k1,data.k2);

                    }.bind(this),this,{k1:k1,k2:k2}));
                }
                ft+=0.02;
            }

            for(var k=0;k<TETRIS_HEIGHT;k++)
            {
                if(k>j)
                    _moveh[k]++;
            }
        }
        action.push(new cc.DelayTime(0.2));
        action.push(new cc.CallFunc(function () {
            for(var i=0;i<TETRIS_WIDTH;i++)
            for(var j=0;j<TETRIS_HEIGHT;j++)
            {
                var box=this._clip.getChildByTag(i*TETRIS_HEIGHT+j);
                if(_moveh[j]>0&&box)
                {
                    var pos=box.getPosition();
                    var moveto=new cc.MoveTo(CHESS_REMOVE_TIME*0.8,cc.p(pos.x,pos.y-_moveh[j]*TETRIS_SIZE_WIDTH));
                    box.runAction(moveto);

                    box.setTag(i*TETRIS_HEIGHT+j-_moveh[j]);
                    this._chessfillinfo[i*TETRIS_HEIGHT+j-_moveh[j]]=this._chessfillinfo[i*TETRIS_HEIGHT+j];
                    this._chessfillinfo[i*TETRIS_HEIGHT+j]=0;
                }
            }
        }.bind(this)));

        this.runAction(new cc.Sequence(action));

        ft+=CHESS_REMOVE_TIME+0.2;

        return ft;
    },

    addParticle:function (x,y,shapeid) {
        ELSGameTool.getInstance().addFkLizi(this,this.chessPos(x,y),(shapeid-1) % 5,0.8);
    },

    //
    createNextBox:function(){
        var step=this.getStepNumber();
        this.setStepNumber(++step);
        for(var i=1;i<3;i++){
            this._nextBox[i-1]=this._nextBox[i];
        }
        this._nextBox[2]=parseInt(Math.random()*9);
    },

    removeBox:function (x,y) {
        this._chessfillinfo[x*TETRIS_HEIGHT+y]=0;
        this._clip.removeChildByTag(x*TETRIS_HEIGHT+y);
    },

    getTopHeight:function () {
        //每一列的最高层
        var topheight=[];
        for(var i=0;i<TETRIS_WIDTH;i++)
        {
            topheight[i]=-1;
            this._toph[i]=-1;
            for(var j=(TETRIS_HEIGHT-1);j>=0;j--)
            {
                if(this._chessfillinfo[i*TETRIS_HEIGHT+j])
                {
                    topheight[i]=j;
                    this._toph[i]=j;
                    break;
                }
            }
        }
        return topheight;
    },

    //方块位置确定和移除
    boxSure:function () {
        var ret=true;
        var boxfill=this.getRetBoxFill();
        for(var i in boxfill){
            var key=boxfill[i];
            if(key.y>=TETRIS_HEIGHT)
                ret=false;

            if(key.y<TETRIS_HEIGHT&&!this._chessfillinfo[key.x*TETRIS_HEIGHT+key.y]){
                var k=parseInt(this._recentBox)%5+1;
                var boxnode=new cc.Sprite(chesspng[k-1]);
                this._clip.addChild(boxnode,CHESSMAN_LEVEL,key.x*TETRIS_HEIGHT+key.y);
                boxnode.setPosition(this.chessPos(key.x,key.y));
                boxnode.setScale(TETRIS_CHESS_SCALE);
                this._chessfillinfo[key.x*TETRIS_HEIGHT+key.y]=k;
            }
        }

        this._clip.removeChildByTag(RECENTTAG);
        this._clip.removeChildByTag(CLONETAG);
        this._recentBox=-1;
        this._scoretemppos=boxfill[0];
        return ret;
    },

    //棋子向下移动一步
    boxDropOneLine:function () {
        this._recentPos.y-=1;
        var recentbox=this._clip.getChildByTag(RECENTTAG);
        recentbox.setPosition(this.chessPos(this._recentPos.x,this._recentPos.y));
        return true;
    },

    //棋子是否可以移动判断
    boxMoveJudge:function (dir,vec) {
        if(!vec)
            vec=cc.p(0,0);
        var boxfill=this.getRetBoxFill(vec);
        switch (dir)
        {
            case DirectionIndex.DIRECTION_D:
            {
                for(var i in boxfill)
                {
                    var key=boxfill[i];
                    if(0==key.y)
                        return false;
                    else if(key.y<=TETRIS_HEIGHT&&this._chessfillinfo[key.x*TETRIS_HEIGHT+key.y-1]>0)
                        return false;
                }
            }
                break;
            case DirectionIndex.DIRECTION_R:
            {
                for(var i in boxfill)
                {
                    var key=boxfill[i];
                    if((TETRIS_WIDTH-1)==key.x)
                        return false;
                    else if(key.y<TETRIS_HEIGHT&&this._chessfillinfo[(key.x+1)*TETRIS_HEIGHT+key.y]>0)
                        return false;
                }
            }
                break;
            case DirectionIndex.DIRECTION_L:
            {
                for(var i in boxfill)
                {
                    var key=boxfill[i];
                    if(0==key.x)
                        return false;
                    else if(key.y<TETRIS_HEIGHT&&this._chessfillinfo[(key.x-1)*TETRIS_HEIGHT+key.y]>0)
                        return false;
                }
            }
                break;
            default:
                break;
        }

        return true;
    },

    //获取当前棋子的覆盖范围
    getRetBoxFill:function (vec) {
        if(!vec)
            vec=cc.p(0,0);
        var box=this._clip.getChildByTag(RECENTTAG);
        if(box){
            var boxfill=box.getBoxFill();
            for(var i in boxfill){
                boxfill[i].x+=this._recentPos.x+vec.x;
                boxfill[i].y+=this._recentPos.y+vec.y;
            }
            return boxfill;
        }
        return null;
    },

    //方块左移
    MoveLeft:function () {
        if(this.getGameState()!=GameState.STATE_RUN||this.getTouchState()!=TouchState.TOUCH_TRUE||this._recentBox<0)
            return;

        this._specialTime = 0.0;

        if (this.boxMoveJudge(DirectionIndex.DIRECTION_L))
        {
            var recentBox = this._clip.getChildByTag(RECENTTAG);
            this._recentPos.x -= 1;
            var pos=recentBox.getPosition();
            recentBox.setPosition(cc.p(pos.x-TETRIS_SIZE_WIDTH,pos.y));
        }
    },
    //方块右移
    MoveRight:function () {
        if(this._guide){
            if(guidenumber==5&&this._guidepage){
                this._guidepage=false;
                cc.director.getRunningScene().removeChildByTag(BCLAYERTAG);
                this.runAction(new cc.Sequence(new cc.DelayTime(0.5),new cc.CallFunc(function () {
                    this.GameGuide();
                }.bind(this))));
            }else{
                return ;
            }
        }else{
            if(this.getGameState()!=GameState.STATE_RUN||this.getTouchState()!=TouchState.TOUCH_TRUE||this._recentBox<0)
                return;
        }

        this._specialTime = 0.0;

        if (this.boxMoveJudge(DirectionIndex.DIRECTION_R))
        {
            var recentBox = this._clip.getChildByTag(RECENTTAG);
            this._recentPos.x += 1;
            var pos=recentBox.getPosition();
            recentBox.setPosition(cc.p(pos.x+TETRIS_SIZE_WIDTH, pos.y));
        }
    },
    //方块向下
    MoveDown:function () {
        if(this.getGameState()!=GameState.STATE_RUN||this.getTouchState()!=TouchState.TOUCH_TRUE||this._recentBox<0)
            return;

        if (this.boxMoveJudge(DirectionIndex.DIRECTION_D))
        {
            var recentBox = this._clip.getChildByTag(RECENTTAG);
            this._recentPos.y -= 1;
            var pos=recentBox.getPosition();
            recentBox.setPosition(cc.p(pos.x, pos.y-TETRIS_SIZE_WIDTH));
        }
    },
    //方块确定
    MoveDownDown:function () {
        if(this._guide){
            if(guidenumber==6&&this._guidepage){
                this._guidepage=false;
                cc.director.getRunningScene().removeChildByTag(BCLAYERTAG);
                this.endGuide();
            }else
                return;
        }else{
            if(this.getGameState()!=GameState.STATE_RUN||this.getTouchState()!=TouchState.TOUCH_TRUE||this._recentBox<0)
                return;
        }

        var pos = this._recentPos;
        var hoffest = 0;
        while (this.boxMoveJudge(DirectionIndex.DIRECTION_D))
        {
            hoffest++;
            this._recentPos.y--;
        }
        if (hoffest>0)
        {
           // addTail(pos);
           //  for (auto &i : _tailsp) {
           //  auto tmove = MoveBy::create(hoffest*0.01f, Vec2(0, -TETRIS_SIZE_WIDTH*hoffest));
           //  auto teasein = EaseIn::create((ActionInterval*)tmove, EASE_STRENGTH);
           //  i->runAction(Sequence::create(tmove, DelayTime::create(CHESS_CHECK_TIME), CallFunc::create([i]() {
           //      i->removeFromParent();
           //  }), nullptr));
            // }

            this._clip.removeChildByTag(CLONETAG);
            this.setGameState(GameState.STATE_STOP);
            var recentBox = this._clip.getChildByTag(RECENTTAG);

            this.runAction(new cc.Sequence(new cc.DelayTime(hoffest*0.01),new cc.CallFunc(function () {
                ELSGameTool.getInstance().playVideo(VIDEO[12]);
            })));

            var move = new cc.MoveTo(hoffest*0.01,this.chessPos(this._recentPos.x,this._recentPos.y));
            //var move = new cc.MoveBy(hoffest*0.01,cc.p(0,-TETRIS_HEIGHT*hoffest));
            var dtime=new cc.DelayTime(CHESS_CHECK_TIME);
            var call=new cc.CallFunc(function () {
                if(this.getGameState()==GameState.STATE_STOP){
                    this.setGameState(GameState.STATE_RUN);
                }
                this.boxDropUpdate(0.0);
            }.bind(this));
            recentBox.runAction(new cc.Sequence(move,dtime,call));
        }
    },

    //旋转
    MoveRotate:function () {
        if(this._guide){
            if(guidenumber==4&&this._guidepage){
                this._guidepage=false;
                cc.director.getRunningScene().removeChildByTag(BCLAYERTAG);
                this.boxChange();
                this.runAction(new cc.Sequence(new cc.DelayTime(0.5),new cc.CallFunc(function () {
                    this.GameGuide();
                }.bind(this))));
            }
        }else{
            if (this.getGameState() == GameState.STATE_RUN && !this._touchcan&&this._recentBox >= 0 && this._recentBox != ShapeIndex.SQUARE_SHAPE&&this._recentBox != ShapeIndex.POINT_SHAPE)
            {
                this.boxChange();
            }
        }
    },

    boxChange:function (key) {
        var recentBox=this._clip.getChildByTag(RECENTTAG);
        if (!recentBox)
            return false;

        key=key?key:1;

        if(key==1)
            recentBox.Rotate();
        else
            recentBox.ReRotate();

        var boxFill=this.getRetBoxFill();

        var tempbool=true;
        for(var i in boxFill) {
            var key=boxFill[i];
            if((key.y<TETRIS_HEIGHT)&&(key.y<0||key.x<0||key.x>=TETRIS_WIDTH||this._chessfillinfo[key.x*TETRIS_HEIGHT+key.y])) {
                tempbool=false;
                break;
            }
        }

        if(tempbool) {
            this._specialTime = 0.0;
            return true;
        }
        else {
            tempbool=true;
            boxFill=this.getRetBoxFill(cc.p(-1,0));
            for(var i in boxFill) {
                var key=boxFill[i];
                if((key.y<TETRIS_HEIGHT)&&(key.y<0||key.x<0||key.x>=TETRIS_WIDTH||this._chessfillinfo[key.x*TETRIS_HEIGHT+key.y])) {
                    tempbool=false;
                    break;
                }
            }
        }

        //向左移动一个单位
        if(tempbool) {
            this. _specialTime = 0.0;
            this._recentPos.x-=1;
            var pos=recentBox.getPosition();
            recentBox.setPosition(cc.p(pos.x-TETRIS_SIZE_WIDTH,pos.y));
            return true;
        }
        else {
            tempbool=true;
            boxFill=this.getRetBoxFill(cc.p(1,0));
            for(var i in boxFill) {
                var key=boxFill[i];
                if((key.y<TETRIS_HEIGHT)&&(key.y<0||key.x<0||key.x>=TETRIS_WIDTH||this._chessfillinfo[key.x*TETRIS_HEIGHT+key.y])) {
                    tempbool=false;
                    break;
                }
            }
        }

        //向右移动一个单位
        if(tempbool) {
            this._specialTime = 0.0;
            this._recentPos.x+=1;
            var pos=recentBox.getPosition();
            recentBox.setPosition(cc.p(pos.x+TETRIS_SIZE_WIDTH,pos.y));
            return true;
        }
        else {
            tempbool=true;
            if(this._recentBox==ShapeIndex.T_SHAPE||this._recentBox==ShapeIndex.SWAGER_RESHAPE) {
                boxFill=this.getRetBoxFill(cc.p(-1,-1));
                for(var i in boxFill) {
                    var key=boxFill[i];
                    if((key.y<TETRIS_HEIGHT)&&(key.y<0||key.x<0||key.x>=TETRIS_WIDTH||this._chessfillinfo[key.x*TETRIS_HEIGHT+key.y])) {
                        tempbool=false;
                        break;
                    }
                }
            }
            else
                tempbool=false;
        }

        //向左下移动
        if(tempbool) {
            this._specialTime = 0.0;

            this._recentPos.x-=1;
            this._recentPos.y-=1;
            var pos=recentBox.getPosition();
            recentBox.setPosition(cc.p(pos.x-TETRIS_SIZE_WIDTH,pos.y-TETRIS_SIZE_WIDTH));
            return true;
        }
        else {
            //tempbool=true;
            //if(_recentBox==ShapeIndex::T_SHAPE)
            //{
            //	boxFill=getRetBoxFill(Vec2(1,-1));
            //	for(auto &i:boxFill)
            //	{
            //		if((i.second<TETRIS_HEIGHT)&&(i.first<0||i.first>=TETRIS_WIDTH||_chessFilInfo[i.first*TETRIS_HEIGHT+i.second]))
            //		{
            //			tempbool=false;
            //			break;
            //		}
            //	}
            //}
            //else
            tempbool=false;
        }

        //向右下移动
        if(tempbool) {
            this._specialTime = 0.0;
            this._recentPos.x+=1;
            this._recentPos.y-=1;
            var pos=recentBox.getPosition();
            recentBox.setPosition(cc.p(pos.x+TETRIS_SIZE_WIDTH,pos.y-TETRIS_SIZE_WIDTH));
            return true;
        }
        else {
            tempbool=true;
            if(tiis._recentBox==ShapeIndex.LINE_SHAPE||this._recentBox==ShapeIndex.LINESMALL_SHAPE||this._recentBox==ShapeIndex.SWAGER_SHAPE||this._recentBox==ShapeIndex.T_SHAPE) {
                boxFill=this.getRetBoxFill(cc.p(0,-1));
                for(var i in boxFill) {
                    var key= boxFill[i];
                    if((key.y<TETRIS_HEIGHT)&&(key.y<0||key.x<0||key.x>=TETRIS_WIDTH||this._chessfillinfo[key.x*TETRIS_HEIGHT+key.y])) {
                        tempbool=false;
                        break;
                    }
                }
            }
            else
                tempbool=false;
        }

        //向下移动
        if(tempbool) {
            this._specialTime = 0.0;

            this._recentPos.y-=1;
            var pos=recentBox.getPosition();
            recentBox.setPosition(cc.p(pos.x,pos.y-TETRIS_SIZE_WIDTH));
            return true;
        }
        //旋转失败
        else {
            if(key==1)
                recentBox.ReRotate();
            else
                recentBox.Rotate();
            return false;
        }

        return false;

    },

    getNextBox:function (i) {
        return this._nextBox[i];
    },
})