CenterPoint=cc.p(0,0);

var TetrisLayer=cc.Layer.extend({
    _gamemanager:null,

    _level:0,
    _score:0,
    _hang:0,

    _nextSp:null,

    _tempbox:-1,
    ctor:function(){
        this._super();

        ELSGameLogic.getInstance().setGameType(GameType.Type_Tetris);
        this.initLayer();

        ELSGameLogic.getInstance().addLimitHb(this,cc.p(WINSIZE.width*0.84,WINSIZE.height*0.42));
        ELSGameLogic.getInstance().addReturnPage(2);
    },

    initLayer:function(){
        bg=ccs.load(res.TetrisScene_json).node;
        this.addChild(bg);
        bg.setContentSize(WINSIZE);
        ccui.helper.doLayout(bg);

        var dd=bg.getChildByName("di").getPosition();
        CenterPoint=cc.p(dd.x,dd.y-430);

        fnt_level=bg.getChildByName("fnt_level");
        fnt_hang=bg.getChildByName("fnt_hang");
        fnt_highest=bg.getChildByName("fnt_highest");
        fnt_score=bg.getChildByName("fnt_score");
        fnt_score.setAnchorPoint(cc.p(0.5,0.5));
        _nextnode=bg.getChildByName("Node_next");

        //左
        wb.FW(bg,"Button_left",function(){
            this.getManager().MoveLeft();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //右
        wb.FW(bg,"Button_right",function(){
            this.getManager().MoveRight();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //变形
        wb.FW(bg,"Button_flush",function(){
            this.getManager().MoveRotate();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //下下
        wb.FW(bg,"Button_downdown",function(){
            this.getManager().MoveDownDown();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //下
        wb.FW(bg,"Button_down",function(){
            this.getManager().MoveDown();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //暂停
        wb.FW(bg,"Button_pause",function(){
            if(!this.getManager()._guide){
                var layer=new PauseLayer();
                this.addChild(layer,100);
                ELSGameTool.getInstance().playVideo(VIDEO[0]);
            }
        }.bind(this));

        this._gamemanager= new TetrisManager();
        this.addChild(this._gamemanager);

        this._nextSp=new BoxNode(this.getManager().getNextBox(0));
        _nextnode.addChild(this._nextSp);
        this._nextSp.setScale(0.8);
        var tpos=_nextnode.getChildByName("NextOne").getPosition();
        this._nextSp.setPosition(this._nextSp.getCenterAnPoint(cc.p(tpos.x,tpos.y-15)));
        this._tempbox=this.getManager().getNextBox(0);

        this.schedule(this.dataUpdate,0.1);
    },

    getManager:function () {
        return this._gamemanager;
    },

    restart:function () {
        TetrisTempData.getInstance().clear();
        this.getManager().restart();
    },

    dataUpdate:function(ft){
        fnt_level.setString(this.getManager().getLevel().toString());
        fnt_hang.setString(this.getManager().getHang().toString());
        fnt_highest.setString(ELSGameData.getInstance().getTetrisHighScore().toString());
        fnt_score.setString(this.getManager().getScore().toString());

        var key=this.getManager().getNextBox(0);
        if(key!=-1&&key!=this._tempbox){
            this._tempbox=key;
            this._nextSp.removeFromParent();
            this._nextSp=new BoxNode(key);
            _nextnode.addChild(this._nextSp);
            this._nextSp.setScale(0.8);
            var tpos=_nextnode.getChildByName("NextOne").getPosition();
            this._nextSp.setPosition(this._nextSp.getCenterAnPoint(cc.p(tpos.x,tpos.y-15)));
            this._tempbox=this.getManager().getNextBox(0);
        }
    },

});

var TetrisScene=cc.Scene.extend({
    onEnter:function () {
        this._super();

        var layer=new TetrisLayer();
        this.addChild(layer,1,"layer");
    }
})