var BoxNode=cc.Node.extend({
    _shape:null,
    _angle:null,
    _boxcolor:null,
    _boxsize:0,
    _boxscale:0,
    _boxset:[],
    ctor:function (shape,angle) {
        this._super();
        this._shape=shape;
        this._boxset=[];
        this._boxcolor=ColorIndex.BOX_NORMAL;
        if(!angle)
            this._angle=AngleIndex.ANGLE_0;
        else
            this._angle=angle;
        this.init();
    },

    init:function () {
        if(ELSGameLogic.getInstance().getGameType()==GameType.Type_Tetris){
            this._boxsize=42;
        }else if(ELSGameLogic.getInstance().getGameType()==GameType.Type_1010){
            this._boxsize=72;
        }else if(ELSGameLogic.getInstance().getGameType()==GameType.Type_LIUJIAO){
            this._boxsize=57;
        }

        this._boxscale=this._boxsize/64.0;

        var boxfill=this.getBoxFill();
        var nodename=chesspng[parseInt(this._shape)%5];
        for(var i in boxfill){
            var sp=new cc.Sprite(nodename);
            this.addChild(sp,0,i);
            sp.setScale(this._boxscale);
            sp.setPosition(cc.p(boxfill[i].x*this._boxsize,boxfill[i].y*this._boxsize));
            this._boxset.push(sp);
        }
    },

    getBoxFill:function () {
        return this.getBoxFillByData(this._shape,this._angle);
    },

    getBoxFillByData:function (shape,angle) {
        var vec=[];
        vec.push(cc.p(0,0));
        switch (shape)
        {
            case ShapeIndex.L_SHAPE:
            {
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(1,1));
                    }
                        break;
                    case AngleIndex.ANGLE_90:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(1,-1));
                    }
                        break;
                    case AngleIndex.ANGLE_180:
                    {
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(-1,-1));
                    }
                        break;
                    case AngleIndex.ANGLE_270:
                    {
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(-1,1));
                    }
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.L_RESHAPE:
            {
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                    {
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(-1,1));
                    }
                        break;
                    case AngleIndex.ANGLE_90:
                    {
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(1,1));
                    }
                        break;
                    case AngleIndex.ANGLE_180:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(1,-1));
                    }
                        break;
                    case AngleIndex.ANGLE_270:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(-1,-1));
                    }
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.LINE_SHAPE:
            {
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(2,0));
                    }
                        break;
                    case AngleIndex.ANGLE_90:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(0,-2));
                    }
                        break;
                    case AngleIndex.ANGLE_180:
                    {
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(-2,0));
                    }
                        break;
                    case AngleIndex.ANGLE_270:
                    {
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,2));
                    }
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.SQUARE_SHAPE:
            {
                vec.push(cc.p(1,0));
                vec.push(cc.p(0,1));
                vec.push(cc.p(1,1));
            }
                break;
            case ShapeIndex.SWAGER_SHAPE:
            {
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                    {
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(-1,1));
                    }
                        break;
                    case AngleIndex.ANGLE_90:
                    {
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(1,1));
                    }
                        break;
                    case AngleIndex.ANGLE_180:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(1,-1));
                    }
                        break;
                    case AngleIndex.ANGLE_270:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(-1,-1));
                    }
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.SWAGER_RESHAPE:
            {
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(1,1));
                    }
                        break;
                    case AngleIndex.ANGLE_90:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(1,-1));
                    }
                        break;
                    case AngleIndex.ANGLE_180:
                    {
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(-1,-1));
                    }
                        break;
                    case AngleIndex.ANGLE_270:
                    {
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(-1,1));
                    }
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.T_SHAPE:
            {
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                    {
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(0,1));
                    }
                        break;
                    case AngleIndex.ANGLE_90:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(1,0));
                    }
                        break;
                    case AngleIndex.ANGLE_180:
                    {
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(0,-1));
                    }
                        break;
                    case AngleIndex.ANGLE_270:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(-1,0));
                    }
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.POINT_SHAPE:
                break;
            case ShapeIndex.ANGLE_SHAPE:
            {
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                    {
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(0,1));
                    }
                        break;
                    case AngleIndex.ANGLE_90:
                    {
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(0,-1));
                    }
                        break;
                    case AngleIndex.ANGLE_180:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(0,-1));
                    }
                        break;
                    case AngleIndex.ANGLE_270:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(-1,0));
                    }
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.LINESMALL_SHAPE:
            {
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(1,0));
                    }
                        break;
                    case AngleIndex.ANGLE_90:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,-1));
                    }
                        break;
                    case AngleIndex.ANGLE_180:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(1,0));
                    }
                        break;
                    case AngleIndex.ANGLE_270:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,-1));
                    }
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.LBIG_SHAPE:
            {
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(-1,1));
                        vec.push(cc.p(-1,2));
                    }
                        break;
                    case AngleIndex.ANGLE_90:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(1,1));
                        vec.push(cc.p(2,1));				}
                        break;
                    case AngleIndex.ANGLE_180:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(1,-1));
                        vec.push(cc.p(1,-2));
                    }
                        break;
                    case AngleIndex.ANGLE_270:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(-1,-1));
                        vec.push(cc.p(-2,-1));
                    }
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.U_SHAPE:
            {
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(-1,1));
                        vec.push(cc.p(1,1));
                    }
                        break;
                    case AngleIndex.ANGLE_90:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(1,1));
                        vec.push(cc.p(1,-1));				}
                        break;
                    case AngleIndex.ANGLE_180:
                    {
                        vec.push(cc.p(-1,0));
                        vec.push(cc.p(1,0));
                        vec.push(cc.p(-1,-1));
                        vec.push(cc.p(1,-1));
                    }
                        break;
                    case AngleIndex.ANGLE_270:
                    {
                        vec.push(cc.p(0,1));
                        vec.push(cc.p(0,-1));
                        vec.push(cc.p(-1,1));
                        vec.push(cc.p(-1,-1));
                    }
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.SQUAREBIG_SHAPE:
            {
                vec.push(cc.p(1,0));
                vec.push(cc.p(-1,0));
                vec.push(cc.p(1,1));
                vec.push(cc.p(-1,1));
                vec.push(cc.p(0,1));
                vec.push(cc.p(1,2));
                vec.push(cc.p(-1,2));
                vec.push(cc.p(0,2));
            }
                break;
            case ShapeIndex.LINETWO_SHAPE:
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                        vec.push(cc.p(-1, 0));
                        break;
                    case AngleIndex.ANGLE_90:
                        vec.push(cc.p(0, 1));
                        break;
                    default:
                        break;
                }
                break;
            case ShapeIndex.LINEFINE_SHAPE:
                switch (angle)
                {
                    case AngleIndex.ANGLE_0:
                        vec.push(cc.p(1, 0));
                        vec.push(cc.p(-1, 0));
                        vec.push(cc.p(2, 0));
                        vec.push(cc.p(-2, 0));
                        break;
                    case AngleIndex.ANGLE_90:
                        vec.push(cc.p(0, 1));
                        vec.push(cc.p(0, -1));
                        vec.push(cc.p(0, 2));
                        vec.push(cc.p(0, -2));
                        break;
                    default:
                        break;
                }
                break;
            case ShapeIndex.TEN_SHAPE:
                vec.push(cc.p(1, 0));
                vec.push(cc.p(-1, 0));
                vec.push(cc.p(0, 1));
                vec.push(cc.p(0, -1));
                break;
            case ShapeIndex.W_SHAPE:
                vec.push(cc.p(1, 0));
                vec.push(cc.p(0, -1));
                vec.push(cc.p(1, 1));
                vec.push(cc.p(-1, -1));
                break;
            case ShapeIndex.TBIG_SHAPE:
                vec.push(cc.p(0, 1));
                vec.push(cc.p(0, -1));
                vec.push(cc.p(1, -1));
                vec.push(cc.p(-1, -1));
                break;
            default:
                break;
        }

        return vec;
    },

    //顺时针旋转
    Rotate:function () {
        this._angle=(this._angle+1)%4;
        this.setRotation(this._angle*90.0);
        for(var i in this._boxset) {
            var node=this._boxset[i];
            if(node)
                node.setRotation(360-(this._angle*90));
        }
    },

    ReRotate:function () {
        this._angle=(this._angle+3)%4;
        this.setRotation(this._angle*90.0);
        for(var i in this._boxset) {
            var node=this._boxset[i];
            if(node)
                node.setRotation(360-(this._angle*90));
        }
    },

    setRotate:function (angle) {
        this._angle=angle;
        this.setRotation(this._angle*90.0);
        for(var i in this._boxset) {
            var node=this._boxset[i];
            if(node)
                node.setRotation(360-(this._angle*90));
        }
    },

    getAngle:function () {
        return this._angle;
    },

    setAngle:function (angle) {
        this._angle=angle;
    },

    //全体设置透明度
    setOpacity:function (opa) {
        opa=100;
        for(var i in this._boxset) {
            var node=this._boxset[i];
            if(node)
                node.setOpacity(opa);
        }
    },

    //位置居中
    getCenterAnPoint:function (vec) {
        var vv=cc.p(0,0);
        switch (this._shape)
        {
            case ShapeIndex.L_SHAPE:
            case ShapeIndex.L_RESHAPE:
            case ShapeIndex.T_SHAPE:
            case ShapeIndex.U_SHAPE:
            {
                switch(this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(0,-1);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(-1,0);
                        break;
                    case AngleIndex.ANGLE_180:
                        vv=cc.p(0,1);
                        break;
                    case AngleIndex.ANGLE_270:
                        vv=cc.p(1,0);
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.LINE_SHAPE:
            {
                switch(this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(-1,0);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(0,1);
                        break;
                }
            }
                break;
            case ShapeIndex.LINETWO_SHAPE:
            {
                switch (this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(1,0);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(0,-1);
                        break;
                }
            }
                break;
            case ShapeIndex.SQUARE_SHAPE:
            case ShapeIndex.ANGLE_SHAPE:
            {
                switch (this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(-1,-1);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(-1,1);
                        break;
                    case AngleIndex.ANGLE_180:
                        vv=cc.p(1,1);
                        break;
                    case AngleIndex.ANGLE_270:
                        vv=cc.p(1,-1);
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.SWAGER_SHAPE:
            case ShapeIndex.SWAGER_RESHAPE:
            {
                switch(this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(0,-1);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(-1,0);
                        break;
                    case AngleIndex.ANGLE_180:
                        vv=cc.p(0,1);
                        break;
                    case AngleIndex.ANGLE_270:
                        vv=cc.p(1,0);
                        break;
                }
            }
                break;
            case ShapeIndex.POINT_SHAPE:
            case ShapeIndex.LINESMALL_SHAPE:
            case ShapeIndex.LINEFINE_SHAPE:
            case ShapeIndex.TEN_SHAPE:
            case ShapeIndex.W_SHAPE:
            case ShapeIndex.TBIG_SHAPE:
                vv=cc.p(0,0);
                break;
            case ShapeIndex.SQUAREBIG_SHAPE:
            case ShapeIndex.LBIG_SHAPE:
            {
                switch (this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(0,-2);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(-2,0);
                        break;
                    case AngleIndex.ANGLE_180:
                        vv=cc.p(0,2);
                        break;
                    case AngleIndex.ANGLE_270:
                        vv=cc.p(2,0);
                        break;
                    default:
                        break;
                }
            }
                break;
            default:
                break;
        }
        var res=cc.p(vec.x+vv.x*this._boxsize/2.0*this.getScale(),vec.y+vv.y*this._boxsize/2.0*this.getScale());
        return res;
    },

    //x轴位置居中
    getCenterAnPointX:function (vec) {
        var vv=cc.p(0,0);
        switch (this._shape)
        {
            case ShapeIndex.L_SHAPE:
            case ShapeIndex.L_RESHAPE:
            case ShapeIndex.T_SHAPE:
            case ShapeIndex.U_SHAPE:
            {
                switch(this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(0,1);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(-1,3);
                        break;
                    case AngleIndex.ANGLE_180:
                        vv=cc.p(0,3);
                        break;
                    case AngleIndex.ANGLE_270:
                        vv=cc.p(1,3);
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.LINE_SHAPE:
            {
                switch(this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(-1,1);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(0,5);
                        break;
                }
            }
                break;
            case ShapeIndex.SQUARE_SHAPE:
            case ShapeIndex.ANGLE_SHAPE:
            {
                switch (this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(-1,1);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(-1,3);
                        break;
                    case AngleIndex.ANGLE_180:
                        vv=cc.p(1,3);
                        break;
                    case AngleIndex.ANGLE_270:
                        vv=cc.p(1,1);
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.SWAGER_SHAPE:
            case ShapeIndex.SWAGER_RESHAPE:
            {
                switch(this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(0,1);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(-1,3);
                        break;
                    case AngleIndex.ANGLE_180:
                        vv=cc.p(0,3);
                        break;
                    case AngleIndex.ANGLE_270:
                        vv=cc.p(1,3);
                        break;
                }
            }
                break;
            case ShapeIndex.POINT_SHAPE:
                vv=cc.p(0,1);
                break;
            case ShapeIndex.LINESMALL_SHAPE:
            {
                switch(this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(0,1);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(0,3);
                        break;
                }
            }
                break;
            case ShapeIndex.LINETWO_SHAPE:
                switch (this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(1,1);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(0,1);
                        break;
                    default:
                        break;
                }
                break;
            case ShapeIndex.SQUAREBIG_SHAPE:
            case ShapeIndex.LBIG_SHAPE:
            {
                switch (this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(0,1);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(-2,3);
                        break;
                    case AngleIndex.ANGLE_180:
                        vv=cc.p(0,5);
                        break;
                    case AngleIndex.ANGLE_270:
                        vv=cc.p(2,3);
                        break;
                    default:
                        break;
                }
            }
                break;
            case ShapeIndex.LINEFINE_SHAPE:
                switch (this._angle)
                {
                    case AngleIndex.ANGLE_0:
                        vv=cc.p(0,1);
                        break;
                    case AngleIndex.ANGLE_90:
                        vv=cc.p(0,5);
                        break;
                    default:
                        break;
                }
                break;
            case ShapeIndex.TEN_SHAPE:
            case ShapeIndex.W_SHAPE:
            case ShapeIndex.TBIG_SHAPE:
                vv=cc.p(0,3);
                break;
            default:
                break;
        }
        var res=cc.p(vec.x+vv.x*this._boxsize/2.0*this.getScale(),vec.y+vv.y*this._boxsize/2.0*this.getScale());
        return res;
    },

    setNormal:function () {
        if(this._boxcolor==ColorIndex.BOX_NORMAL)
            return;
        this._boxcolor=ColorIndex.BOX_NORMAL;
        for(var i in this._boxset) {
            var node=this._boxset[i];
            if(node){
                node.setVisible(true);
            }
            var gray=this.getChildByTag(100+parseInt(i));
            if(gray){
                gray.setVisible(false);
            }
        }
    },

    setGray:function () {
        if(this._boxcolor==ColorIndex.BOX_GRAY)
            return;
        this._boxcolor=ColorIndex.BOX_GRAY;
        for(var i in this._boxset) {
            var node=this._boxset[i];
            if(node)
                node.setVisible(false);
            var graynode=this.getChildByTag(100+parseInt(i));
            if(graynode)
                graynode.setVisible(true);
            else{
                var graysp=new cc.Sprite(chesspng2[0]);
                this.addChild(graysp,1,100+parseInt(i));
                graysp.setPosition(node.getPosition());
            }
        }
    },

    //设置成虚线模式
    setLineModel:function () {
        this._boxsize*=0.96;
        var boxfill=this.getBoxFill();
        for(var i in boxfill){
            var key=boxfill[i];
            //上

            if(ELSGameTool.getInstance().posIndexOf(boxfill,cc.p(key.x,key.y+1))==-1){
                var sp=new cc.Sprite(res.line_png);
                this.addChild(sp);
                sp.setScale(this._boxscale);
                sp.setPosition(cc.p(key.x*this._boxsize,(key.y+0.5)*this._boxsize));
            }

            //下
            if(ELSGameTool.getInstance().posIndexOf(boxfill,cc.p(key.x,key.y-1))==-1){
                var sp=new cc.Sprite(res.line_png);
                this.addChild(sp);
                sp.setScale(this._boxscale);
                sp.setPosition(cc.p(key.x*this._boxsize,(key.y-0.5)*this._boxsize));
            }

            //左
            if(ELSGameTool.getInstance().posIndexOf(boxfill,cc.p(key.x-1,key.y))==-1){
                var sp=new cc.Sprite(res.line_png);
                this.addChild(sp);
                sp.setRotation(90);
                sp.setScale(this._boxscale);
                sp.setPosition(cc.p((key.x-0.5)*this._boxsize,key.y*this._boxsize));
            }

            //右
            if(ELSGameTool.getInstance().posIndexOf(boxfill,cc.p(key.x+1,key.y))==-1){
                var sp=new cc.Sprite(res.line_png);
                this.addChild(sp);
                sp.setRotation(90);
                sp.setScale(this._boxscale);
                sp.setPosition(cc.p((key.x+0.5)*this._boxsize,key.y*this._boxsize));
            }
        }
        for(var i in this._boxset) {
            var node=this._boxset[i];
            if(node)
                node.removeFromParent();
        }

    },

})
