var PauseLayer=BaseLayer.extend({
    ctor:function () {
        this._super();

        ELSGameLogic.getInstance().openAd("pause");
        this.initLayer();
        this.runAction(new cc.Sequence(new cc.DelayTime(0.0),new cc.CallFunc(function () {
            this.gamePause();
        }.bind(this))));

        ELSGameLogic.getInstance().addSingleSend(this,cc.p(586,420));
    },

    getGameManager:function () {
        return this.getParent().getManager();
    },

    //
    gamePause:function () {
        this.runAction(new cc.Sequence(new cc.DelayTime(0.1),new cc.CallFunc(function () {
            //保存当前游戏数据
            var tag=ELSGameLogic.getInstance().getGameType();
            if(tag==1){
                MatchTempData.getInstance().save(this.getGameManager());
            }else if(tag==2){
                OneZeroTempData.getInstance().save(this.getGameManager());
            }else if(tag==3){
                LJTempData.getInstance().save(this.getGameManager());
            }
        }.bind(this))));


        this.getGameManager().setGameState(GameState.STATE_PAUSE);
        //暂停或者退出游戏时保存游戏时长
        wb.HJCore.onOutGame();
    },

    gameStart:function () {
        //进入游戏开始统计在线时长
        wb.HJCore.onEnterGame();

        this.getGameManager().start();
        this.removeFromParent();
    },
    
    gameRestart:function () {
        //进入游戏开始统计在线时长
        wb.HJCore.onEnterGame();

        this.getParent().restart();
        this.removeFromParent();
    },

    initLayer:function () {
        var csb = ccs.load(res.PauseLayer_json).node;
        this.getContainer().addChild(csb);

        var bg=ccui.helper.seekWidgetByName(csb,"bg");
        var pic=bg.getChildByName("picture");
        ELSGameLogic.getInstance().addRectSend(bg,pic.getPosition());

        wb.FW(csb, "cha", function () {
            this.gameStart();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        wb.FW(csb, "btn_fxyx", function () {
            this.gameStart();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        wb.FW(csb, "btn_fhzy", function () {
            //暂停或者退出游戏时保存游戏时长
            wb.HJCore.onOutGame();

            wb.HjTaskManager.failGame(GameName[ELSGameLogic.getInstance().getGameType()-1],this.getGameManager().getScore());

            ELSGameLogic.getInstance().backToMain();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        wb.FW(csb,"btn_cxks",function () {
            this.gameRestart();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //帮助
        wb.FW(csb,"Button_help",function () {
            var layer=new HelpLayer();
            this.addChild(layer,100);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
        var help=ccui.helper.seekWidgetByName(csb,"Button_help");

        //音乐复选框
        Button_musicon=ccui.helper.seekWidgetByName(csb,"Button_musicon");
        Button_musicon.addClickEventListener(function () {
            Button_musicon.setVisible(false);
            Button_musicoff.setVisible(true);
            wb.setMusicEnable(false);
            cc.audioEngine.stopMusic(false);
        });
        Button_musicoff=ccui.helper.seekWidgetByName(csb,"Button_musicoff");
        Button_musicoff.addClickEventListener(function () {
            Button_musicon.setVisible(true);
            Button_musicoff.setVisible(false);
            wb.setMusicEnable(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
            if(ELSGameTool.getInstance().getGameType()==1){
                ELSGameTool.getInstance().playMusic(VIDEO[2],true);
            }else{
              //  ELSGameTool.getInstance().playMusic(VIDEO[11],true);
            }
        });
        if(wb.getMusicEnable()){
            Button_musicon.setVisible(true);
            Button_musicoff.setVisible(false);
        }else{
            Button_musicon.setVisible(false);
            Button_musicoff.setVisible(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }

        //音效复选框
        Button_videoon=ccui.helper.seekWidgetByName(csb,"Button_videoon");
        Button_videoon.addClickEventListener(function () {
            Button_videoon.setVisible(false);
            Button_videooff.setVisible(true);
            wb.setSoundEnable(false);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        });
        Button_videooff=ccui.helper.seekWidgetByName(csb,"Button_videooff");
        Button_videooff.addClickEventListener(function () {
            Button_videoon.setVisible(true);
            Button_videooff.setVisible(false);
            wb.setSoundEnable(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        });
        if(wb.getSoundEnable()){
            Button_videoon.setVisible(true);
            Button_videooff.setVisible(false);
        }else{
            Button_videoon.setVisible(false);
            Button_videooff.setVisible(true);
        }

    },

});