var ShopLayer =  BaseLayer.extend({
    chexBoxs:null,
    diamondNum:null,
    pageView:null,
    chexBox1:null,
    chexBox2:null,
    chexBox3:null,
    root:null,
    ctor:function () {
        this._super();

        this.initLayer();
        this.scheduleUpdate();

        ELSGameLogic.getInstance().addSingleSend(this,cc.p(580,WINSIZE.height*0.58));
    },

    initLayer:function () {

        var root = ccs.load(res.shop_ygb_json).node;
        this.getContainer().addChild(root);

        this.root=root;
        //钻石数量
        this.diamondNum= ccui.helper.seekWidgetByName(root,"diaNum");
        this.diamondNum.setString(ELSGameLogic.getInstance().getIcon());

        //去广告提示
        var noadtip=ccui.helper.seekWidgetByName(root,"noADtip");
        noadtip.setVisible(false);

        //关闭按钮
        wb.FW(root,"cha",function () {
            cc.log("商店关闭按钮被点击");
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //初始化礼包翻页容器
        this.initGiftsPageView();

        //获取购买按钮
        var listView = ccui.helper.seekWidgetByName(root,"ListView");
        var listArray = listView.getChildren();
        for(var i in listArray)
        {
            //购买按钮
            var btn_buy = listArray[i].getChildByName("buy");
            //钻石价格
            var money = btn_buy.getChildByName("qian").getChildByName("money4");
            money.setAnchorPoint(0.25,0.5);
            money.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
            money.setTextVerticalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            //钻石数量
             var diaNumText = listArray[i].getChildByName("zuanshi");
            diaNumText.setTextVerticalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            switch (i)
            {
                case "0" :  btn_buy.setTag(1);money.setString(ZSPRICE[3]/100+".00");diaNumText.setString(ZSNUM[3]+" 钻石");break;
                case "1" :  btn_buy.setTag(2);money.setString(ZSPRICE[2]/100+".00");diaNumText.setString(ZSNUM[2]+" 钻石");break;
                case "2" :  btn_buy.setTag(3);money.setString(ZSPRICE[1]/100+".00");diaNumText.setString(ZSNUM[1]+" 钻石");break;
                case "3" :  btn_buy.setTag(4);money.setString(ZSPRICE[0]/100+".00");diaNumText.setString(ZSNUM[0]+" 钻石");break;
            }
            btn_buy.addClickEventListener(this.onBtnBuyClick);
        }
    },

    //翻页容器添加子控件
    addPageViewItem:function (index,payID) {
        if(!ELSGameTool.getInstance().isGiftExist(payID)||ELSGameData.getInstance().isBuyGift(payID))
        {
            cc.log("this gift is already buyed or is not deploy!");
            return;
        }
        var layout = new ccui.Layout();
        layout.setContentSize(this.pageView.getContentSize());
        var size = layout.getContentSize();
        var image = new ccui.ImageView(giftpng[index]);
        image.setPosition(cc.p(size.width/2,size.height/2));
        image.setTouchEnabled(true);
        image.addClickEventListener(this.giftClickCallBack.bind(this));
        image.setTag(index);
        layout.addChild(image,1);
        this.pageView.addPage(layout);
        cc.log("标签："+image.getTag());
    },

    //滑动页面回调
    pageViewCallBack:function (sender) {
        var index = sender.getCurrentPageIndex();
        if(index==3)
        {
            index=2;
        }
        for(var i in this.chexBoxs){
            if(i==index)
            {
                this.chexBoxs[i].setSelected(true);
            }
            else {
                this.chexBoxs[i].setSelected(false);
            }
        }
        cc.log("当前页："+index);
    },

    //购买按钮点击回调
    onBtnBuyClick:function (sender) {
        var tag =sender.getTag();
        switch (tag)
        {
            case 1 : cc.log("购买按钮："+ tag );
                ELSGameTool.getInstance().clickUm("hj_tap_shop","type_29");
            ELSGameLogic.getInstance().orderPay(4);
            break;
            case 2 :  cc.log("购买按钮："+ tag );
                ELSGameTool.getInstance().clickUm("hj_tap_shop","type_18");
            ELSGameLogic.getInstance().orderPay(3);
            break;
            case 3 :  cc.log("购买按钮："+ tag );
                ELSGameTool.getInstance().clickUm("hj_tap_shop","type_12");
            ELSGameLogic.getInstance().orderPay(2);
            break;
            case 4 :  cc.log("购买按钮："+ tag  );
                ELSGameTool.getInstance().clickUm("hj_tap_shop","type_6");
            ELSGameLogic.getInstance().orderPay(1);
            break;
        }
        ELSGameTool.getInstance().playVideo(VIDEO[0]);
    },

    //礼包点击回调
    giftClickCallBack:function (sender) {
        cc.log("礼包被点击："+sender.getTag());
        if(sender.getTag()==0)
        {
            var layer = new GiftLayer_limited();
           // cc.director.getRunningScene().addChild(layer);
            this.addChild(layer,100);
        }
        else if(sender.getTag()==1)
        {
            var layer = new GiftLayer_newPlayer();
            this.addChild(layer,100);
        }
        else if(sender.getTag()==2)
        {
            var layer = new GiftLayer_noAD();
            this.addChild(layer,100);
        }
        ELSGameTool.getInstance().playVideo(VIDEO[0]);
    },

    //刷新钻石数量
    update:function () {
        //刷新钻石数量
        this.diamondNum.setString(ELSGameLogic.getInstance().getIcon());

        //刷新礼包容器
        if(GameUserInfo.getInstance().getIsShopGiftChenged())
        {
            GameUserInfo.getInstance().setIsShopGiftChenged(false);
            cc.log("礼包容器刷新.....");
            this.updateGifts(5);
            this.updateGifts(7);
        }
    },

    //礼包容器初始化
    initGiftsPageView:function () {

        //礼包翻页容器
        this.pageView = ccui.helper.seekWidgetByName(this.root,"PageView");
        this.pageView.setClippingEnabled(true);//设置内容裁剪
        this.pageView.setTouchEnabled(true);
        this.pageView.addEventListener(this.pageViewCallBack.bind(this));
        //添加礼包
        this.addPageViewItem(0,6);//限时
        this.addPageViewItem(1,7);//新手
        this.addPageViewItem(2,5);//去广告

        //滑动页面当前页选项
        this.chexBox1 = ccui.helper.seekWidgetByName(this.root,"CheckBox_1");
        this.chexBox1.setTouchEnabled(false);
        this.chexBox2 = ccui.helper.seekWidgetByName(this.root,"CheckBox_2");
        this.chexBox2.setBright(true);
        this.chexBox2.setSelected(false);
        this.chexBox2.setTouchEnabled(false);
        this.chexBox3 = ccui.helper.seekWidgetByName(this.root,"CheckBox_3");
        this.chexBox3.setTouchEnabled(false);
        this.chexBoxs = new Array(this.chexBox1,this.chexBox2,this.chexBox3);

        if(this.pageView.getChildrenCount()==1)
        {
            this.chexBox1.setVisible(false);
            this.chexBox2.setSelected(true);
            this.chexBox3.setVisible(false);
            this.chexBoxs.splice(0,1);
            this.chexBoxs.splice(1,1);
        }
       else if(this.pageView.getChildrenCount()==2)
        {
            this.chexBox1.setSelected(true);
            this.chexBox2.setVisible(false);
            this.chexBox3.setSelected(false);
            this.chexBoxs.splice(1,1);
        }
        else if(this.pageView.getChildrenCount()==0)//当容器没有内容时隐藏
        {
            for(var i in this.chexBoxs)
            {
                this.chexBoxs[i].setVisible(false);
            }
        }
    },
    //刷新礼包显示
    updateGifts:function (payID) {
            if(ELSGameData.getInstance().isBuyGift(payID))
            {
                var num = this.pageView.getChildrenCount();
                if(payID==5)//去广告礼包
                {
                    if(num==3)
                    {
                        var page = this.pageView.getPage(2);
                       this.pageView.removePage(page);
                    }
                    else if(num==2)
                    {
                        var page = this.pageView.getPage(1);
                        this.pageView.removePage(page);
                    }
                }
                else if(payID==7)//新手礼包
                {
                    var page = this.pageView.getPage(1);
                    this.pageView.removePage(page);
                }
                //刷新复选框显示
                this.updateChexBoxs();
            }

    },
    //刷新复选框显示
    updateChexBoxs:function () {
        var num = this.pageView.getChildrenCount();
        switch (num)
        {
            case 1: this.chexBox1.setVisible(false);this.chexBox2.setVisible(true);this.chexBox3.setVisible(false);
                    this.chexBox2.setSelected(true);
                    this.chexBoxs.splice(0,1);
                    this.chexBoxs.splice(1,1);
            break;
            case 2: this.chexBox1.setVisible(true);this.chexBox2.setVisible(false);this.chexBox3.setVisible(true);
                    this.chexBox1.setSelected(true);
                    this.chexBox3.setSelected(false);
                    this.chexBoxs.splice(1,1);
            break;
        }
    },
});