var ItemWidth=76;
TaskAdName="task_video";

var TaskLayer=BaseLayer.extend({
    _showmonth:0,
    _showday:0,
    _showyear:0,
    _daynum:0,
    _pageview:null,
    _lastpos:null,
    _tempindex:-1,
    _tasktip:[],
    ctor:function () {
        this._super();
        this.initLayer();
        this.showRecentTask();
        this.showLxDays();
        this.updateGetState();
        this.schedule(this.listUpdate);

        ELSGameLogic.getInstance().addSingleSend(this,cc.p(586,420));
    },

    initLayer:function () {
        root=ccs.load(res.dailyTask_json).node;
        this.getContainer().addChild(root);

        date=ELSGameTool.getInstance().getRecentDate();
        this._showyear=date.year;
        this._showmonth=date.month;
        this._showday=date.day;

        cc.log("date="+date.year+":"+date.month+":"+date.day);

        this._tasktip[0]=ccui.helper.seekWidgetByName(root,"Text_wcrw1");
        this._tasktip[1]=ccui.helper.seekWidgetByName(root,"Text_wcrw2");

        var calendar=ccui.helper.seekWidgetByName(root,"calendar");
        var clipdi=new cc.Sprite(res.taskclip_png);
        var clipnode=new cc.ClippingNode(clipdi);
        clipnode.setAlphaThreshold(0.00);
        calendar.addChild(clipnode);
        clipnode.setPosition(cc.p(255,45));
        this._pageview=new ccui.PageView();
        clipnode.addChild(this._pageview);
        this._pageview.setClippingEnabled(false);
        this._pageview.setContentSize(cc.size(86,90));
        this._pageview.setPosition(cc.p(-40,-45))
        this.flushDateView();
        this._pageview.addEventListener(function (sender,type) {
           this._showday=sender.getCurrentPageIndex()+1;
        }.bind(this));

        //前一个任务
        wb.FW(root,"btn_left",function () {
            if(this._showday>1){
                this._showday--;
                this._pageview.scrollToPage(this._showday-1);
            }
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //后一个任务
        wb.FW(root,"btn_right",function () {
            if(this._showday<this._daynum){
                this._showday++;
                this._pageview.scrollToPage(this._showday-1);
            }
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //上一个月
        wb.FW(root,"bt_mh_1",function () {
            if(this._showmonth>1){
                this._showmonth--
            }else{
                this._showmonth=12;
                this._showyear--;
            }
            if(this._showyear==date.year&&this._showmonth==date.month){
                this._showday=date.day;
            }else{
                this._showday=ELSGameTool.getInstance().getMonthDay(this._showyear,this._showmonth);
            }
            this.flushDateView();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //下一个月
        wb.FW(root,"bt_mh_2",function () {
            if(this._showmonth<12){
                this._showmonth++;
            }else{
                this._showmonth=1;
                this._showyear++;
            }
            if(this._showyear==date.year&&this._showmonth==date.month){
                this._showday=date.day;
            }else{
                this._showday=1;
            }
            this.flushDateView();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //去完成
        wb.FW(root,"btn_qwc",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_task","finish");
            ELSGameLogic.getInstance().backToMain();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //领取奖励
        wb.FW(root,"btn_lqjl",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_task","bonus");
            this.getRecentReward();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //换任务
        wb.FW(root,"btn_hrw",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_task","more");
            this.changeRecentTask();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //帮助
        wb.FW(root,"Button_help",function () {
            var layer=new TaskHelpLayer();
            this.addChild(layer,100);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //关闭按钮
        wb.FW(root,"cha",function () {
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
    },

    //刷新pageview
    flushDateView:function () {
        var month_left=ccui.helper.seekWidgetByName(root,"month_left");
        month_left.setString(((this._showmonth-1)>0?(this._showmonth-1):12).toString());
        var month_mid=ccui.helper.seekWidgetByName(root,"month_mid");
        month_mid.setString(this._showmonth.toString());
        var month_right=ccui.helper.seekWidgetByName(root,"month_right");
        month_right.setString(((this._showmonth+1)>12?1:(this._showmonth+1)).toString());

        this._pageview.removeAllPages();
        this._daynum=ELSGameTool.getInstance().getMonthDay(this._showyear,this._showmonth);
        for(var i=0;i<this._daynum;i++){
            var default_item=new ccui.Widget();
            default_item.setContentSize(cc.size(ItemWidth,90));
            var node=ccs.load(res.dailyTaskcell_json).node;
            default_item.addChild(node);
            node.setPosition(cc.p(ItemWidth/2,45));
            this.setBtState(node,i+1);
            this._pageview.addPage(default_item);
        }
        this.runAction(new cc.Sequence(new cc.DelayTime(0.1),new cc.CallFunc(function () {
            this._pageview.scrollToPage(this._showday-1);
        }.bind(this))));
    },

    //设置按钮状态
    setBtState:function(bt,i){
        var recent=bt.getChildByName("recent");
        recent.setVisible(false);
        var post=bt.getChildByName("post");
        post.setVisible(false);
        var next=bt.getChildByName("next");
        next.setVisible(false);
        var day1=date.year*1000+date.month*50+date.day;
        var day2=this._showyear*1000+this._showmonth*50+i;
        if(day2<day1){
            post.setVisible(true);
            post.getChildByName("num").setString(i.toString());
            cc.log("year:"+this._showyear+"month:"+this._showmonth+"day:"+i);
            if(!this.isTaskCompile(this._showyear,this._showmonth,i)){
                post.getChildByName("yes").setVisible(false);
                post.getChildByName("num").setPosition(cc.p(0,0));
            }
        }else if(day2==day1){
            recent.setVisible(true);
            recent.getChildByName("num").setString(i.toString());
            var state=wb.HjTaskManager.getBoundsEnable();
            if(state!=0){
                recent.getChildByName("yes").setVisible(false);
                recent.getChildByName("num").setPosition(cc.p(0,0));
            }
        }else if(day2>day1){
            next.setVisible(true);
            next.getChildByName("num").setString(i.toString());
        }
    },

    //当天任务是否已经完成
    isTaskCompile:function (year,month,day) {
        var redate=this.timeToStr(year,month,day);
        cc.log("TaskCompile redata:"+redate);
        var taskcompiple=wb.HjTaskManager.getCompletedDates();
        if(taskcompiple.indexOf(redate)!=-1)
            return true;
        return false;
    },

    //时间换成字符串
    timeToStr:function (year,month,day) {
        var res=year.toString();
        if(month<10){
            res+="0";
        }
        res+=month.toString();
        if(day<10){
            res+="0";
        }
        res+=day.toString();
        return year*10000+month*100+day;
    },

    //显示当前任务
    showRecentTask:function () {
        var task=wb.HjTaskManager.currentItem.data;
        if(task.target.length==1){
            this._tasktip[1].setVisible(false);
           // this._tasktip[0].setPositionY((this._tasktip[0].getPositionY()+this._tasktip[1].getPositionY())/2);
            var tx=task.targetMess[0]+"("+task.ptargetNum[0]+"/"+task.targetNum[0]+")";
            this._tasktip[0].setString(tx);
            cc.log("task content:"+tx);
        }else if(task.target.length>=2){
            for(var i=0;i<2;i++){
                var tx=task.targetMess[i]+"("+task.ptargetNum[i]+"/"+task.targetNum[i]+")";
                this._tasktip[i].setString(tx);
                this._tasktip[i].setVisible(true);
                cc.log("task content:"+tx);
            }
        }
    },

    //连续任务进度
    showLxDays:function () {
        var lxdaysnum=wb.HjTaskManager.lx_days;
        var lxbar=ccui.helper.seekWidgetByName(root,"LoadingBar_1");
        lxbar.setPercent(lxdaysnum*100/wb.HjTaskManager.lx_max_days);

        var process=0;
        var bonuslist=[7,14,30];
        for(var i=0;i<3;i++){
            var bt=ccui.helper.seekWidgetByName(root,"Button_"+(i+1))
            cc.log("getLxTaskBoundsEnable:"+wb.HjTaskManager.getLxTaskBoundsEnable(100+i))
            if(lxdaysnum<bonuslist[i]||wb.HjTaskManager.getLxTaskBoundsEnable(100+i)){
                bt.addClickEventListener(function (target) {
                    var key=target.getTag();
                    this.getLxReward(key);
                }.bind(this));
                bt.setTag(i);
                bt.getChildByName("wwcNum").setVisible(true);
                bt.getChildByName("ywcNum").setVisible(false);

                if(wb.HjTaskManager.getLxTaskBoundsEnable(100+i)){
                    bt.runAction(new cc.RepeatForever(new cc.Sequence(new cc.ScaleTo(2.0,1.0),new cc.ScaleTo(2.0,1.1))));
                }else{
                    bt.stopAllActions();
                    bt.setScale(1.0);
                }
            }else{
                process++;
                bt.setTouchEnabled(false);
                bt.setBright(false);
                bt.getChildByName("wwcNum").setVisible(false);
                bt.getChildByName("ywcNum").setVisible(true);
            }
        }

        //连续任务提示
        var tip=ccui.helper.seekWidgetByName(root,"Text_1");
        if(process==3){
            tip.setVisible(false);
        }else{
            tip.setString("连续完成"+bonuslist[process]+"天任务可以获得免费奖励哦!");
        }
    },

    //领取连续奖励
    getLxReward:function (key) {
        var bt=ccui.helper.seekWidgetByName(root,"Button_"+(key+1));
        var zbonus=wb.HjTaskManager.getLxTaskItem(100+key);
        var rewardid=[];
        var rewardnum=[];
        if(zbonus){
            rewardid=zbonus.data.bonus;
            rewardnum=zbonus.data.bonusNum;
        }
        if(wb.HjTaskManager.getLxTaskBoundsEnable(100+key)){
            wb.HjTaskManager.getLxTaskBounds(100+key);
            for(var i in rewardid){
                if(rewardid[i]==1){
                    ELSGameLogic.getInstance().useIcon(rewardnum[i]);
                    ELSGameTool.getInstance().diamondMotion(rewardnum[i]);
                }else if(rewardid[i]>1){
                    ELSGameData.getInstance().changePropNum(rewardid[i]-1,rewardnum[i]);
                }
            }
            this.showLxDays();
        }else{

        }
    },

    //领取当天奖励
    getRecentReward:function () {
        wb.HjTaskManager.getBounds();
        this.updateGetState();

        var task=wb.HjTaskManager.currentItem.data;
        var bonus=task.bonus;
        var bonusnum=task.bonusNum;
        if(bonus.length==1&&bonus[0]==1){
            ELSGameTool.getInstance().diamondMotion(bonusnum[0])
            ELSGameLogic.getInstance().useIcon(bonusnum[0]);
        }
    },

    //换任务
    changeRecentTask:function () {
        ELSGameLogic.getInstance().openAdC(TaskAdName,function () {
                cc.log("change task success!");
                wb.HjTaskManager.changeTask();
                this.showRecentTask();
        }.bind(this));
    },

    //刷新领取奖励状态
    updateGetState:function () {
        var state=wb.HjTaskManager.getBoundsEnable();
        var qwc=ccui.helper.seekWidgetByName(root,"btn_qwc")
        var lqjl=ccui.helper.seekWidgetByName(root,"btn_lqjl");
        cc.log("boundenable="+state);
        switch (state){
            case 0:
                qwc.setVisible(false);
                lqjl.setVisible(true);
                lqjl.setTouchEnabled(false);
                lqjl.setBright(false);
                break;
            case 1:
                qwc.setVisible(false);
                lqjl.setVisible(true);
                lqjl.setTouchEnabled(true);
                lqjl.setBright(true);
                break;
            case -1:
                qwc.setVisible(true);
                lqjl.setVisible(false);
                break;
        }
    },

    listUpdate:function (ft) {
        var index=this._pageview.getCurrentPageIndex();
        if(this._tempindex!=index){
            var pages=this._pageview.getItems();
            for(var i in pages){
                var key=1.1-Math.abs(index-i)*0.07;
                var opakey=1.0-Math.abs(index-i)*0.25;
                pages[i].setCascadeOpacityEnabled(true);
                pages[i].setOpacity(255*opakey);
                pages[i].setScale(key);
            }
            this._tempindex=index;
        }

        //换任务按钮刷新
        var isAdReady=wb.ADManager.isAdReady(TaskAdName,"video");
        if(isAdReady&&!wb.HjTaskManager.completed){
            ccui.helper.seekWidgetByName(root,"btn_hrw").setVisible(true);
        }else{
            ccui.helper.seekWidgetByName(root,"btn_hrw").setVisible(false);
        }
    },
});