//用户信息设置界面
var UserSetting = BaseLayer.extend({
    //头像
    userTX:null,
    //性别男
    uerSex_1:null,
    //性别女
    uerSex_2:null,
    //手机号码
    userPhone:null,
    //用户昵称
    userName:null,
    //用户等级
    userLevel:null,
    //手机号缓存
    _phonestr:"",

    ctor:function () {
        this._super();
        this.initLayer();
        this.scheduleUpdate();//开启计时器（每帧执行）

        ELSGameLogic.getInstance().addSingleSend(this,cc.p(586,420));
    },

    initLayer:function () {
        var root = ccs.load(res.userSettingLayer_json).node;
        this.getContainer().addChild(root);

        this.userTX=ccui.helper.seekWidgetByName(root,"tx");
        this.userTX.loadTexture(GameUserInfo.getInstance().getUserTx());

        var service=ccui.helper.seekWidgetByName(root,"service");
        service.setVisible(false);

        //使用微信头像
        if(wb.WBUser.userInfo.data.wxhead.length>0)
        {
            cc.loader.loadImg(this.giftCfg.picture_url,
                {isCrossOrigin : false }, function(err, img){
                    if(img)
                    {
                        var texture2d = new cc.Texture2D();
                        texture2d.initWithElement(img);
                        texture2d.handleLoadedTexture();
                        this.userTX.loadTexture(texture2d);
                    }
                }.bind(this));
        }

        //性别
        this.userSex_1=ccui.helper.seekWidgetByName(root,"CheckBox_1");
        this.userSex_2=ccui.helper.seekWidgetByName(root,"CheckBox_2");
        if(GameUserInfo.getInstance().getUserSex()=="0")
        {
            this.userSex_1.setSelected(true);
            this.userSex_2.setSelected(false);
        }
        else {
            this.userSex_1.setSelected(false);
            this.userSex_2.setSelected(true);
        }
        this.userSex_1.addEventListener(this.selectedStateEvent, this);
        this.userSex_2.addEventListener(this.selectedStateEvent, this);


        var phone=ccui.helper.seekWidgetByName(root,"phone");
        phone.setVisible(false);

        //手机号码
        this.userPhone=ccui.helper.seekWidgetByName(root,"num");
        this.userPhone.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
        this.userPhone.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        this.userPhone.anchorX=0.6;
        this.userPhone.setString(GameUserInfo.getInstance().getUserPhone());
        this.userPhone.addEventListener(function (target,type) {
            ELSGameTool.getInstance().clickUm("hj_tap_user","phone");
            if(type==ccui.TextField.EVENT_INSERT_TEXT||type==ccui.TextField.EVENT_DELETE_BACKWARD){
                var text = target.getString();
                this._phonestr="";
                for(var i in text){
                    if(parseInt(text[0])!=0&&parseInt(text[i])&&parseInt(text[i])>=0&&parseInt(text[i])<=9){
                        this._phonestr+=text[i];
                    }else{
                        break;
                    }
                }
                cc.log("手机号长度："+this._phonestr.length)
                if(this._phonestr.length==11){
                    target.setString(this._phonestr);
                    GameUserInfo.getInstance().setUserPhone(target.getString());
                    ELSGameTool.getInstance().clickUm("hj_user","phone");
                }
            }
        }.bind(this));

        //用户昵称（不可修改）
        this.userName=ccui.helper.seekWidgetByName(root,"name");
        this.userName.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
        this.userName.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        this.userName.setMaxLength(7);
        this.userName.setString(GameUserInfo.getInstance().getUserName());
        this.userName.setTouchEnabled(false);
        // this.userName.addEventListener(function (target,type) {
        //     if(type==ccui.TextField.EVENT_INSERT_TEXT||type==ccui.TextField.EVENT_DELETE_BACKWARD){
        //         GameUserInfo.getInstance().setUserName(target.getString());
        //     }
        // });

        //用户ID
        this.userid=ccui.helper.seekWidgetByName(root,"userid");
        this.userid.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
        this.userid.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        this.userid.setString("用户ID:"+GameUserInfo.getInstance().getUserID());

        //用户等级
        this.userLevel=ccui.helper.seekWidgetByName(root, "level");
        this.userLevel.setString(GameUserInfo.getInstance().getUserLevel().toString());

        //滑动条
        var lvBar = ccui.helper.seekWidgetByName(root,"lvBar");
        lvBar.setVisible(false);

        //关闭按钮
        wb.FW(root,"cha",function () {
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //头像按钮
        var bt_tx=wb.FW(root,"btn_tx",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_user","avatar");
            var layer = new TXSettingLayer();
            this.addChild(layer,100);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
        bt_tx.setPressedActionEnabled(false);

        //绑定微信按钮
        var btn_wx = wb.FW(root,"btn_wx",function () {
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
        btn_wx.setVisible(false);

    },

    //计时器函数（每帧执行）
    update:function () {

        //刷新用户信息
        this.userTX.loadTexture(GameUserInfo.getInstance().getUserTx());
        //this.userName.setString(GameUserInfo.getInstance().getUserName());
        this.userLevel.setString(GameUserInfo.getInstance().getUserLevel());
    },

    //性别复选框点击事件
    selectedStateEvent: function (sender, type) {
        ELSGameTool.getInstance().clickUm("hj_tap_user","sex");
           switch (type) {
                case ccui.CheckBox.EVENT_SELECTED:

                    if(sender==this.userSex_1)
                    {
                        this.userSex_2.setSelected(false);
                        GameUserInfo.getInstance().setUserSex("0");
                    }
                    else {
                        this.userSex_1.setSelected(false);
                        GameUserInfo.getInstance().setUserSex("1");
                    }
                    break;
                case ccui.CheckBox.EVENT_UNSELECTED:

                    if(sender==this.userSex_1)
                    {
                        this.userSex_2.setSelected(true);
                        GameUserInfo.getInstance().setUserSex("0");
                    }
                    else {
                        this.userSex_1.setSelected(true);
                        GameUserInfo.getInstance().setUserSex("1");
                    }
                     break;

                default:
                   break;
             }
         },

});


//用户头像选择界面
var TXSettingLayer = BaseLayer.extend({
    curSelectedTXID:null,
    containerTX:null,
    ctor:function () {
        this._super();
        this.initLayer();
    },

    initLayer:function () {
        var root =ccs.load(res.userTXLayer_json).node;
        this.getContainer().addChild(root);

        var panel= ccui.helper.seekWidgetByName(root,"panel");
        this.containerTX = panel.getChildren();
        this.curSelectedTXID=GameUserInfo.getInstance().getUserTxIndex();
        var index = GameUserInfo.getInstance().getUserTxIndex();
        for(var i in this.containerTX){
            this.containerTX[i].addEventListener(this.selectCheckBoxEvent,this);
            if(i==index)
            {
                this.containerTX[i].setSelected(true);
            }
            else {
                this.containerTX[i].setSelected(false);
            }
        }
        //确认按钮
        wb.FW(root,"btn_sure",function () {
            if(this.curSelectedTXID!=-1)
            {
                GameUserInfo.getInstance().setUserTx(this.curSelectedTXID);
                GameUserInfo.getInstance().setUserTxIndex(this.curSelectedTXID);
                ELSGameTool.getInstance().clickUm("hj_user","avatar");
            }
            this.removeFromParent(true);
        }.bind(this));

    },

    //复选框单选事件处理
    selectCheckBoxEvent:function (sender,type) {
        switch(type){
            case ccui.CheckBox.EVENT_SELECTED:
                for(var i in this.containerTX)
                {
                    if(this.containerTX[i]==sender)
                    {
                        this.curSelectedTXID=i;
                    }
                    else{
                        this.containerTX[i].setSelected(false);
                    }
                }
                break;
            case ccui.CheckBox.EVENT_UNSELECTED:
                this.curSelectedTXID=-1;
                break;
            default:
                break;
        }
    }
});