var GameType={
    Type_Star:1,
    Type_1010:2,
    Type_LIUJIAO:3,
};
var GameState={
    STATE_RUN:1,
    STATE_FAILD:2,
    STATE_STOP:3,
    STATE_PAUSE:4
};
var TouchState={
    TOUCH_TRUE:1,
    TOUCH_FAILD:2,
};

var ELSGameLogic=cc.Class.extend({
    game_type:null,
    ctor:function(){
    },

    //设置游戏模式
    setGameType:function(type) {
        this.game_type = type;
    },
    getGameType:function(){
        return this.game_type;
    },

    //触摸层
    addkeyListener:function(lay,call){
        var listener=cc.EventListener.create({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            target:lay,
            swallowTouches:true,
            onTouchBegan:function(){
                cc.log("touch true");
                call;
                return true;
            },
            onTouchMoved:function(){},
            onTouchEnded:function(){}
        });
        cc.eventManager.addListener(listener,lay);
    },

    //手机返回键 type:1.主界面  2.游戏界面  3.其他界面
    addReturnPage:function (type) {
        var scene=cc.director.getRunningScene();
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function (key, event) {
                if (key == cc.KEY.back||key==cc.KEY.escape) {
                    if(!type){
                        type=3;
                    }
                    var scenelayer=scene.getChildByName("layer");
                    var exitlayer=scenelayer.getChildByTag(BaselayerTag);
                    //存在子界面时关掉子界面
                    var firstpage=true;
                    if(exitlayer){
                        var temp=true;
                        do{
                            if(exitlayer.getName()=="faildlayer")
                                break;
                            var sublayer=exitlayer.getChildByTag(BaselayerTag);
                            if(sublayer){
                                exitlayer=sublayer;
                                firstpage=false;
                            }else{
                                if(type==2&&firstpage){
                                    exitlayer.getParent().getManager().start();
                                }
                                exitlayer.removeFromParent();
                                temp=false;
                            }
                        }while (temp);
                        return;
                    }

                    //不存在子界面打开界面
                    if(type==1){
                        if(wb.PayManager.isExitGame()){
                            wb.PayManager.setOnGameExit(function(){
                                wb.CoreManager.onExit();
                                cc.director.end();
                            });
                            wb.PayManager.openExitGame();
                        }else{
                            var layer=new ExitLayer();
                            scenelayer.addChild(layer,100);
                        }
                    }else if(type==2){
                        if(!scenelayer.getManager()._guide){
                            var layer=new PauseLayer();
                            scenelayer.addChild(layer,100);
                        }
                    }
                }
            }
        }, scene);
    },

    //返回主页
    backToMain:function(){
        wb.ADManager.closeAd("banner");
        if(this.game_type){
            wb.HjTaskManager.endGame()
        }
        cc.director.runScene(new MainScene2());
    },

    //领取在线时长奖励
    getOnLineReward:function () {
        if(wb.HjOnlineManager.getBoundsEnable()==1){
            var rewardid=wb.HjOnlineManager.getBoundsIds();
            var rewardnum=wb.HjOnlineManager.getBoundsNums();
            for(var i in rewardid){
                if(rewardid[i]==1){
                    ELSGameLogic.getInstance().useIcon(rewardnum[i]);
                    ELSGameTool.getInstance().diamondMotion(rewardnum[i]);
                }else if(rewardid[i]>1){
                    ELSGameData.getInstance().changePropNum(rewardid[i]-1,rewardnum[i]);
                }
            }
            wb.HjOnlineManager.getBounds();
        }

    },

    //获取钻石数量
    getIcon:function () {
        return ELSGameTool.getInstance().getIntegerForKey("coins",0);
        //return GameUserInfo.getInstance().getUserDiamond();
    },

    //使用钻石
    useIcon:function (num) {
        var key=this.getIcon();
        key+=num;
        ELSGameTool.getInstance().setIntegerForKey("coins",key);
        //GameUserInfo.getInstance().addUserDiamond(num);
    },

    //获取三个排行榜的数据
    getRankData:function () {
        for(var i=0;i<3;i++){
            RankData.getInstance().getServerData();
        }
    },

    //支付
    orderPay:function (id) {
     //   this.orderPaySuccess(id);
        wb.PayManager.orderPay(id);
        wb.WBUser.recharge(id);//保存支付信息
    },

    //支付成功
    orderPaySuccess:function (payid) {
        var diamondnum=ZSNUM[payid-1];
        ELSGameLogic.getInstance().useIcon(diamondnum);
        ELSGameTool.getInstance().diamondMotion(diamondnum);
        if(payid==5){
            //去广告礼包（去掉广告）
            ELSGameData.getInstance().buyGift(5,true);
            GameUserInfo.getInstance().setIsShopGiftChenged(true);
            wb.setADEnabled(false);
        }
        else if(payid==6){
            //限时礼包
            ELSGameData.getInstance().buyGift(6,true);
        }
        else if(payid==7){
            //新手礼包
            ELSGameData.getInstance().buyGift(7,true);
            GameUserInfo.getInstance().setIsShopGiftChenged(true);
        }
    },

    //添加红包
    addLimitHb:function (lay,pos) {
        var hb=new HongBao();
        lay.addChild(hb,1,112233);
        hb.setPosition(pos);
    },

    //是否是全面屏
    isFullScreen:function () {
        if(WINSIZE.width/WINSIZE.height<0.53){
            return true;
        }
        return false;
    },

    //加条形互推
    addIconSend:function (lay) {
       // if (cc.sys.isMobile||cc.sys.platform==cc.sys.WIN32){
            var layer = new MenuItemADLayer();
            lay.addChild(layer,1000);
            layer.setPosition(cc.p(0,-48));
      //  }
    },

    //加单个互推
    addSingleSend:function (lay,pos) {
        var htManager=wb.HtManager.getInstance();
        var iconList=htManager.getIconList();
        if(iconList&&iconList.length>0){
            var menuIconItem = new wb.HtMenuItem(iconList[0]);
            menuIconItem.setListener(function(event){
                cc.log("IconMenu::event="+event);
                if(event===wb.HtMenuItem.Event.OnClicked){
                    menuIconItem.loadHtItem(iconList[Math.floor(Math.random() * iconList.length)]);
                }
                else if(event===wb.HtMenuItem.Event.OnPresent){//展现
                }
            });
            menuIconItem.setItemSize(cc.size(100,100));
            menuIconItem.setPosition(pos);

            var menu = new cc.Menu(menuIconItem);
            lay.addChild(menu);
            menu.setAnchorPoint(cc.p(0,0));
            menu.setPosition(cc.p(0,0));
        }
    },

    //加矩形互推
    addRectSend:function (lay,pos) {
        var htManager=wb.HtManager.getInstance();
        var iconList=htManager.getPlaqueList();
        if(iconList&&iconList.length>0){
            var menuPlaqueItem = new wb.HtMenuItem(iconList[0]);
            menuPlaqueItem.setListener(function(event){
                cc.log("PlaqueMenu::event="+event);
                if(event===wb.HtMenuItem.Event.OnClicked){
                    menuPlaqueItem.loadHtItem(iconList[Math.floor(Math.random() * iconList.length)]);
                }
                else if(event===wb.HtMenuItem.Event.OnPresent){//展现
                }
            });
            menuPlaqueItem.setItemSize(cc.size(502,307));
            menuPlaqueItem.setPosition(pos);

            var menu = new cc.Menu(menuPlaqueItem);
            lay.addChild(menu);
            menu.setAnchorPoint(cc.p(0,0));
            menu.setPosition(cc.p(0,0));
        }
    },

    //openad
    openAd:function (name) {
        wb.ADManager.openAd(name);
    },

    openAdC:function (name,func) {
        ELSGameTool.getInstance().pauseMusic();
        wb.ADManager.openAdC(name,function(adSourceItem,result){
            ELSGameTool.getInstance().resumeMusic();
            if(result==0){
                func();
            }
        });
    },

    //是否可以播放胜利广告
    canOpenWinAd:function (level) {
        var starlevel=parseInt(wb.ADManager.getAdPositionParam("level_win","startLevel"));
        var interval=parseInt(wb.ADManager.getAdPositionParam("level_win","intervalLevel"));
        if(starlevel>0){
            if((level>=starlevel)&&((level-starlevel)%interval==0)){
                return true;
            }else{
                return false;
            }
        }else{
            return true;
        }
    },

    //获取上一个版本的钻石个数
    getLastVersionDiamond:function () {
        var lastnum=ELSGameTool.getInstance().getIntegerForKey("ELS_LAST_DIAMOND",-1);
        cc.log("ELS_LAST_DIAMOND:"+lastnum);
        if(lastnum==-1){
            var num=wb.getCoin();

            cc.log("ELS_LAST_NUM:"+num);
            if(num>0)
                ELSGameLogic.getInstance().useIcon(num);
            ELSGameTool.getInstance().setIntegerForKey("ELS_LAST_DIAMOND",num);
        }
    },

});

ELSGameLogic._instance=null;

ELSGameLogic.getInstance=function(){
    if(ELSGameLogic._instance==null){
        ELSGameLogic._instance=new ELSGameLogic();

        //输出计费文件信息
        cc.log("----getDefaultFeeInfo1----");
        var type=wb.PayManager.getDefaultPayType();
        if(type){
            cc.log("----getDefaultFeeInfo2----type="+type);
            var info=wb.PayManager.getDefaultFeeInfo();
            cc.log("----getDefaultFeeInfo3----");
            if(info){
                cc.log("info="+info);
                var dd=wb.PayManager.getDefaultFeeInfo().getFeeItems();
                for(var i in dd)
                    cc.log("id="+dd[i].getID()+"-price="+dd[i].getPrice()+"-code="+dd[i].getCode()+"-desc="+dd[i].getDesc());
            }
        }
    }
    return ELSGameLogic._instance;
}

