/* 游戏当局临时数据 */

TempData=cc.Class.extend({
    _score: 0,   //分数
    _level: 0,   //关数
    _lastscore:0,  //上关分数
    _target: 0,  //目标
    _hang: 0,    //行数
    _stepnumber: 0,  //步数
    _chesspad:"",   //棋盘
    _chessid:"",    //可供选择的id
    _issaved:0, //是否已保存数据

    init:function () {
        this._score=0;
        this._level=0;
        this._lastscore=0;
        this._target=0;
        this._hang=0;
        this._stepnumber=0;
        this._chesspad="";
        this._chessid="";
        this._issaved=0;
    },

    dataSave:function (name) {
        // cc.sys.localStorage.setItem(name+"score",this._score.toString());
        // cc.sys.localStorage.setItem(name+"lastscore",this._lastscore.toString());
        // cc.sys.localStorage.setItem(name+"level",this._level.toString());
        // cc.sys.localStorage.setItem(name+"target",this._target.toString());
        // cc.sys.localStorage.setItem(name+"hang",this._hang.toString());
        // cc.sys.localStorage.setItem(name+"stepnumber",this._stepnumber.toString());
        // cc.sys.localStorage.setItem(name+"chesspad",this._chesspad.toString());
        // cc.sys.localStorage.setItem(name+"chessid",this._chessid.toString());
        // cc.sys.localStorage.setItem(name+"issaved",this._issaved.toString());

        ELSGameTool.getInstance().setIntegerForKey(name+"score",this._score);
        ELSGameTool.getInstance().setIntegerForKey(name+"lastscore",this._lastscore);
        ELSGameTool.getInstance().setIntegerForKey(name+"level",this._level);
        ELSGameTool.getInstance().setIntegerForKey(name+"target",this._target);
        ELSGameTool.getInstance().setIntegerForKey(name+"hang",this._hang);
        ELSGameTool.getInstance().setIntegerForKey(name+"stepnumber",this._stepnumber);
        ELSGameTool.getInstance().setStringForKey(name+"chesspad",this._chesspad);
        ELSGameTool.getInstance().setStringForKey(name+"chessid",this._chessid);
        ELSGameTool.getInstance().setIntegerForKey(name+"issaved",this._issaved);
    },

    dataWrite:function (name) {
        this._score=parseInt(ELSGameTool.getInstance().getIntegerForKey(name+"score",0));
        this._lastscore=parseInt(ELSGameTool.getInstance().getIntegerForKey(name+"lastscore",0));
        this._level=parseInt(ELSGameTool.getInstance().getIntegerForKey(name+"level",0));
        this._target=parseInt(ELSGameTool.getInstance().getIntegerForKey(name+"target",0));
        this._hang=parseInt(ELSGameTool.getInstance().getIntegerForKey(name+"hang",0));
        this._stepnumber=parseInt(ELSGameTool.getInstance().getIntegerForKey(name+"stepnumber",0));
        this._issaved=parseInt(ELSGameTool.getInstance().getIntegerForKey(name+"issaved",0));
        this._chessid=ELSGameTool.getInstance().getStringForKey(name+"chessid","");
        this._chesspad=ELSGameTool.getInstance().getStringForKey(name+"chesspad","");
    },

    dataClear:function (name) {
        this._score=0;
        this._lastscore=0;
        this._level=0;
        this._target=0;
        this._hang=0;
        this._stepnumber=0;
        this._chesspad="";
        this._chessid="";
        this._issaved=0;
        this.dataSave(name);
    },
})

//糖果模式
MatchTempData=TempData.extend({

    save:function (manager) {
        this.init();
        this._score=manager.getScore();
        this._level=manager.getLevel();
        this._lastscore=manager._lastLevelScore;
        this._target=manager.getTarget();
        var chessinfo=manager._chessInfo;
        var map="";
        for(var i in chessinfo){
            map+=chessinfo[i].toString();
        }
        this._chesspad=map;
        this._issaved=1;
        this.dataSave(GameName[0]);
    },

    clear:function () {
        this.dataClear(GameName[0]);
    },

    getSaveData:function () {
        this.dataWrite(GameName[0]);
        return this;
    },
});

MatchTempData._install=null;

MatchTempData.getInstance=function () {
    if(!MatchTempData._install)
        MatchTempData._install=new MatchTempData();
    return MatchTempData._install;
};

//经典模式
TetrisTempData=TempData.extend({
    save:function (manager) {
        this.init();
        this._score=manager.getScore();
        this._level=manager.getLevel();
        this._hang=manager.getHang();
        this._target=manager.getTarget();
        var chessinfo=manager._chessfillinfo;
        var map="";
        for(var i in chessinfo){
            map+=chessinfo[i].toString();
        }
        var recentBox=manager._recentBox;
        var nextBox=manager._nextBox;
        var chessid="";
        chessid+=recentBox.toString();
        chessid+="#";
        for(var i in nextBox){
            chessid+=nextBox[i].toString();
            chessid+="#";
        }
        this._chessid=chessid;
        this._chesspad=map;
        this._issaved=1;
        this.dataSave(GameName[1]);
    },

    clear:function () {
        this.dataClear(GameName[1]);
    },

    getSaveData:function () {
        this.dataWrite(GameName[1]);
        return this;
    },
});

TetrisTempData._install=null;

TetrisTempData.getInstance=function () {
    if(!TetrisTempData._install)
        TetrisTempData._install=new TetrisTempData();
    return TetrisTempData._install;
};

//拖动模式
OneZeroTempData=TempData.extend({
    save:function (manager) {
        this.init();
        this._score=manager.getScore();
        var chessinfo=manager._chessInfo;
        var map="";
        for(var i in chessinfo){
            map+=chessinfo[i].toString();
        }
        var typeid=manager._typeid;
        var exitid=manager._selectExit;
        var chessid="";
        for(var i in exitid){
            if(exitid[i]){
               chessid+=(typeid[i]+1).toString();
               chessid+="#";
            }else{
                chessid+="0";
                chessid+="#";
            }
        }
        this._chessid=chessid;
        this._chesspad=map;
        this._issaved=1;
        this.dataSave(GameName[2]);
    },

    clear:function () {
        this.dataClear(GameName[2]);
    },

    getSaveData:function () {
        this.dataWrite(GameName[2]);
        return this;
    },
});

OneZeroTempData._install=null;

OneZeroTempData.getInstance=function () {
    if(!OneZeroTempData._install)
        OneZeroTempData._install=new OneZeroTempData();
    return OneZeroTempData._install;
};

//方块模式
FKuaiTempData=TempData.extend({
    save:function (manager) {
        this.init();
        this._score=manager.getScore();
        this._level=manager.getLevel();
        this._target=manager.getTarget();
        var chessinfo=manager._chessfillinfo;
        var map="";
        for(var i in chessinfo){
            map+=chessinfo[i].toString();
        }
        var recentBox=manager._recentBox;
        var nextBox=manager._nextBox;
        var chessid="";
        chessid+=recentBox.toString();
        chessid+="#";
        for(var i in nextBox){
            chessid+=nextBox[i].toString();
            chessid+="#";
        }
        this._chessid=chessid;
        this._chesspad=map;
        this._issaved=1;
        this.dataSave(GameName[3]);
    },

    clear:function () {
        this.dataClear(GameName[3]);
    },

    getSaveData:function () {
        this.dataWrite(GameName[3]);
        return this;
    },
});

FKuaiTempData._install=null;

FKuaiTempData.getInstance=function () {
    if(!FKuaiTempData._install)
        FKuaiTempData._install=new FKuaiTempData();
    return FKuaiTempData._install;
};

//六角模式
LJTempData=TempData.extend({
    save:function (manager) {
        this.init();
        this._score=manager.getScore();
        var chessinfo=manager._chessInfo;
        var map="";
        for(var i in chessinfo){
            map+=chessinfo[i].toString();
        }
        var typeid=manager._typeid;
        var exitid=manager._selectExit;
        var chessid="";
        for(var i in exitid){
            if(exitid[i]){
                chessid+=(typeid[i]+1).toString();
                chessid+="#";
            }else{
                chessid+="0";
                chessid+="#";
            }
        }
        this._chessid=chessid;
        this._chesspad=map;
        this._issaved=1;
        this.dataSave(GameName[4]);
    },

    clear:function () {
        this.dataClear(GameName[4]);
    },

    getSaveData:function () {
        this.dataWrite(GameName[4]);
        return this;
    },
});

LJTempData._install=null;

LJTempData.getInstance=function () {
    if(!LJTempData._install)
        LJTempData._install=new LJTempData();
    return LJTempData._install;
};

