var ELSGameTool=cc.Class.extend({
    getLabelAtlas:function (text,fntname) {
        var width=0;
        var height=0;
        if(fntname==res.fnt_png1) {
            width=30;
            height=48;
        }
        var font=new cc.LabelAtlas(text,fntname,width,height,"0");
        font.setAnchorPoint(cc.p(0.5,0.5));
        return font;
    },

    //钻石动画
    diamondMotion:function (num,pos) {
        var layer=new CommonRewardLayer(num,pos);
        cc.director.getRunningScene().addChild(layer,100);
    },

    //恭喜动画
    spriteShow:function (res,pos) {
        if(res==gxpng[1]){
            ELSGameTool.getInstance().playVideo(VIDEO[4]);
        }else if(res==gxpng[2]){
            ELSGameTool.getInstance().playVideo(VIDEO[5]);
        }
        var sp=new cc.Sprite(res);
        cc.director.getRunningScene().addChild(sp,12);
        sp.setPosition(pos);
        sp.setScale(1.0);
        if(res==gxpng[3]){
            sp.runAction(new cc.Sequence(new cc.MoveBy(0.5,cc.p(0,50)),
               new cc.DelayTime(0.2),new cc.FadeOut(0.3),new cc.CallFunc(function () {
                    sp.removeFromParent();
                })));
        }else{
            sp.runAction(new cc.Sequence(new cc.FadeOut(0.08),new cc.FadeIn(0.08),new cc.FadeOut(0.08),new cc.FadeIn(0.08),new cc.FadeOut(0.08),new cc.FadeIn(0.08),
                new cc.ScaleTo(0.2,0.8),new cc.DelayTime(0.2),new cc.FadeOut(0.3),new cc.CallFunc(function () {
                    sp.removeFromParent();
                })));
        }
    },

    //手指动画
    createHand:function () {
        var node=new cc.Node();

        var shouzhi = new sp.SkeletonAnimation(wb.appendSceneStr("res/spine/shouzhi.json"),wb.appendSceneStr("res/spine/shouzhi.atlas"), 1.0);
        shouzhi.setAnimation(0, "loop", true);
        node.addChild(shouzhi);

        return node;
    },

    //游戏提示
    gameTip:function (str) {
        var di=new cc.Scale9Sprite(res.tipdi_png);
        di.setContentSize(cc.size(434,100));
        cc.director.getRunningScene().addChild(di,1000);
        di.setPosition(cc.p(320,500));
        di.runAction(new cc.Sequence(new cc.MoveBy(0.5,cc.p(0,100)),new cc.DelayTime(1.0),new cc.RemoveSelf()));
        di.runAction(new cc.Sequence(new cc.DelayTime(1.0),new cc.FadeOut(0.5)));

        var fnt2=new cc.LabelTTF(str,"Arial",40);
        fnt2.setColor(cc.color(255,255,0,255));
        di.addChild(fnt2);
        var wid=fnt2.getContentSize().width+80;
        wid=wid>300?wid:300;
        di.setContentSize(cc.size(wid,90));
        fnt2.setPosition(cc.p(di.getContentSize().width/2,di.getContentSize().height/2));
        fnt2.runAction(new cc.Sequence(new cc.DelayTime(1.0),new cc.FadeOut(0.5)));
    },

    //引导小人
    guidePerson:function (str,size,ignore) {
        var ret=new cc.Node();

        var csb=ccs.load(res.guide_json).node;
        ret.addChild(csb);
        csb.setPosition(cc.p(-320,-500));

        var kuang=csb.getChildByName("Image_1");

        var zi=csb.getChildByName("zi");
        zi.setVisible(false);

        var k=0;
        var allk=str.length;
        for(var i in str){
            var zi=new cc.LabelTTF(str[i],"Atlas",size);
            kuang.addChild(zi);
            zi.setPosition(cc.p(kuang.getContentSize().width/2,kuang.getContentSize().height/2+((allk-1)/2.0-parseInt(i))*(size+10)));
            zi.setColor(cc.color(255,255,255,255));
        }

        if(ignore){
            var tip=new cc.LabelTTF("点击任意位置继续","Atlas",25);
            ret.addChild(tip);
            tip.setColor(cc.color(255,255,0,255));
            tip.setPosition(cc.p(180,-150));
        }

        return ret;
    },

    CSVToArray:function (strData,strDelimiter) {
        strDelimiter = (strDelimiter || ",");

        var objPattern = new RegExp(
            (
                "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
                "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
                "([^\"\\" + strDelimiter + "\\r\\n]*))"
            ), "gi"
        );

        var arrData = [[]];
        var arrMatches = null;
        while (arrMatches = objPattern.exec( strData )){
            var strMatchedDelimiter = arrMatches[ 1 ];
            if (
                strMatchedDelimiter.length &&
                (strMatchedDelimiter != strDelimiter)
            ){
                arrData.push( [] );
            }
            if (arrMatches[ 2 ]){
                var strMatchedValue = arrMatches[ 2 ].replace(
                    new RegExp( "\"\"", "g" ),
                    "\""
                );
            } else {
                var strMatchedValue = arrMatches[ 3 ];
            }
            arrData[ arrData.length - 1 ].push( strMatchedValue );
        }

        return arrData;
    },

    StringToArray:function (str) {
        var strvec=[];
        var signerstr="";
        for(var i in str)
        {
            var ch=str[i];
            if(ch==','||ch=='}')
            {
                strvec.push(parseInt(signerstr));
                signerstr="";
            }
            else if(ch!='"'&&ch!='{')
            {
                signerstr+=ch;
            }
        }
        if(signerstr.length>0){
            strvec.push(parseInt(signerstr));
            signerstr="";
        }
        return strvec;
    },

    //数组查找
    posIndexOf:function (vec,pt) {
        for(var i in vec){
            if(vec[i].x==pt.x&&vec[i].y==pt.y)
                return i;
        }
        return -1;
    },

    //头像剪切
    headImageCut:function (pic,di,width,height) {
        if(!height)
            height=width;

        var image=new ccui.ImageView(pic);
        image.setScaleX(width*1.0/image.getContentSize().width);
        image.setScaleY(width*1.0/image.getContentSize().height);

        var disp=new cc.Sprite(di);
        var clip=new cc.ClippingNode(disp);
        clip.setAlphaThreshold(0.05);
        clip.addChild(image,1,111);
        return clip;
    },

    //方块爆炸粒子
    addFkLizi:function (lay,pos,idx,scale,type) {
        if(!type)
            type=1;
        if(!scale)
            scale=1.0;

        var spname=chesspng[idx];
        if(type==2){
            if(idx==5)
                spname=starpng[20];
            else
                spname=starpng[19];
        }
        for(var i=0;i<15;i++){
            var sp=new cc.Sprite(spname);
            lay.addChild(sp,11);
            sp.setPosition(pos);

            if(type==2){
                if(idx<5)
                    sp.setColor(parColor[idx]);
            }else{
                sp.setScale(0.05+wb.randNum(0,2)/10);
            }

            var theta=wb.randNum(0,360);

            var len=wb.randNum(100,400);
            var time=wb.randNum(15,30)/40.0;
            var endpos=cc.p(pos.x+len*Math.cos(theta),pos.y+len*Math.sin(theta));
            sp.runAction(new cc.Sequence(new cc.moveTo(time,endpos),new cc.CallFunc(function (target) {
                target.removeFromParent();
            },this)));
          //  sp.runAction(new cc.moveBy(time,cc.p(0,-wb.randNum(20,30))));
            sp.runAction(new cc.RotateBy(time,wb.randNum(0,360)-180));
        }
        // var dpar=new cc.ParticleSystem(chesslizi[5]);
        // lay.addChild(dpar,11);
        // dpar.setScale(scale);
        // dpar.setPosition(pos);
        // dpar.setAutoRemoveOnFinish(true);
    },

    //获取当前年月日
    getRecentDate:function () {

        var tt=wb.getDate();
        cc.log("recent time:"+tt);

        var myear=0;
        var mmonth=0;
        var mday=0;
        if(tt.length==8){
            for(var i=0;i<4;i++){
                myear+=parseInt(tt[i])*Math.pow(10,(3-i));
            }
            for(var i=4;i<6;i++){
                mmonth+=parseInt(tt[i])*Math.pow(10,(5-i));
            }
            for(var i=6;i<8;i++){
                mday+=parseInt(tt[i])*Math.pow(10,(7-i));
            }
        }
        cc.log("time: year:"+myear+" monty:"+mmonth+" day:"+mday);
        return {year:myear,month:mmonth,day:mday};
    },

    //获取本月天数
    getMonthDay:function (year,month) {
        var da=new Date(year+1990,month,0);
        var daycout=da.getDate();
        return daycout;
    },

    //获取本地时间（单位：天）
    getHistoryDay:function () {
        return parseInt((wb.getLocalTime())/(3600*24));
    },

    //礼包是否存在
    isGiftExist:function (id) {
        var type=wb.PayManager.getDefaultPayType();
        if(type){
            var info=wb.PayManager.getDefaultFeeInfo();
            if(info){
                var dd=info.getFeeItems();
                for(var i in dd){
                    if(dd[i].getID()==id)
                        return true;
                }
            }
        }
        return false;
    },

    //点击事件统计
    clickUm:function(id,keyvalue){
        wb.JDataTJManager.event2(id,keyvalue);
    },

    playVideo:function (str) {
        if(wb.getSoundEnable()){
            cc.audioEngine.playEffect(str);
        }
    },

    playMusic:function (str,bo) {
        if(wb.getMusicEnable()){
            cc.audioEngine.playMusic(str,bo);
        }
    },

    pauseMusic:function(){
        if(wb.getMusicEnable()){
            cc.audioEngine.pauseMusic();
        }
    },

    resumeMusic:function(){
        if(wb.getMusicEnable()){
            cc.audioEngine.resumeMusic();
        }
    },

    getBoolForKey:function (index,defaultkey) {
        return wb.GCUserDefault.getBoolForKey(index,defaultkey);
        // var res=cc.sys.localStorage.getItem(index);
        // if(!res||res=="NAN")
        //     return defaultkey;
        // else{
        //     if(res=="true")
        //         return true;
        //     else
        //         return false;
        // }
    },

    setBoolForKey:function (index,key) {
        wb.GCUserDefault.setBoolForKey(index,key);
        wb.GCUserDefault.save();
        // if(key)
        //     cc.sys.localStorage.setItem(index,"true");
        // else
        //     cc.sys.localStorage.setItem(index,"fault");
    },


    setIntegerForKey:function (index,key) {
     //   cc.sys.localStorage.setItem(index,key.toString());
        wb.GCUserDefault.setIntegerForKey(index,key);
        wb.GCUserDefault.save();
    },

    getIntegerForKey:function (index,defaultkey) {
        return wb.GCUserDefault.getIntegerForKey(index,defaultkey);
        // var key=cc.sys.localStorage.getItem(index);
        // if(!key||res=="NAN")
        //     return defaulekey;
        // else
        //     return parseInt(key);
    },

    setStringForKey:function (index,key) {
        wb.GCUserDefault.setStringForKey(index,key);
        wb.GCUserDefault.save();
    },

    getStringForKey:function (index,defaultkey) {
        return wb.GCUserDefault.getStringForKey(index,defaultkey);
    }
});

ELSGameTool._instance=null;
ELSGameTool.getInstance=function () {
    if(!ELSGameTool._instance){
        ELSGameTool._instance=new ELSGameTool();
    }
    return ELSGameTool._instance;
};